// ********************************************************************
//
//  Routine:	alca/actaxxCommOTR.C
//  Author:		Dirk Kruecker
//
//  Description:	OTR-specific kuip commands for TAXX
//
//  Modifications:
//   -- creation					08/11/00 DK
//   -- remake + add ARTE_mark				14/12/00 DG
//
// ********************************************************************

#include <iostream.h>
#include "arte/arte.hh"
#include "farm/farm.hh"

#include "alca/actaxxComm.hh"
struct TACommOTR taCommOTR =
{
	1, 			/* nMC */
	15,			/* nPC */
	5,			/* nTC */

	1.,			/* xcut */
	2.,			/* xexc */

	20.,			/* zcut */
	4.,			/* pcut */

	10.,			/* chi2_neighbour */

	0,			/* userefit */

	TACommOTR::OtrI_gd	/* flg */
};





extern "C"  {
    int   ku_npar();   // return the number of parameters 
    int   ku_geti();   // read an integer
    double ku_getr();  // read a float
    char* ku_gets();   // read a string
    char* ku_getc();   // read an uppercase string
    char* ku_getf();   // read a filename
    char* ku_getl();   // read a comma separated list
} 


extern "C" void kugeti_(int*);
extern "C" void kugetr_(float*);





extern "C" void actaxxotrcuts_(){
  ARTE_mark( "actaxxotrcuts_ 0", GRR_OK );

  int i;
  kugeti_(&i);
  if(i!=-999) taCommOTR.nMC		= i;

  kugeti_(&i);
  if(i!=-999) taCommOTR.nPC		= i;

  kugeti_(&i);
  if(i!=-999) taCommOTR.nTC		= i;

  float x;
  kugetr_(&x);
  if(x!=-999) taCommOTR.xcut		= x;

  kugetr_(&x);
  if(x!=-999) taCommOTR.xexc		= x;

  kugetr_(&x);
  if(x!=-999) taCommOTR.zcut		= x;

  kugetr_(&x);
  if(x!=-999) taCommOTR.pcut		= x;

  kugetr_(&x);
  if(x!=-999) taCommOTR.chi2_neighbour	= x;

  char * str=ku_getc();
  if ( str[0] != ' ' ) taCommOTR.userefit  = (str[0] == 'Y') ? 1 : 0;
  
  ARTE_mark( "actaxxotrcuts_ 1", GRR_OK );
}





extern "C" void actaxxotropt_()
{
	ARTE_mark( "actaxxotropt_ 0", GRR_OK );

	char * str=ku_getc();
	if ( str[0] != ' ' ) taCommOTR.flg &= (~TACommOTR::OtrI_st);		// Clear bit
	taCommOTR.flg |= ((str[0] == 'Y') ? ~0 : 0) & TACommOTR::OtrI_st;

	// If not use space-consuming gede pointer, then use OtrI
	str=ku_getc();
	if ( str[0] != ' ' ) taCommOTR.flg &= (~TACommOTR::OtrI_gd);		// Clear bit
	taCommOTR.flg |= ((str[0] == 'N') ? ~0 : 0) & TACommOTR::OtrI_gd;

	ARTE_mark( "actaxxotropt_ 1", GRR_OK );
}
