
#ifndef _AC_ECAL_IFARM_H_
#define _AC_ECAL_IFARM_H_

/* ******************************************************************
 *
 * author: I. Matchikhilian, S. Shuvalov
 *
 * changes:
 * 18 May 2000 (AG) creation on request of S. Shuvalov
 *
 * **************************************************************** */

/* standard includes */
#include <stdio.h>
#include <math.h>
#include <string.h>

#include <sys/types.h>
#include <sys/stat.h> 
#include <errno.h> 
#include <unistd.h>
#include <sys/utsname.h>

/* ONLINE includes */
#include "rhp.h"
#include "component.h"

/* ARTE includes */
#include "arte/RSEG_cmp.hh"
#include "arte/arte.hh"
#include "farm/farm.hh"
#include "dq/DQ.h"
#include "alca/AC_ecal_idefines.h"


/***

    Definitions:

***/

#define ECAL_ihists_hostname_prefix_default "hb4lt"

struct ECAL_ihists_THINGS_TO_KNOW {
	  
  /* Physics: */

  float                                      ECAL_ihists_et_cut;
  float                                      ECAL_ihists_ptrack_cut;
  float                                      ECAL_ihists_pttrack_cut;
  float                                      ECAL_ihists_ptrack_low;
  float                                      ECAL_ihists_pmip_cut;
  float                                      ECAL_ihists_a_ell;
  float                                      ECAL_ihists_ncells_betw_2cl;
  float                                      ECAL_ihists_ncells_betw_tr_cl;
  float                                      ECAL_ihists_isol_cut;
  float                                      ECAL_ihists_ztrack_cut;
  float                                      ECAL_ihists_xmid_cut;

  /* Geometry: */

  
  float                                      ECAL_ihists_xmin;
  float                                      ECAL_ihists_ymin;
  float                                      ECAL_ihists_xcell;
  float                                      ECAL_ihists_ycell;
  float                                      ECAL_ihists_zcal;

  /* Histogramms: */

  float                                      ECAL_ihists_EPlow;
  float                                      ECAL_ihists_EPup;
  float                                      ECAL_ihists_MIPlow;
  float                                      ECAL_ihists_MIPup;
  int                                        ECAL_ihists_EP_NTUPLE_ID;
  int                                        ECAL_ihists_MIP_NTUPLE_ID;

  /* Other: */

  char                                       ECAL_ihists_hostname_prefix[20];
  int                                        ECAL_ihists_do;
  
};                             


/*** 
     
     Function prototypes:

***/


/* 1. Should be called once at the begin: */


void AC_ECAL_ihists_initialize(); 


/* 2. Should be called once per each event: */


void AC_ECAL_ihists_event();

/***

    Internal:
    
***/

	 
int ECAL_ihists_get_neigb(float,
			  float,
			  int*,
			  int*,
			  int*);


                       
#endif /*_DQ_ECAL_IHISTS_H_*/
