*-- Author :    Hartwig Albrecht   23/05/95

      SUBROUTINE DDATTF

************************************************************************
*
* Description: make Fortran sequences from the DATT command
*
* Called from: DDEXEC
*
* External references:
*
* Arguments: none
*
************************************************************************

      IMPLICIT NONE

#include "arte/Arte.fi"
#include "arte/ZDDCOM.fi"
#include "auto/DDEF.fi"
#include "arte/ZDDEFP.fi"

      INTEGER K1, K2, IFF, L, NN, LENOCC
      CHARACTER CN*80, CA*80, CC*200

#include "arte/Arte.ff"
#include "auto/DDEF.ff"

      CALL CHCTOH ('F', IFF, 1)

      DO 200 K1 = 1, NDDUSR

        IF (IDDEF_FLAG(K1) .NE. LDDEF_TAB)  GO TO 200

C patch/deck for Fortran declarations and parameters

        CALL CHHTOC (IQ(HQDDEF_NAME(1,K1)), CN)
        CALL DDOPEN (CN, 'fi')
        CC(3:)  = CN

C type declaration: integer

        CALL DDFSTM ('INTEGER')

C type declaration: # of columns/row: Ntabl

        CC(1:2) = ' N'
        CALL DDFEXT (CC(2:))
        CALL DDFEXT (',')
        CC(1:2) = 'NC'
        CALL DDFEXT (CC)

        CALL CHAPPC (CC, '_')
        L = LENOCC (CC) + 1

        DO 20 K2 = K1 + 1, NDDEF()
          IF (IDDEF_FLAG(K2) .GE. LDDEF_INI .AND.
     +        IDDEF_FLAG(K2) .LE. LDDEF_NAM)  GO TO 30
          IF (IDDEF_FLAG(K2) .GE. LDDEF_ATT .AND.
     +        IDDEF_FLAG(K2) .LE. LDDEF_INM)  THEN

C type declaration for parameters Jtabl_att

            CC(2:2) = 'J'
            CC(L:) = ' '
            CALL CHHTOC (IQ(HQDDEF_NAME(1,K2)), CA)
            CALL CHAPPC (CC, CA)
            CALL DDFEXT (',')
            CALL DDFEXT (CC(2:))

          END IF

          IF (IDDEF_FLAG(K2) .EQ. LDDEF_ATT)  THEN
            IF (IDDEF_DIM(K2) .NE. 0)  THEN

C type declarations for dimensions Ntabl_att

              CC(2:2) = 'N'
              CALL DDFEXT (',')
              CALL DDFEXT (CC(2:))
            END IF

C type declarations for statement functions

            IF (HDDEF_NAM2(1,K2) .NE. IFF)  THEN

              CALL CHHTOC (IQ(HQDDEF_NAM2(1,K2)), CC(2:2))
              IF (CC(2:2) .EQ. 'C')  CC(2:2) = 'H'
              IF (CC(2:2) .EQ. 'U')  CC(2:2) = 'B'
              IF (CC(2:2) .EQ. 'S')  CC(2:2) = 'I'
              CALL DDFEXT (',')
              CALL DDFEXT (CC(2:))

              CC(1:1) = CC(2:2)
              CC(2:2) = 'Q'
              CALL DDFEXT (',')
              CALL DDFEXT (CC)

              CALL CHAPPC (CC, '_L')
              CALL DDFEXT (',')
              CALL DDFEXT (CC)

            ELSE

              CC(2:2) = 'Q'
              CALL DDFEXT (',')
              CALL DDFEXT (CC(2:))

              CALL CHAPPC (CC, '_L')
              CALL DDFEXT (',')
              CALL DDFEXT (CC(2:))

            END IF

          ELSE IF (IDDEF_FLAG(K2) .EQ. LDDEF_POI)  THEN

            CC(2:2) = 'I'
            CALL DDFEXT (',')
            CALL DDFEXT (CC(2:))

            CC(1:2) = 'IQ'
            CALL DDFEXT (',')
            CALL DDFEXT (CC)

            CALL CHAPPC (CC, '_L')
            CALL DDFEXT (',')
            CALL DDFEXT (CC)

          ELSE IF (IDDEF_FLAG(K2) .EQ. LDDEF_RE1 .OR.
     +             IDDEF_FLAG(K2) .EQ. LDDEF_IN1)  THEN

            CC(2:2) = 'O'
            CALL DDFEXT (',')
            CALL DDFEXT (CC(2:))

          ELSE IF (IDDEF_FLAG(K2) .EQ. LDDEF_REM .OR.
     +             IDDEF_FLAG(K2) .EQ. LDDEF_INM)  THEN

            CC(2:2) = 'P'
            CALL DDFEXT (',')
            CALL DDFEXT (CC(2:))
            CC(2:2) = 'M'
            CALL DDFEXT (',')
            CALL DDFEXT (CC(2:))
            CC(2:2) = 'X'
            CALL DDFEXT (',')
            CALL DDFEXT (CC(2:))

          END IF

 20     CONTINUE

 30     CALL DDFOUT

C type declaration REAL

        CC(2:2) = 'F'
        NN = 0
        DO 40 K2 = K1 + 1, NDDEF()
          IF (IDDEF_FLAG(K2) .GE. LDDEF_INI .AND.
     +       IDDEF_FLAG(K2) .LE. LDDEF_MEN)  GO TO 50
          IF (IDDEF_FLAG(K2) .NE. LDDEF_ATT)  GO TO 40
          IF (HDDEF_NAM2(1,K2) .NE. IFF)  GO TO 40

          IF (NN .EQ. 0)  THEN
            CALL DDFSTM ('REAL')
          ELSE
            CALL DDFEXT (',')
          END IF
          NN = NN + 1

          CALL CHHTOC (IQ(HQDDEF_NAME(1,K2)), CA)
          CC(L:) = ' '
          CALL CHAPPC (CC, CA)
          CALL DDFEXT (CC(2:))

 40     CONTINUE
 50     CALL DDFOUT

C Fortran PARAMETER statement

        NN = 0
        DO 60 K2 = K1 + 1, NDDEF()
          IF (IDDEF_FLAG(K2) .GE. LDDEF_INI .AND.
     +        IDDEF_FLAG(K2) .LE. LDDEF_MEN)  GO TO 70
          IF (IDDEF_FLAG(K2) .LT. LDDEF_ATT .OR.
     +        IDDEF_FLAG(K2) .GT. LDDEF_INM)  GO TO 60

          IF (NN .EQ. 0)  THEN
            CALL DDFSTM ('PARAMETER(')
          ELSE
            CALL DDFEXT (',')
          END IF
          NN = NN + 1

C position Jtabl_attr=...

          CC(2:2) = 'J'
          CC(L:) = ' '
          CALL CHHTOC (IQ(HQDDEF_NAME(1,K2)), CA)
          CALL CHAPPC (CC, CA)
          CALL CHAPPC (CC, '=')
          CALL CHAPPI (CC, IDDEF_COL(K2))
          CALL DDFEXT (CC(2:))

          IF (IDDEF_DIM(K2) .NE. 0 .AND.
     +        IDDEF_FLAG(K2) .EQ. LDDEF_ATT)  THEN

C dimension Ntabl_att=...

            CC(2:2) = 'N'
            CC(L:) = ' '
            CALL CHHTOC (IQ(HQDDEF_NAME(1,K2)), CA)
            CALL CHAPPC (CC, CA)
            CALL CHAPPC (CC, '=')
            CALL CHAPPI (CC, IDDEF_DIM(K2))
            CALL DDFEXT (',')
            CALL DDFEXT (CC(2:))
          END IF

 60     CONTINUE
 70     IF (NN .NE. 0)  THEN
          CALL DDFEXT (' )')
          CALL DDFOUT
        END IF

C patch/deck for Fortran statement functions

        
        CC(L-1:) = ' '
        CALL DDOPEN (CC(3:L-2), 'ff')

C number of columns / row

        CC(1:2) = ' N'
        CALL CHAPPC (CC, '() = N_U(J')
        CALL CHAPPC (CC, CN)
        CALL CHAPPC (CC, ')')
        CALL DDFSTM (CC)
        CALL DDFOUT

        CC(1:2) = 'NC'
        CC(L+6:L+6) = 'C'
        CALL DDFSTM (CC)
        CALL DDFOUT

        DO 100 K2 = K1 + 1, NDDEF()
          IF (IDDEF_FLAG(K2) .GE. LDDEF_INI .AND.
     +        IDDEF_FLAG(K2) .LE. LDDEF_MEN)  GO TO 110
          IF (IDDEF_FLAG(K2) .GT. LDDEF_INM)  GO TO 100

          CC(L-1:) = '_'
          CALL CHHTOC (IQ(HQDDEF_NAME(1,K2)), CA)
          CALL CHAPPC (CC, CA)

          IF (IDDEF_FLAG(K2) .NE. LDDEF_ATT .AND.
     +        IDDEF_FLAG(K2) .NE. LDDEF_POI)  GO TO 80

C addresses

          CC(2:2) = 'Q'
          CALL CHHTOC (IQ(HQDDEF_NAM2(1,K2)), CC(1:1))
          IF (CC(1:1) .EQ. 'C')  CC(1:1) = 'H'
          IF (CC(1:1) .EQ. 'U')  CC(1:1) = 'B'
          IF (CC(1:1) .EQ. 'S')  CC(1:1) = 'I'
          IF (CC(1:1) .EQ. 'F')  CC(1:1) = ' '
          IF (IDDEF_FLAG(K2) .EQ. LDDEF_POI)  CC(1:1) = 'I'

C any row: IQtabl_att(...

          CALL CHAPPC (CC, '(')
          IF (IDDEF_DIM(K2) .NE. 0)  CALL CHAPPC (CC, 'I_W,')
          CALL CHAPPC (CC, 'I_R)')
          CALL CHAPBC (CC, '= L_A(J')
          CALL CHAPPC (CC, CN)
          CALL CHAPPC (CC, '_')
          CALL CHAPPC (CC, CA)
          IF (IDDEF_DIM(K2) .NE. 0)  CALL CHAPPC (CC, '-1+I_W')
          CALL CHAPPC (CC, ',I_R,J')
          CALL CHAPPC (CC, CN)
          CALL CHAPPC (CC, ')')
          CALL DDFSTM (CC)
          CALL DDFOUT

C last row: IQtabl_att_L()

          CC(L:) = ' '
          CALL CHAPPC (CC, CA)
          CALL CHAPPC (CC, '_L(')
          IF (IDDEF_DIM(K2) .NE. 0)  CALL CHAPPC (CC, 'I_W')
          CALL CHAPPC (CC, ')')
          CALL CHAPBC (CC, '= L_L(J')
          CALL CHAPPC (CC, CN)
          CALL CHAPPC (CC, '_')
          CALL CHAPPC (CC, CA)
          IF (IDDEF_DIM(K2) .NE. 0)  CALL CHAPPC (CC, '-1+I_W')
          CALL CHAPPC (CC, ',J')
          CALL CHAPPC (CC, CN)
          CALL CHAPPC (CC, ')')
          CALL DDFSTM (CC)
          CALL DDFOUT

C statement functions for values

          CC(2:2) = CC(1:1)
          IF (CC(2:2) .EQ. ' ')  CC(2:2) = 'F'
          CC(1:1) = ' '
          CC(L:) = ' '
          CALL CHAPPC (CC, CA)
          CALL CHAPPC (CC, '(')
          IF (IDDEF_DIM(K2) .NE. 0)  CALL CHAPPC (CC, 'I_W,')
          CALL CHAPPC (CC, 'I_R')
          CALL CHAPPC (CC, ')')
          IF (CC(2:2) .EQ. 'F')  THEN
            CALL CHAPBC (CC, '= Q(Q')
          ELSE
            CALL CHAPBC (CC, '= IQ(')
            CALL CHAPPC (CC, CC(2:2))
            CALL CHAPPC (CC, 'Q')
          END IF
          CALL CHAPPC (CC, CN)
          CALL CHAPPC (CC, '_')
          CALL CHAPPC (CC, CA)
          CALL CHAPPC (CC, '(')
          IF (IDDEF_DIM(K2) .NE. 0)  CALL CHAPPC (CC, 'I_W,')
          CALL CHAPPC (CC, 'I_R')
          CALL CHAPPC (CC, '))')
          CALL DDFSTM (CC)
          CALL DDFOUT

          GO TO 100

C statement functions for relations

 80       IF (IDDEF_FLAG(K2) .LT. LDDEF_RE1)  GO TO 100

          CC(1:2) = ' O'
          CC(L:) = ' '
          IF (IDDEF_FLAG(K2) .EQ. LDDEF_REM .OR.
     +        IDDEF_FLAG(K2) .EQ. LDDEF_INM)  CC(2:2) = 'P'

          CALL CHAPPC (CC, CA)
          CALL CHAPPC (CC, '(I_R) = I_V(J')
          CALL CHAPPC (CC, CN)
          CALL CHAPPC (CC, '_')
          CALL CHAPPC (CC, CA)
          CALL CHAPPC (CC, ',I_R,J')
          CALL CHAPPC (CC, CN)
          CALL CHAPPC (CC, ')')
          CALL DDFSTM (CC)
          CALL DDFOUT

          IF (CC(2:2) .EQ. 'O')  GO TO 100

          CC(L:) = ' '
          CC(2:2) = 'X'
          CALL CHAPPC (CC, CA)
          CALL CHAPPC (CC, '(I_R) = X_')
          IF (IDDEF_FLAG(K2) .EQ. LDDEF_REM)  THEN
            CALL CHAPPC (CC, '1')
          ELSE IF (IDDEF_RFLG(K2) .EQ. 4)  THEN
            CALL CHAPPC (CC, '2')
          ELSE
            CALL CHAPPC (CC, 'R')
          END IF
          NN = LENOCC (CC) - 2
          CALL CHAPPC (CC, '(I_R,J')
          CALL CHHTOC (IQ(HQDDEF_NAM3(1,K2)), CA)
          CALL CHAPPC (CC, CA)
          CALL CHAPPC (CC, ')')
          CALL DDFSTM (CC)
          CALL DDFOUT

          CC(2:2) = 'M'
          CC(NN:NN) = 'M'
          CALL DDFSTM (CC)
          CALL DDFOUT

 100    CONTINUE

 110    CONTINUE

 200  CONTINUE

      END

************************************************************************
* End of DDATTF
************************************************************************
