//                              -*- Mode: C++ -*-
//:CareUtil.C
//
//
// Author: Mauro Villa   
// ECAL group 
// HERA-B experiment, Desy
// e-mail: villa@bo.infn.it
//
// Created 30/1/01
//
// Evaluate energy thresholds for cells

#include "arte/arte.hh"
#include "care/EMHitCell.hh"
#include "care/EMCluster.hh"

Energy_t EnergyThreshold(const EMHitCell * hitc){
  return ArtePointer<ECHS>((hitc->cellIdx()).index())->thrs;
}

/// return the cluster energy threshold
Energy_t EnergyThreshold(const EMCluster *cluster){
  Energy_t thresh = 0.0;
  const EMClusterMember* memb = cluster;
  while( memb!=0 && !memb->isALeaf() ){ memb =((EMCluster*) memb)->begin();}
  if( memb!=0 && memb->maxEnergy()>0.0){
    const EMHitCell* hitc = (EMHitCell*)memb;
    thresh = EnergyThreshold(hitc);
  }
  return thresh;
}

