#ifndef __CATS_HH
#define __CATS_HH

#ifdef __cplusplus
extern "C" {
#endif

#include "iol.h"
  
  void cats_param_init(void);
  void CatsEvent(void);
  void stop_cats(void);
  
  struct Cats_Iol_t {
    IOL_MNAME   module[IOL_MLEN];
    IOL_SIZE    size; 
    IOL_FLOAT   search_window   ;     /* search window around a track [cm]    */
    IOL_FLOAT   target_window   ;     /* radius of a target window [cm]       */
    IOL_INT     gede_plane_off  ;     /* plane to switch off                  */
    IOL_FLAG    draw_display    ;     /* draw event display                   */
  };
  typedef struct Cats_Iol_t Cats_Iol_t;
  extern  Cats_Iol_t cats_iol;
  
  const int vds_pattern[32] = {0x1,0x2,0x4,0x8,                              /* SL 1 */
			       0x10,0x20,0x40,0x80,                          /* SL 2 */
			       0x100,0x200,0x400,0x800,                      /* SL 3 */
			       0x1000,0x2000,0x4000,0x8000,                  /* SL 4 */
			       0x10000,0x20000,0x40000,0x80000,              /* SL 5 */
			       0x100000,0x200000,0x400000,0x800000,          /* SL 6 */
			       0x1000000,0x2000000,0x4000000,0x8000000,      /* SL 7 */
			       0x10000000,0x20000000,0x40000000,0x80000000}; /* SL 8 */

#ifdef __cplusplus
}
#endif

#endif

