// *****************************************************************************
//
// source:    daq_sparse_if.hh
//
// type:      header file
//
// created:   13 Mar 2001
//
// author:    Lars Soezueer
//            email: soezueer@mail.desy.de
//
// purpose:   intermediate class declaration for sparsified components
//
// changes:   
//
// *****************************************************************************
#ifndef _DAQ_SPARSE_IF_
#define _DAQ_SPARSE_IF_

#include "daqif/daq_mc_if.hh"

class DAQ_SPARSE_IF : public DAQ_MC_IF {

public:

  virtual unsigned int getFED_IDs(unsigned short *buf, unsigned int maxIDs) = 0;
  virtual int getFED(unsigned short fedid, FED_HDR *buf, unsigned int maxSize) = 0;

  int prepare(void); // status return

  void setSLBs(void); 

protected:

  DAQ_SPARSE_IF(int component_id = -1);

  virtual int prepareEvent(void) {return -1;} // returns 0 on success if FED_IDs are not going to change
  // returns 1 on success if FED_IDs have to be re-read for this event
  // returns negative integer on error

private:

};

#endif
