 
// *****************************************************************************
//
// source:    DQ_FLT_rec.C
//
// type:      source code
//
// created:   19 Dec 2000
//
// author:    Dr. Andreas Gellrich
//            HERA-B Collaboration
//            Humboldt-University Berlin
//            Physics Department
//            Invalidenstr. 110
//            10115 Berlin
//            Germany
//            email: Andreas.Gellrich@desy.de
//
// symbol:    DQ_FLT_rec_init
//            DQ_FLT_rec_evnt
//
// called by: DQ_init()
//            DQ_evnt()
//
// purpose:   Data Quality Monitoring using rhp
//
// hints:     use ARTE_error() to publish error messages
//            steered by /DQ/SUBD FLT rec ON
//
// changes:
// 19 Dec 2000 (AG) creation
//
// ******************************************************************

// standard includes
#include <iostream.h>
#include <stdlib.h>
#include <stdio.h>

// ONLINE includes
#include "rhp.h"

// Arte includes
#include "arte/arte.hh"
#include "farm/farm.hh"
#include "dq/DQ.h"
#include "dq/DQ_FLT.h"

// externals
extern int FADEB; // can be set by runargs=-debug in the kumac

//
// function code
//
int
DQ_FLT_rec_init()
{
  ARTE_mark( "DQ_FLT_rec_init", 0 );
  cout << "DQ_FLT_rec_init" << endl;

  //
  // here comes your code
  //
  int rc = 0;

  // example
  //unsigned int histogram_id1 = 1;     // 0x0     lowest
  //unsigned int histogram_id2 = 65535; // 0xfffff highes
  //int   nbinx = 100; // binning in x
  //int   nbiny = 100; // binning in y
  //float xmin  = 0;   // minimal x
  //float xmax  = 100; // maximal x
  //float ymin  = 0;   // minimal y
  //float ymax  = 100; // maximal y
  // print (online to grr)
  //ARTE_error( GRR_SFATAL, "I am dead!", 99 );
  // book 1-dim histograms
  //rhp_hbook1( DQ_ID( COMP_FLT, LVL_REC, histogram_id1 ),
  //            "FLT: test", nbinx, xmin, xmax );
  // book 2-dim histograms
  //rhp_hbook2( DQ_ID( COMP_FLT, LVL_REC, histogram_id2 ),
  //            "This is a test", nbinx, xmin, xmax, nbiny, ymin, ymax );

  //
  // return
  //
  ARTE_mark( "DQ_FLT_rec_init", 0 );
  return rc; // return error code (0 = okay)
}

//
// function code
//
int
DQ_FLT_rec_evnt()
{
  ARTE_mark( "DQ_FLT_rec_evnt 0", 0 );

  //
  // here comes your code
  //
  int rc = 0;

  // example
  //unsigned int histogram_id1 = 1;     // 0x0     lowest
  //unsigned int histogram_id2 = 65535; // 0xfffff highest
  //float x_value = 0; // containing the x-value to be histogrammed
  //float y_value = 0; // containing the y-value to be histogrammed
  // print (online to grr)
  //ARTE_error( GRR_SFATAL, "I am dead!", 99 );
  // 1-dim histogram
  //rhp_hf1( DQ_ID( COMP_FLT, LVL_REC, histogram_id1 ), x_value, 1 );
  // 2-dim histogfram
  //rhp_hfill( DQ_ID( COMP_FLT, LVL_REC, histogram_id2 ), x_value, y_value, 1 );

  //
  // return
  //
  ARTE_mark( "DQ_FLT_rec_evnt 1", 0 );
  return rc; // return error code (0 = okay)
}
