// ********************************************************************
//
//  Routine:      gageFillRhpOtrVds.C
//  Author:       T. Oest
//
//  Description: fill rhp histograms for global RICH alignment
//
//  Modification:
//
// ********************************************************************

#include <iostream.h>
#include <math.h>
#include <algo.h>
#include "rhp.h"
#include "dq/DQ.h"
#include "arte/arte.hh"
#include "gage/gage.hh"
#include "arte/RSEG_cmp.hh"

//*********************************************************************
// function
//*********************************************************************

int gageFillRhpOtrVds(){

//-----------------------------------------------------------------
//   OTR/VDS correlation
//-----------------------------------------------------------------

    float z0 = 160.;

    for( ArteTable<RSEG>::iterator rOTR = ArteTable<RSEG>::begin();
         rOTR != ArteTable<RSEG>::end(); ++rOTR ) {

      if ((*rOTR)->fit == 0 && ((*rOTR)->cmp & Rsegc::magt) &&
          (*rOTR)->zf < 450. && (*rOTR)->pf != 0.0 && 
          ((1./ fabs((*rOTR)->pf) > gagePCutsVdsOtr[4]) || 
           gagePCutsVdsOtr[4] == 0.0)){


       float p[6];
       float pTraced[6];
       p[0] = (*rOTR)->zf;
       p[1] = (*rOTR)->xf;
       p[2] = (*rOTR)->yf;
       p[3] = (*rOTR)->txf;
       p[4] = (*rOTR)->tyf;
       p[5] = (*rOTR)->pf;

       gageTraceTRACK(z0 , p, pTraced);


    for( ArteTable<RSEG>::iterator rVDS = ArteTable<RSEG>::begin();
         rVDS != ArteTable<RSEG>::end(); ++rVDS ) {

    if ((*rVDS)->fit == 0 && ((*rVDS)->cmp & Rsegc::vxd) ){



       float pVDSTraced[6];

       p[0] = (*rVDS)->zf;
       p[1] = (*rVDS)->xf;
       p[2] = (*rVDS)->yf;
       p[3] = (*rVDS)->txf;
       p[4] = (*rVDS)->tyf;
       p[5] = (*rOTR)->pf;

       gageTraceTRACK(z0 , p, pVDSTraced);

         float dx, dy, dtx, dty;
         dx  = pTraced[1] - pVDSTraced[1];
         dy  = pTraced[2] - pVDSTraced[2];
         dtx = pTraced[3] - pVDSTraced[3];
         dty = pTraced[4] - pVDSTraced[4];

	 if (fabs(dx)  <  gagePCutsVdsOtr[0] && 
             fabs(dy)  <  gagePCutsVdsOtr[1] &&
             fabs(dtx) <  gagePCutsVdsOtr[2] &&
             fabs(dty) <  gagePCutsVdsOtr[3]){

          rhp_hfill( AC_ID(COMP_CORR, LVL_REC, 100 ), dx, dy, 1 );
          rhp_hfill( AC_ID(COMP_CORR, LVL_REC, 101 ), dtx, dty, 1 );

          if ((*rOTR)->xf > 0.0){
           rhp_hfill( AC_ID(COMP_CORR, LVL_REC, 102 ), dx, dy, 1 );
           rhp_hfill( AC_ID(COMP_CORR, LVL_REC, 103 ), dtx, dty, 1 );
          } else {
           rhp_hfill( AC_ID(COMP_CORR, LVL_REC, 104 ), dx, dy, 1 );
           rhp_hfill( AC_ID(COMP_CORR, LVL_REC, 105 ), dtx, dty, 1 );
          };

         };

      };
    };
    };
    };
//------------------------------------------------------------------------------
//
//------------------------------------------------------------------------------
  return 0;
};
