// ********************************************************************
//
//  Routine:      kagageselect
//  Author:       T.Oest
//
//  Description:  select components to be written to rhp ring buffer
//
//
// ********************************************************************

#include <iostream.h>
#include <stdlib.h>
#include <stdio.h>
#include <string.h>
#include <ctype.h>
#include "arte/arte.hh"
#include "dq/DQ.h"
#include "gage/gage.hh"
#include "rhp.h"

int gagePlotsVdsEcalRich    = 0;
int gagePlotsRichEcal       = 0;
int gagePlotsOtrEcal        = 0;
int gagePlotsOtrRich        = 0;
int gagePlotsOtrVds         = 0;

int   gageSelectRichEcal    = 0;
int   gageSelectOtrRich     = 0;
int   gageSelectOtrEcal     = 0;
int   gageSelectVdsEcalRich = 0;
int   gageSelectVdsOtr      = 0;

float gageCutsRichEcal[5]   ;
float gageCutsOtrRich[5]   ;
float gageCutsOtrEcal[5]   ;
float gageCutsVdsEcalRich[5];
float gageCutsVdsOtr[5]     ;

float gagePCutsRichEcal[5]   ;
float gagePCutsOtrRich[5]   ;
float gagePCutsOtrEcal[5]   ;
float gagePCutsVdsEcalRich[5];
float gagePCutsVdsOtr[5]     ;

extern "C" void kugeti_(int*);
extern "C" void kugetr_(float*);
extern "C" void kugetc_( char*, int *, int );

extern "C" void kagageselect_() {   

//---------------------------------------------------------------
//   read in component to be aligned
//---------------------------------------------------------------

  int len;
  int len1 = 5;
  char input[9];
  kugetc_(input, &len, len1);
  input[len] = 0;

  char *Segment1;
  Segment1  = (char *) malloc(len+1);
  Segment1[len] = 0;

  if(len>0) for(int i=0; i<len; i++) Segment1[i] = toupper(input[i]);

//---------------------------------------------------------------
//   reference component
//---------------------------------------------------------------

  len1 = 5;
  kugetc_(input, &len, len1);
  input[len] = 0;

  char *Segment2;
  Segment2  = (char *) malloc(len+1);
  Segment2[len] = 0;

  if(len>0) for(int i=0; i<len; i++) Segment2[i] = toupper(input[i]);

//---------------------------------------------------------------
//   read cuts
//---------------------------------------------------------------

  float dx, dy, dtx, dty, pmin;

  kugetr_(&dx);
  kugetr_(&dy);
  kugetr_(&dtx);
  kugetr_(&dty);
  kugetr_(&pmin);

//---------------------------------------------------------------
//   option
//---------------------------------------------------------------

  len1 = 5;
  kugetc_(input, &len, len1);
  input[len] = 0;

  char *Option;
  Option  = (char *) malloc(len+1);
  Option[len] = 0;

  if(len>0) for(int i=0; i<len; i++) Option[i] = toupper(input[i]);

//---------------------------------------------------------------
//   number of bins
//---------------------------------------------------------------
    int nbins;

  kugeti_(&nbins);

  if (nbins < 0) nbins = 100;

//---------------------------------------------------------------
//   set gage status
//---------------------------------------------------------------


  if ( !strncmp(Segment1,"VDS"   ,3)  &&
      (!strncmp(Segment2,"ECALR" ,5)||!strncmp(Segment2,"RICHE" ,5))){

    if (!strncmp(Option,"PLOT"   ,4)){

       gagePlotsVdsEcalRich    = 1;
       gagePCutsVdsEcalRich[0] = dx;
       gagePCutsVdsEcalRich[1] = dy;
       gagePCutsVdsEcalRich[2] = dtx;
       gagePCutsVdsEcalRich[3] = dty;
       gagePCutsVdsEcalRich[4] = pmin;

       rhp_hbook2( AC_ID( COMP_CORR, LVL_REC, 106 ), 
                  "GAGE: VDS/ECALRICH: delta x vs delta y", 
                   nbins, -dx, dx, nbins, -dy, dy );

       rhp_hbook2( AC_ID( COMP_CORR, LVL_REC, 107 ), 
                  "GAGE: VDS/ECALRICH: delta tanx vs delta tany", 
                   nbins, -dtx, dtx, nbins, -dty, dty );

    } else {
       gageSelectVdsEcalRich  = 1;
       gageCutsVdsEcalRich[0] = dx;
       gageCutsVdsEcalRich[1] = dy;
       gageCutsVdsEcalRich[2] = dtx;
       gageCutsVdsEcalRich[3] = dty;
       gageCutsVdsEcalRich[4] = pmin;
    };
  };

  if (!strncmp(Segment1,"RICH" ,4) && !strncmp(Segment2,"ECAL" ,4)){

    if (!strncmp(Option,"PLOT"   ,4))

       gagePlotsRichEcal    = 1;
       gagePCutsRichEcal[0] = dx;
       gagePCutsRichEcal[1] = dy;
       gagePCutsRichEcal[2] = dtx;
       gagePCutsRichEcal[3] = dty;
       gagePCutsRichEcal[4] = pmin;

       rhp_hbook2( AC_ID( COMP_CORR, LVL_REC, 110 ), 
                  "GAGE: ECAL/RICH: delta tanx vs delta tany", 
                   nbins, -dtx, dtx, nbins, -dty, dty );

  };

  if (!strncmp(Segment1,"OTR" ,3) && !strncmp(Segment2,"ECAL" ,4)){

    if (!strncmp(Option,"PLOT"   ,4)) {

       gagePlotsOtrEcal    = 1;
       gagePCutsOtrEcal[0] = dx;
       gagePCutsOtrEcal[1] = dy;
       gagePCutsOtrEcal[2] = dtx;
       gagePCutsOtrEcal[3] = dty;
       gagePCutsOtrEcal[4] = pmin;

       rhp_hbook2( AC_ID( COMP_CORR, LVL_REC, 120 ), 
                   "GAGE: OTR/ECAL: delta x vs delta y", 
                   nbins, -dx, dx, nbins, -dy, dy );

       rhp_hbook2( AC_ID( COMP_CORR, LVL_REC, 121 ), 
                   "GAGE: OTR/ECAL +x: delta x vs delta y", 
                   nbins, -dx, dx, nbins, -dy, dy );

       rhp_hbook2( AC_ID( COMP_CORR, LVL_REC, 122 ), 
                   "GAGE: OTR/ECAL -x: delta x vs delta y", 
                   nbins, -dx, dx, nbins, -dy, dy );

    } else {
       gageSelectOtrEcal  = 1;
       gageCutsOtrEcal[0] = dx;
       gageCutsOtrEcal[1] = dy;
       gageCutsOtrEcal[2] = dtx;
       gageCutsOtrEcal[3] = dty;
       gageCutsOtrEcal[4] = pmin;
    };

  };

  if (!strncmp(Segment1,"OTR" ,3) && !strncmp(Segment2,"RICH" ,4)){

    if (!strncmp(Option,"PLOT"   ,4)){

       gagePlotsOtrRich    = 1;
       gagePCutsOtrRich[0] = dx;
       gagePCutsOtrRich[1] = dy;
       gagePCutsOtrRich[2] = dtx;
       gagePCutsOtrRich[3] = dty;
       gagePCutsOtrRich[4] = pmin;

       rhp_hbook2( AC_ID( COMP_CORR, LVL_REC, 111 ), 
                   "GAGE: OTR/RICH: delta tanx vs delta tany", 
                    nbins, -dtx, dtx, nbins, -dty, dty );

       rhp_hbook2( AC_ID( COMP_CORR, LVL_REC, 112 ), 
                   "GAGE: OTR/RICH +x: delta tanx vs delta tany", 
                    nbins, -dtx, dtx, nbins, -dty, dty );

       rhp_hbook2( AC_ID( COMP_CORR, LVL_REC, 113 ), 
                   "GAGE: OTR/RICH -x: delta tanx vs delta tany", 
                    nbins, -dtx, dtx, nbins, -dty, dty );

    } else {
       gageSelectOtrRich  = 1;
       gageCutsOtrRich[0] = dx;
       gageCutsOtrRich[1] = dy;
       gageCutsOtrRich[2] = dtx;
       gageCutsOtrRich[3] = dty;
       gageCutsOtrRich[4] = pmin;

    };
  };

  if (!strncmp(Segment1,"VDS"  ,3) && !strncmp(Segment2,"OTR" ,3)){

    if (!strncmp(Option,"PLOT"   ,4)){
       gagePlotsOtrVds    = 1;
       gagePCutsVdsOtr[0] = dx;
       gagePCutsVdsOtr[1] = dy;
       gagePCutsVdsOtr[2] = dtx;
       gagePCutsVdsOtr[3] = dty;
       gagePCutsVdsOtr[4] = pmin;

       rhp_hbook2( AC_ID( COMP_CORR, LVL_REC, 100 ), 
                   "GAGE: OTR/VDS: delta x vs delta y", 
                   nbins, -dx, dx, nbins, -dy, dy );

       rhp_hbook2( AC_ID( COMP_CORR, LVL_REC, 101 ), 
                   "GAGE: OTR/VDS: delta tan x vs delta tan y", 
                   nbins, -dtx, dtx, nbins, -dty, dty );

       rhp_hbook2( AC_ID( COMP_CORR, LVL_REC, 102 ), 
                   "GAGE: OTR/VDS +x: delta x vs delta y", 
                   nbins, -dx, dx, nbins, -dy, dy );

       rhp_hbook2( AC_ID( COMP_CORR, LVL_REC, 103 ), 
                   "GAGE: OTR/VDS +x: delta tan x vs delta tan y", 
                   nbins, -dtx, dtx, nbins, -dty, dty );

       rhp_hbook2( AC_ID( COMP_CORR, LVL_REC, 104 ), 
                   "GAGE: OTR/VDS -x: delta x vs delta y", 
                   nbins, -dx, dx, nbins, -dy, dy );

       rhp_hbook2( AC_ID( COMP_CORR, LVL_REC, 105 ), 
                   "GAGE: OTR/VDS -x: delta tan x vs delta tan y", 
                   nbins, -dtx, dtx, nbins, -dty, dty );

    } else {
       gageSelectVdsOtr  = 1;

       gageCutsVdsOtr[0] = dx;
       gageCutsVdsOtr[1] = dy;
       gageCutsVdsOtr[2] = dtx;
       gageCutsVdsOtr[3] = dty;
       gageCutsVdsOtr[4] = pmin;
    };

  };

};
