#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <ctype.h>
#include <iostream.h>
#include <math.h>
#include "gean/hgdat.h"
#include "gean/zgvers.hh"
#include "gean/ZGESL.h"
#include "arte/arte.hh"
#include "arte/ArteMessage.hh"

/*
    written by Siegmund Nowak
    This routine reads in the ASCII files with NESL informations and stores 
    them into the NESL-bank. It is called from GEOMAIN.
    The input parameter must be the ascii file name.
*/
// ------------------------------------------------------------------------
  FILE *NESL_input, *utfilp(const char*,const char*);
  struct NESL sl;

// ------------------------------------------------------------------------  
  extern "C" {void gesldat_(); }

// ------------------------------------------------------------------------  
  void gesldat_() {
  int isl[32]={0};
  char   buffer[256], name[32], tag[5];
  zgvers ZGVERS;

  strcpy(name,ZGVERS.Get_vers_datafile(LGESL_MOTH));         
  NESL_input = utfilp(name,""); 
  if(!NESL_input) { arteMsg << "Can not open " << name;  arteMsg.error(); }
  
  for(;;) {
     if(fgets(buffer,256,NESL_input) == NULL) {
        if(feof(NESL_input)) {  fclose(NESL_input);   break;}
        else continue;}
          
     char   *card=&buffer[0];
     int nitem=sscanf(card,"%s",tag);
     if (nitem!=1 || strstr(tag,"#")!=0) continue; 
     fillstr(tag,4);
     strcpy(sl.name,tag);
     card+=itemlength(card,nitem);
     nitem = sscanf(card,"%d",&sl.cmp);
     isl[sl.cmp-1]=isl[sl.cmp-1]+1;
     sl.nsl=isl[sl.cmp-1]; 

     card+=itemlength(card,nitem);
     nitem = sscanf(card,"%s",tag);
     fillstr(tag,4);
     if (!strncmp(tag,"BOX ",4))      sl.shp = 1;
     else if(!strncmp(tag,"TRD2",4))  sl.shp = 3;
     else if(!strncmp(tag,"TUBE",4))  sl.shp = 5;
     else                             sl.shp = 0; 

     card+=itemlength(card,nitem);
     nitem = sscanf(card,"%d %d %d %f %f %f %f %f %f", 
             &sl.lay, &sl.ltyp, &sl.mfl,
             &sl.x1, &sl.x2, &sl.y1, &sl.y2, &sl.z1, &sl.z2);

     if(sl.shp==3) {
        card+=itemlength(card,nitem);
        nitem = sscanf(card,"%f %f ",&sl.dx,&sl.dy); }        

     sl.fpl = 0;     sl.npl = 0;     sl.fwl = 0;     sl.nwl = 0;
     ArteTable<NESL>::push_back(sl);
  }
}


