
      SUBROUTINE HGINIT(ISTAT)
************************************************************************
*
* HGINIT
* written by Siegmund Nowak, 21/12/95 15.18.57
*
* This routines initialises HBGEAN in context of arte with three possibilities
* ISTAT = 1 - geometry installation
* ISTAT = 2 - geometry installation and geant tracing 
* ISTAT = 3 - geant tracing when geometry is read in 
* 
*       called from ATINIT
*
************************************************************************

      IMPLICIT NONE

#include "arte/Arte.fi"
#include "gean/gclink.fi"
#include "gean/gcflag.fi"
#include "gean/gcjloc.fi"
#include "gean/gctime.fi"
#include "gean/gcmzfo.fi"
#include "gean/gcscal.fi"
#include "gean/gcunit.fi"
      INTEGER NLOCAL,LOCAL,LOSTO,ISTAT
      COMMON/GCLOCA/NLOCAL(2),LOCAL(20)
      INTEGER IORUNG,I
#include "arte/Arte.ff"
      CALL GWORK(5200)
C
C                 Create a permanent link area for master pointers
C
      CALL MZLINK(IXSTOR,'/GCLINK/',JDIGI,JSKLT,JDIGI)
C
C                 Create a permanent link area for param. pointers
C
      CALL MZLINK(IXSTOR,'/GCSLNK/',LSCAN,LSLAST,LSCAN)
C
C                 Create temporary link areas
C
      CALL MZLINT(IXSTOR,'/GCLOCA/',NLOCAL,LOCAL(1),LOCAL(20))
      CALL MZLINT(IXSTOR,'/GCJLOC/',NJLOC ,JTM,JRANG)
      CALL MZLINT(IXSTOR,'/GCJLCK/',NJLCK ,JTCKOV,JTASHO)
C
C             Define IO descriptors of GEANT banks
C
      CALL MZFORM('MATE','5H -F'      ,IOMATE)
      CALL MZFORM('PART','5H -F'      ,IOPART)
      CALL MZFORM('TMED','5H -F'      ,IOTMED)
      CALL MZFORM('SEJD','10I / 1H 1I',IOSEJD)
      CALL MZFORM('SJDD','/ 1H 1I'    ,IOSJDD)
      CALL MZFORM('SJDH','/ 1H 1I 2F' ,IOSJDH)
      CALL MZFORM ('STAK', '3I / 3I 9F',IOSTAK)
      CALL MZFORM('RUNG','20I 8F 2I'   ,IORUNG)
C
C             Create RUN header bank
C
      CALL MZBOOK(IXCONS,JRUNG,JRUNG,1,'RUNG',1,1,30,IORUNG,0)
      IQ(JRUNG-5)=1
      IQ(JRUNG+1)=IDRUN
C
C             Fill header with default date,time,Geant and Zebra
C             version numbers for the 4 main GEANT data structures
C             INIT,KINE,HITS,DIGI
C
       DO 10 I=1,4
         IQ(JRUNG+2*I+ 9)=IGDATE
         IQ(JRUNG+2*I+10)=IGTIME
          Q(JRUNG+2*I+19)=GVERSN
          Q(JRUNG+2*I+20)=ZVERSN
  10  CONTINUE

C---  fill geant particle table

      IF(ISTAT.LE.2) THEN
         CALL GPART
         CALL GPIONS

C---  geometry and materials description
         CALL GEOMAIN
      ELSE
         CALL CRGEAN
      ENDIF 

C     Energy loss and cross-sections initialisations
      LOSTO = LOUT
      LOUT = LLOGF
      CALL GPHYSI
      LOUT = LOSTO

C---  fill Arte-table GMAT with de/dx
      CALL MEDCON
      IF(ISTAT.EQ.1)  CALL CRGEAN

C---  copy NEDE to GEDE and set MIM1-HITL (in case of immediate generation) 
      IF(ISTAT.EQ.2) CALL DGGEHD
  99  RETURN
      END

