#ifndef _ZGDET_HH_
#define _ZGDET_HH_
#include "gean/zgeom.hh"
#include <vector.h>

  typedef struct {
    int   sides; 
    int   index_hgvol;
    float sensdx,sensdy,sensdz; 
    float sens_offset_x,sens_offset_y,sens_offset_z;
    float wire_orient[4];
    float x_wire[4];
    float z_wire[4];
    int   n_wire[4];
    float y1_wire[4];
    float y2_wire[4];
    float polarity[4];
    float pitch[4];
    float effectivity;
    float accuracy;
    float double_hit_res;
  } hgdet;

class zgdet : public zgeom {
public:

  friend class zgmed;
  friend class zgpos;
  friend class zgrot;  
  friend class zgvol;
  friend class zguser;
 
  zgdet() {}
  ~zgdet() {} 
  
 void ini(int n);
 void fin();
 void increase();

  void  Read_sens_dim(char*);
  void  Read_sens_offset(char*);
  void  Read_sides(char*);
  void  Read_x_wire(char*);
  void  Read_z_wire(char*);
  void  Read_n_wire(char*);
  void  Read_y1_wire(char*);
  void  Read_y2_wire(char*);
  void  Read_wire_orientation(char*);
  void  Read_polarity(char*);
  void  Read_pitch(char*);
  void  Read_effectivity(char*);
  void  Read_accuracy(char*);
  void  Read_double_hit_res(char*);

  void  Set_vol_det_Rel();

  void  Set_default();
  void  Copy_previous();

  void  Get_sens_dim(int &, float &, float &) ;
  void  Get_sens_offset(int &, float &, float &) ;
  int   Get_sides(int &) ;
  void  Get_x_wire(int &,float *, int ) ;
  void  Get_z_wire(int &,float *, int ) ;
  void  Get_n_wire(int &,int   *, int ) ;
  void  Get_y1_wire(int &,float *, int ) ;
  void  Get_y2_wire(int &,float *, int ) ;
  void  Get_wire_orientation(int &,float* ,int);
  void  Get_polarity(int&, float*, int); 
  void  Get_pitch(int &, float *,int) ;
  float Get_effectivity(int &) ;
  float Get_accuracy(int &) ;
  float Get_double_hit_res(int &) ;
  void  FillSensParameter(int &,const ArtePointer<NEDE>);


private:
   static vector<hgdet> *ptdet[33];
};

#endif
