
*-- Author : B.Fominykh  26.10.2000

***** list of draw commands *****
*  "pict muon"
*
*  p, p1, p2, p3, p4                -  perspective view
*  top, top1, top2, top3, top4      - top view
*  side, side1, side2, side3, side4 - side view
*  "pict muon zcut 2010."           - Zcut with scale 0.02 
*  "pict muon zcut1 2010."          - Zcut with scale 0.025
*  "pict muon zcut2 2010. 0.05"     - Zcut with scale 0.05 
*  sl11 - sl16                      - Zcut MU1 in selected z
*  sl21 - sl25                      - Zcut MU2 in selected z
*  sl31 - sl36                      - Zcut MU3 in selected z
*  sl41 - sl48                      - Zcut MU4 in selected z
*  sl1, sl2, sl3, sl4               - chamber overlap
*
*********************************



      SUBROUTINE PICMUO
*     =================
C     draws a muon detector

      IMPLICIT NONE
C
      REAL ZCUT,Z1(5),Z2(5),ZMUON(5),SCALE
      REAL ZMOTH1,ZMOTH2,ZMOTH
      INTEGER I,K,NP1,IS,JS,CMP,IMU
      CHARACTER*5 PERS
#include "gean/gcflag.fi"
#include "arte/Arte.fi"
#include "auto/NESL.fi"
#include "gean/ZGESL.fi"
#include "arte/ArteFlag.fi"
      DATA NP1 /3/
#include "arte/Arte.ff"
#include "auto/NESL.ff"

C----------------------
* middle Z of MUON
      DO I=1,5
        ZMUON(I)=0.
      ENDDO
      IMU=0
      DO IS=1,IQ(JNESL+2)
        JS=JNESL+IQ(JNESL+1)*(IS-1)+2
        CMP=IQ(JS+JNESL_CMP)
* volumes MUON, MU01, MU02, MU03, MU04
        IF(CMP.EQ.LGESL_MUON) THEN
          IMU=IMU+1
          Z1(IMU)=Q(JS+JNESL_Z1)
          Z2(IMU)=Q(JS+JNESL_Z2)
          ZMUON(IMU)=0.5*(Z1(IMU)+Z2(IMU))
        ENDIF
      ENDDO
* mother
      ZMOTH1=Z1(1)
      ZMOTH2=Z2(1)
      ZMOTH =0.5*(ZMOTH1+ZMOTH2)

      CALL GDOPT('HIDE','ON  ')
      CALL GDOPT('SHAD','ON  ')
      CALL KUGETC(PERS,K)

      IF(PERS.EQ.'P') THEN
         CALL GDRAW('MUON',80.,150.,0.,10.,12.,.015,.015)
         CALL GDSCAL(2.,4.)
      ELSE IF(PERS.EQ.'P1') THEN
         CALL GDRAW('MU01',70.,150.,0.,10.,12.,.015,.015)
         CALL GDSCAL(2.,4.)
      ELSE IF(PERS.EQ.'P2') THEN
         CALL GDRAW('MU02',70.,150.,0.,10.,12.,.015,.015)
         CALL GDSCAL(2.,4.)
      ELSE IF(PERS.EQ.'P3') THEN
         CALL GDRAW('MU03',70.,150.,0.,10.,12.,.015,.015)
         CALL GDSCAL(2.,4.)
      ELSE IF(PERS.EQ.'P41') THEN
         CALL GDRAW('MU04',40.,20.,0.,10.,12.,.015,.015)
         CALL GDSCAL(2.,4.)
      ELSE IF(PERS.EQ.'P42') THEN
         CALL GDRAW('MU04',135.,20.,0.,10.,12.,.015,.015)
         CALL GDSCAL(2.,4.)

      ELSE IF(PERS.EQ.'ZCUT') THEN
        CALL KUGETR(ZCUT)
*        ZCUT=1852.
        SCALE=0.02
        PRINT*,'Zcut=',ZCUT,'   Zmin, Zmax =',ZMOTH1,ZMOTH2
        CALL GDRAWC('MUON',3,ZCUT-ZMOTH,10.,12.,.02,.02)
      ELSE IF(PERS.EQ.'ZCUT1') THEN
        CALL KUGETR(ZCUT)
        PRINT*,'Zcut =',ZCUT,'   Zmin, Zmax =',ZMOTH1,ZMOTH2
        SCALE=0.025
        CALL GDRAWC('MUON',3,ZCUT-ZMOTH,10.,12.,SCALE,SCALE)
      ELSE IF(PERS.EQ.'ZCUT2') THEN
        CALL KUGETR(ZCUT)
        CALL KUGETR(SCALE)
        PRINT*,'Zcut, SCALE =',ZCUT,SCALE,'   Zmin, Zmax =',ZMOTH1,ZMOTH2
        CALL GDRAWC('MUON',3,ZCUT-ZMOTH,10.,12.,SCALE,SCALE)

      ELSE IF(PERS.EQ.'SIDE') THEN
        CALL GDRAWC('MUON',1,0.,10.,12.,.02,.02)
*        CALL GDRAW('MUON',90.,180.,0.,10.,12.,.023,.023)
      ELSE IF(PERS.EQ.'SIDE1') THEN
        CALL GDRAW('MU01',90.,180.,0.,10.,12.,.023,.023)
      ELSE IF(PERS.EQ.'SIDE2') THEN
        CALL GDRAW('MU02',90.,180.,0.,10.,12.,.023,.023)
      ELSE IF(PERS.EQ.'SIDE3') THEN
        CALL GDRAW('MU03',90.,180.,0.,10.,12.,.023,.023)
      ELSE IF(PERS.EQ.'SIDE4') THEN
        CALL GDRAW('MU04',90.,180.,0.,10.,12.,.023,.023)

      ELSE IF(PERS.EQ.'TOP') THEN
        CALL GDRAWC('MUON',2,0.,10.,10.5,.017,.017)
      ELSE IF(PERS.EQ.'TOP1') THEN
        CALL GDRAWC('MU01',2,0.,10.,11.5,.017,.017)
      ELSE IF(PERS.EQ.'TOP2') THEN
        CALL GDRAWC('MU02',2,0.,10.,11.5,.017,.017)
      ELSE IF(PERS.EQ.'TOP3') THEN
        CALL GDRAWC('MU03',2,0.,10.,11.5,.017,.017)
      ELSE IF(PERS.EQ.'TOP4') THEN
        CALL GDRAWC('MU04',2,0.,10.,11.5,.017,.017)


      ELSE IF(PERS.EQ.'SL1') THEN
          CALL GDOPT('HIDE','OFF ')
          CALL GDOPT('SHAD','OFF ')
          CALL GSATT('MUW1','COLO',1)
          CALL GDRAW('MUD1',0.,0.,0.,10.,10.,.025,.025)
          CALL GSATT('MUW1','COLO',60)
          CALL GDOPT('HIDE','ON  ')
          CALL GDOPT('SHAD','ON  ')
          CALL GDHEAD(1001,
     +    'HERA-B MUON DETECTOR - superlayer 1',.4)
      ELSE IF(PERS.EQ.'SL2') THEN
          CALL GDOPT('HIDE','OFF ')
          CALL GDOPT('SHAD','OFF ')
          CALL GSATT('MUW2','COLO',1)
          CALL GDRAW('MUD2',0.,0.,0.,10.,10.,.025,.025)
          CALL GSATT('MUW2','COLO',60)
          CALL GDOPT('HIDE','ON  ')
          CALL GDOPT('SHAD','ON  ')
          CALL GDHEAD(1001,
     +    'HERA-B MUON DETECTOR - superlayer 2',.4)
      ELSE IF(PERS.EQ.'SL3') THEN
          CALL GDOPT('HIDE','OFF ')
          CALL GDOPT('SHAD','OFF ')
          CALL GSATT('MUP3','COLO',1)
          CALL GDRAW('MUD3',0.,0.,0.,10.,11.,.02,.02)
          CALL GSATT('MUP3','COLO',60)
          CALL GDOPT('HIDE','ON  ')
          CALL GDOPT('SHAD','ON  ')
          CALL GDHEAD(1001,
     +    'HERA-B MUON DETECTOR - superlayer 3',.4)
      ELSE IF(PERS.EQ.'SL4') THEN
          CALL GDOPT('HIDE','OFF ')
          CALL GDOPT('SHAD','OFF ')
          CALL GSATT('MUP4','COLO',1)
          CALL GDRAW('MUD4',0.,0.,0.,10.,10.,.025,.025)
          CALL GSATT('MUP4','COLO',60)
          CALL GDOPT('HIDE','ON  ')
          CALL GDOPT('SHAD','ON  ')
          CALL GDHEAD(1001,
     +    'HERA-B MUON DETECTOR - superlayer 4',.4)


      ELSE IF(PERS.EQ.'SL11') THEN
          ZCUT=1618.6
          CALL GDRAWC('MUON',3,ZCUT-ZMOTH,8.5,12.,.02,.02)
      ELSE IF(PERS.EQ.'SL12') THEN
          ZCUT=1624.5
          CALL GDRAWC('MUON',3,ZCUT-ZMOTH,8.5,12.,.02,.02)
      ELSE IF(PERS.EQ.'SL13') THEN
          ZCUT=1630.4
          CALL GDRAWC('MUON',3,ZCUT-ZMOTH,8.5,12.,.02,.02)
      ELSE IF(PERS.EQ.'SL14') THEN
          ZCUT=1636.3
          CALL GDRAWC('MUON',3,ZCUT-ZMOTH,8.5,12.,.02,.02)
      ELSE IF(PERS.EQ.'SL15') THEN
          ZCUT=1641.9
          CALL GDRAWC('MUON',3,ZCUT-ZMOTH,8.5,12.,.02,.02)
      ELSE IF(PERS.EQ.'SL16') THEN
          ZCUT=1647.4
          CALL GDRAWC('MUON',3,ZCUT-ZMOTH,8.5,12.,.02,.02)


      ELSE IF(PERS.EQ.'SL21') THEN
          ZCUT=1745.
          CALL GDRAWC('MUON',3,ZCUT-ZMOTH,8.5,12.,.02,.02)
      ELSE IF(PERS.EQ.'SL22') THEN
          ZCUT=1751.
          CALL GDRAWC('MUON',3,ZCUT-ZMOTH,8.5,12.,.02,.02)
      ELSE IF(PERS.EQ.'SL23') THEN
          ZCUT=1757.
          CALL GDRAWC('MUON',3,ZCUT-ZMOTH,8.5,12.,.02,.02)
      ELSE IF(PERS.EQ.'SL24') THEN
          ZCUT=1763.2
          CALL GDRAWC('MUON',3,ZCUT-ZMOTH,8.5,12.,.02,.02)
      ELSE IF(PERS.EQ.'SL25') THEN
          ZCUT=1769.
          CALL GDRAWC('MUON',3,ZCUT-ZMOTH,8.5,12.,.02,.02)


      ELSE IF(PERS.EQ.'SL31') THEN
          ZCUT=1880.
          CALL GDRAWC('MUON',3,ZCUT-ZMOTH,10.,12.,.02,.02)
      ELSE IF(PERS.EQ.'SL32') THEN
          ZCUT=1880.6
          CALL GDRAWC('MUON',3,ZCUT-ZMOTH,10.,12.,.02,.02)
      ELSE IF(PERS.EQ.'SL33') THEN
          ZCUT=1886.5
          CALL GDRAWC('MUON',3,ZCUT-ZMOTH,10.,12.,.02,.02)
      ELSE IF(PERS.EQ.'SL34') THEN
          ZCUT=1887.
          CALL GDRAWC('MUON',3,ZCUT-ZMOTH,10.,12.,.02,.02)
      ELSE IF(PERS.EQ.'SL35') THEN
          ZCUT=1893.
          CALL GDRAWC('MUON',3,ZCUT-ZMOTH,10.,12.,.02,.02)
      ELSE IF(PERS.EQ.'SL36') THEN
          ZCUT=1898.
          CALL GDRAWC('MUON',3,ZCUT-ZMOTH,10.,12.,.02,.02)


      ELSE IF(PERS.EQ.'SL41') THEN
          ZCUT=1960.
          CALL GDRAWC('MUON',3,ZCUT-ZMOTH,10.,12.,.02,.02)
      ELSE IF(PERS.EQ.'SL42') THEN
          ZCUT=1961.1
          CALL GDRAWC('MUON',3,ZCUT-ZMOTH,10.,12.,.02,.02)
      ELSE IF(PERS.EQ.'SL43') THEN
          ZCUT=1966.5
          CALL GDRAWC('MUON',3,ZCUT-ZMOTH,10.,12.,.02,.02)
      ELSE IF(PERS.EQ.'SL44') THEN
          ZCUT=1969.
          CALL GDRAWC('MUON',3,ZCUT-ZMOTH,10.,12.,.02,.02)
      ELSE IF(PERS.EQ.'SL45') THEN
          ZCUT=1973.1
          CALL GDRAWC('MUON',3,ZCUT-ZMOTH,10.,12.,.02,.02)
      ELSE IF(PERS.EQ.'SL46') THEN
          ZCUT=1979.
          CALL GDRAWC('MUON',3,ZCUT-ZMOTH,10.,12.,.02,.02)
      ELSE IF(PERS.EQ.'SL47') THEN
          ZCUT=2010.
          CALL GDRAWC('MUON',3,ZCUT-ZMOTH,10.,12.,.02,.02)
      ELSE IF(PERS.EQ.'SL48') THEN
          ZCUT=2100.
          CALL GDRAWC('MUON',3,ZCUT-ZMOTH,10.,12.,.02,.02)
      ENDIF



      RETURN
      END






