************************************************************************
*
* TRDMED
* written by Siegmund Nowak 09/94
*
* This routines DEFINES MATERIAL CONSTANTS AND MEDIA FOR TRD
*
************************************************************************

      SUBROUTINE TRDMED
C-----------------------

      IMPLICIT NONE

#include "arte/Arte.fi"
#include "gean/gclink.fi"
#include "gean/ZGTRDE.fi"
#include "gean/ZGESL.fi"
#include "gean/ZGDETV.fi"

      INTEGER J,MEDNUM,IMED,JMED
      REAL CUTSM
      CHARACTER*6 CUTSN
      DIMENSION CUTSM(6,4),CUTSN(6)
C
C...New cuts for different tracking media
C
        DATA CUTSN
     *  /'CUTGAM','CUTELE','BCUTE ','BCUTM ','DCUTE ','DCUTM '/
        DATA CUTSM
     * / .00001  ,.00005  ,.00001  ,.00001  ,.00005  ,.00005  ,
     *   .00001  ,.00001  ,.00001  ,.00001  ,.00001  ,.00001  ,
     *   .00001  ,.00001  ,.00001  ,.00001  ,.00001  ,.00001  ,
     *   .00001  ,.00001  ,.00001  ,.00001  ,.00001  ,.00001  /
#include "arte/Arte.ff"

      CALL TRDMAT 

      IF(DETV(LGESL_TRSL:LGESL_TRSL) .EQ. 'S') GO TO 99
C...
      DO 10 J = 1,6
       CALL GSTPAR(MEDNUM(1,'TRD_FOAM'),CUTSN(J),CUTSM(J,1))
       CALL GSTPAR(MEDNUM(1,'TR_MYLAR'),CUTSN(J),CUTSM(J,2))
       CALL GSTPAR(MEDNUM(3,'TRD_GAS'),CUTSN(J),CUTSM(J,3))
       CALL GSTPAR(MEDNUM(1,'TR_TUNGSTEN'),CUTSN(J),CUTSM(J,4))
       CALL GSTPAR(MEDNUM(3,'TRD_TUBE'),CUTSN(J),CUTSM(J,4))
   10 CONTINUE
       CALL GSTPAR(MEDNUM(1,'TRD_FOAM'),'LOSS',2.)
       CALL GSTPAR(MEDNUM(1,'TR_MYLAR'),'LOSS',2.)
       CALL GSTPAR(MEDNUM(3,'TRD_GAS'),'LOSS',2.)
       CALL GSTPAR(MEDNUM(1,'TR_TUNGSTEN'),'LOSS',2.)
       CALL GSTPAR(MEDNUM(3,'TRD_TUBE'),'LOSS',2.)
       CALL GSTPAR(MEDNUM(1,'TRD_FOAM'),'DRAY',0.)
       CALL GSTPAR(MEDNUM(1,'TR_MYLAR'),'DRAY',0.)
       CALL GSTPAR(MEDNUM(3,'TRD_GAS'),'DRAY',0.)
       CALL GSTPAR(MEDNUM(1,'TR_TUNGSTEN'),'DRAY',0.)
       CALL GSTPAR(MEDNUM(3,'TRD_TUBE'),'DRAY',0.)

      IMED = MEDNUM(1,'TRD_FOAM')
      JMED = LQ(JTMED-IMED)
      IF(JMED.GT.0) THEN
         Q(JMED+11) = .24                                ! STEMAX
         Q(JMED+12) = .2                                 ! DEEMAX
         Q(JMED+13) = .06                                ! EPSIL
         Q(JMED+14) = .06                                ! STMIN
      ELSE 
         CALL MEERRO('TRDMED: TRD-FOAM NOT BOOKED')
      ENDIF

      IMED = MEDNUM(3,'TRD_GAS')
      JMED = LQ(JTMED-IMED)
      IF(JMED.GT.0) THEN
         Q(JMED+11) = .012                               ! STEMAX
         Q(JMED+12) = .02                                ! DEEMAX
         Q(JMED+13) = .006                               ! EPSIL
         Q(JMED+14) = .006                               ! STMIN
      ELSE 
         CALL MEERRO('TRDMED: TRD-GAS NOT BOOKED')
      ENDIF

      IMED = MEDNUM(3,'TRD_TUBE')
      JMED = LQ(JTMED-IMED)
      IF(JMED.GT.0) THEN
         Q(JMED+11) = .012                               ! STEMAX
         Q(JMED+12) = .02                                ! DEEMAX
         Q(JMED+13) = .006                               ! EPSIL
         Q(JMED+14) = .006                               ! STMIN
      ELSE 
         CALL MEERRO('TRDMED: TRD-TUBE NOT BOOKED')
      ENDIF

  99  RETURN
      END

