// utfilp.C (name, subdir)
// written by Siegmund Nowak 97/11/18
// This routine opens a file either from the PWD, from a subdirectory 
// of the PWD with the same name as in the standard GEO , from a given  
// subdirectory (second parameter in the call) or from $HBROOT/GEO
// The search is in the order descibed above. The file is positioned at 
// the begin, a message is written out and the filepointer is given 
// as return value. In the calling program the routine must be declared as 
// FILE *utfilp(const char*,const char*) 
// name:   filename          
// subdir: subdirectory from where the filename should be taken (it is 
//         assumed that subdir is a replacement of $HBROOT and that the 
//         remaining structure is the same as in $HBROOT)    

#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <ctype.h>
#include <iostream.h>
#include "arte/arte.hh"
#include "arte/ArteMessage.hh"

  FILE *utfilp(const char* name, const char* subdir){ 
  FILE *filepointer;
  char fname[256];
  char *ptr;

  strcpy(fname,name);
  ptr=strtok(fname,"/");
  while (ptr != NULL) 
    strcpy(fname,ptr), ptr = strtok(NULL,"/");
  if(strlen(fname) != 0) {
    filepointer=fopen(fname,"r");
    if(filepointer){ 
       arteMsg<<"OPEN FILE " <<fname<< " : taken from your private directory";
       arteMsg.warn();          
       fseek(filepointer,0L,0);
       return filepointer;}     }                          

  strcpy(fname,name);
  filepointer=fopen(fname,"r");
  if(filepointer) {
    arteMsg <<"OPEN FILE " << fname << " : taken from your private directory";
    arteMsg.warn();
    fseek(filepointer,0L,0);
    return filepointer;
  }

  if(strlen(subdir) > 0) {
  strcpy(fname,subdir); 
  strcat(fname,"/");
  strcat(fname,name); 
  filepointer=fopen(fname,"r");
  if(filepointer) {
    arteMsg <<"OPEN FILE " << fname << " file is taken from " << subdir  ;
    arteMsg.warn();          
    fseek(filepointer,0L,0);
    return filepointer;
  }  }                              

  strcpy(fname,getenv("HBROOT"));
  strcat(fname,"/GEO/");
  if(strlen(subdir) > 0) {
     strcat(fname,subdir); 
     strcat(fname,"/"); } 
  strcat(fname,name);
  filepointer=fopen(fname,"r"); 
  if(filepointer) {
     arteMsg <<"OPEN FILE " << fname  ;
     arteMsg.toPrinters("p");          
     fseek(filepointer,0L,0);
     return filepointer;}                               

  arteMsg <<"Can not open " << name  ;
  arteMsg.warn();          
  return filepointer;                               }


