#ifndef GROVER_WITHOUT_ARTE
#include "arte/arte.hh"
#endif

#include "grover/grover.hh"

// Part of the Grover package
// Please see the header file grover.hh
// for authors etc.
//
//
// Modifications:
// When?     Who?     What?
// YY-MM-DD  Name     Modification
// -----------------------------------------------------------------------------
// 01-03-13  Max      Added preprocessor directives
//


int GroverFillFromRTAR(GroverWireList* gwl)
{
  ////////////////////////////////////////////////////////////////////////
  //
  // Fills a GroverWireList from RTAR
  //
  // returns 0 if OK, -1 if RTAR empty
  //
  ////////////////////////////////////////////////////////////////////////

#ifndef GROVER_WITHOUT_ARTE
  if (!ArteTable<RTAR>::booked()) return FAILURE;
  gwl->clear();
  for (ArteTable<RTAR>::iterator irtar = ArteTable<RTAR>::begin();
       irtar != ArteTable<RTAR>::end(); ++irtar) {
    gwl->push_back(GroverWire(irtar));
  }
#endif

  return SUCCESS;
}
