*CMZ :          20/03/96  19.32.15  by  Fedor Ratnikov
*-- Author :    Fouzia SAADI   03/11/95
************************************************************************
*
* T1HADXI
* written by Fouzia SAADI, 03/11/95 11.08.16
*
* This routine calculate de the minimal track slope dxi from
* pretrigger  to TC2 using the already calculated ROI in TC2.
* and the size of the track window in x.
* To be used in the hardware massage
*
* Arguments  kind         description
*          (in,update,out)
*----------------------------------------------------------------------*
* x1min,           in     xmin   positions  of ROI in pretriggers
* x1width          in     width             of =
* z1               in       z     =         =  =    =   =
* x2min            in     xmin    =         =  =    =   TC2
* x2width          in    width              =  =    =   =
* z2               in       z     =         =  =    =   =
*
* dxi              out
* ddxi             out
*
*
*
*
***********************************************************************
c
      SUBROUTINE  T1HADXI(x1min,x1width,z1,x2min,x2width,z2,dxi,ddxi)
c
      IMPLICIT NONE
c
      REAL x1min,x1width,z1,x2min,x2width,z2
      REAL x1max,x2max,dz,dxi,ddxi
c
      x1max = x1min+x1width
      x2max = x2min+x2width
c
      dz    = z1-z2
      dxi   = (x1max-x2min)/dz -  x1max/z1
c
      ddxi   = (x1min-x2max)/dz - x1min/z1 - dxi
c
c      print*,' t1hadxi--->  x1min x1width  z1 x2min x2width z2 ',
c     &  x1min,x1width, z1,x2min,x2width,z2
c      print*,' t1hadxi---> alpha  dxi  ddxi', x1max/z1 , dxi , ddxi
c
      RETURN
c
      END
