
*-- Author :    Rainer Mankel   02/04/95

      subroutine prmimp()

*     **** called by KUIP
*     **** print mimp bank. Arguments are:

*     **** mimp1, mimp2     Range of rows in Mimp table
*     **** mc               MC track number in mtra table
*     **** hit              Hit number in hitb table
*     **** pl               Plane number in gede table
*     **** sl               Superlayer number in gesl table

      implicit none
#include "arte/Arte.fi"

      integer id1, id2, nhitot, ndetpl, nmitot, ipl, isl, imc, nch,
     +        mimp, iimimp, n_mimps, pl, sl, hit, mc, rc, hitb,
     +        iihitb, index_hitb, index_mimp
      real xmc, ymc, zmc, pmc, mxmc, mymc
      character*80 chopts

#include "auto/GEO.fi"
#include "auto/HITB.fi"
#include "auto/MIMP.fi"
#include "auto/RTRA.fi"

#include "arte/Arte.ff"
#include "auto/GEO.ff"
#include "auto/HITB.ff"
#include "auto/MIMP.ff"
#include "auto/RTRA.ff"

*     **** parameters
      call kugeti(id1)
      call kugeti(id2)
      call kugeti(mc)
      call kugeti(rc)
      call kugeti(hit)
      call kugeti(pl)
      call kugeti(sl)
      call kugetc(chopts,nch)

*     **** fixup
      if (jmimp.le.0) then
         call mewarn('prmimp: table MIMP is not booked')
         go to 999
      endif

      ndetpl = iq(jgede+2)
      nhitot = iq(jhitb+2)
      nmitot = iq(jmimp+2)
      if (id2.eq.0.and.id1.ne.0) id2 = id1
      id1 = max(id1,1)
      if (id2.eq.0) then
         id2 = nmitot
      else
         id2 = min(id2,nmitot)
      endif
      print *,' prmimp: total number of mimps=', nmitot

      if (hit.lt.0.or.hit.gt.nhitot) then
         print *,' () prmimp: invalid hit=', hit
         go to 999
      endif

      if (pl.lt.0.or.pl.gt.ndetpl) then
         print *,' () prmimp: invalid  pl=', pl
         go to 999
      endif

*     **** option cases
      if (hit.gt.0) then
*        **** loop over associated mimps
         n_mimps = 0
         do 10 iimimp=1,99
            if (iimimp.eq.1) then
               index_mimp = phitb_mimp(hit)
            else
               index_mimp = xhitb_mimp(index_mimp)
            endif
            if (index_mimp.eq.0) go to 11
            mimp = mhitb_mimp(index_mimp)
            if (mimp.ge.id1.and.mimp.le.id2) then
               ipl = imimp_gede(mimp)
               if (pl.gt.0.and.ipl.ne.pl) go to 10
*              **** avoid packed plane IDs for ECAL
               if (ipl.le.ndetpl) then
                  isl = ogede_gesl(ipl)
               else
                  isl = 0
               endif
               if (sl.gt.0.and.isl.ne.sl) go to 10
               imc  = omimp_mtra(mimp)
               if (mc.gt.0.and.imc.ne.mc) go to 10
               n_mimps = n_mimps + 1

               if (mod(n_mimps,10).eq.1) then ! headline
                  print 102,
     +                 'isl','ipl','mimp','mc','z','x','y','mx','my','p'
               endif

               xmc  = fmimp_x(mimp)
               ymc  = fmimp_y(mimp)
               mxmc = fmimp_tx(mimp)
               mymc = fmimp_ty(mimp)
               zmc  = fmimp_z(mimp)
               pmc  = fmimp_p(mimp)

               print 101,isl,ipl,mimp,imc,zmc,xmc,ymc,mxmc,mymc,pmc
 101           format(i4,i6,i6,i5,6f9.3)
 102           format(a4,a6,a6,a5,6a9)
            endif               ! mimp.gt.0
 10      continue               ! loop over associated mimps
 11      continue               ! loop escape

      elseif (rc.gt.0) then

         do 30 iihitb=1,999         ! locate associated hits
            if (iihitb.eq.1) then
               index_hitb = prtra_hitb(rc)
            else
               index_hitb = xrtra_hitb(index_hitb)
            endif
            if (index_hitb.le.0) go to 31
            hitb = mrtra_hitb(index_hitb)
            
            do 40 iimimp=1,99       ! locate mimps
               if (iimimp.eq.1) then
                  index_mimp = phitb_mimp(hitb)
               else
                  index_mimp = xhitb_mimp(index_mimp)
               endif
               if (index_mimp.le.0) go to 41
               mimp = mhitb_mimp(index_mimp)

               if (mimp.ge.id1.and.mimp.le.id2) then
                  ipl = imimp_gede(mimp)
                  if (pl.gt.0.and.ipl.ne.pl) go to 40
*                 **** avoid packed plane IDs for ECAL
                  if (ipl.le.ndetpl) then
                     isl = ogede_gesl(ipl)
                  else
                     isl = 0
                  endif
                  if (sl.gt.0.and.isl.ne.sl) go to 40
                  imc  = omimp_mtra(mimp)
                  if (mc.gt.0.and.imc.ne.mc) go to 40
                  n_mimps = n_mimps + 1
                  if (mod(n_mimps,10).eq.1) then ! headline
                     print '(a4,a6,a6,a5,6a9,a6,a6)',
     +                    'isl','ipl','mimp','mc','z','x','y',
     +                    'mx','my','p','hitb','rtra'
                  endif

                  print '(i4,i6,i6,i5,6f9.3,i6,i6)',
     +                 isl,ipl,mimp,imc,fmimp_z(mimp),fmimp_x(mimp),
     +                 fmimp_y(mimp),fmimp_tx(mimp),fmimp_ty(mimp),
     +                 fmimp_p(mimp),hitb,rc
               endif

 40         continue
 41         continue

 30      continue
 31      continue

      else                      ! no hit given
*     **** loop over range of mimps
         do 20 mimp=id1,id2
            ipl = imimp_gede(mimp)
            if (pl.gt.0.and.ipl.ne.pl) go to 20
*     **** avoid packed plane IDs for ECAL
            if (ipl.le.ndetpl) then
               isl = ogede_gesl(ipl)
            else
               isl = 0
            endif
            if (sl.gt.0.and.isl.ne.sl) go to 20
            imc  = omimp_mtra(mimp)
            if (mc.gt.0.and.imc.ne.mc) go to 20
            xmc  = fmimp_x(mimp)
            ymc  = fmimp_y(mimp)
            mxmc = fmimp_tx(mimp)
            mymc = fmimp_ty(mimp)
            zmc  = fmimp_z(mimp)
            pmc  = fmimp_p(mimp)
            n_mimps = n_mimps + 1

            if (mod(n_mimps,10).eq.1) then ! headline
               print 102,
     +              'isl','ipl','mimp','mc','z','x','y','mx','my','p'
            endif
            print 101,isl,ipl,mimp,imc,zmc,xmc,ymc,mxmc,mymc,pmc
 20      continue
      endif                     ! hit.ne.0 clause

 999  end


