
// Boris Fominykh  31.03.2000
// main routine of muon identification in muon detector

// history:
//  30/11/00 - added the check that hits are prepared for real events - B.Fominykh
//  04/01/01 - excluded murlhov_() - B.Fominykh

//
//  RTRA tracks are used as a source of seeds for Kalman Filter
//  propagation to muon detector. Obtained track tree is used
//  as a basis for muon likelihood calculation.

#include <iostream.h>
#include <iomanip.h>
#include "usSelect.hh"
#include "arte/arte.hh"

extern "C" {
  void murbwtb_();
  void murbzdin_();
  void murhtinb_();
  void murclinb_();
  void mursdin_();
  void murdwtb_();
  void murtree_();
  void murtabb_();
  void murhtprb_();
  void murclprb_();
  void mursdpr_();
  void musteer_();
  int  MuDigi2Hitb();
}

extern "C" void MuonID()
{
// check that hits are prepared for real events
  int mode=12;
  int mustat=0;
  if(ArteTable<MTRA>::size() <= 0) { 
    musteer_(&mode,&mustat);
    if(mustat == 0) {
      int rhit=MuDigi2Hitb();
      if(rhit != 0) return;
    }
  }

// book temporary ARTE tables
  murbwtb_();
// calculate the z-ranges  of the reco layers
  murbzdin_();
// collect muon hits
  murhtinb_();
//  murhtprb_();
// make clusters
  murclinb_();
//  murclprb_();
// collect the seeds
  mursdin_();
//  mursdpr_();
// make a track tree
  murtree_();
// fill RTRA
  murtabb_();
// close the temporary ARTE tables
  murdwtb_();
// set the status
  mode=4;
  mustat=1;
  musteer_(&mode,&mustat);

  return;
}
