*
* B.Fominykh  17.11.97
* least squared straight-line fit with covariance calculation
*   parametrization is used y=a*x+b
*  cov(1)=sig(a)**2, cov(2)= rho*sig(a)*sig(b), cov(3)=sig(b)**2
*
*  input:  X(L),Y(L),ER(L),L
*  output: A,B,COV(3),CHI
*
      SUBROUTINE MURLFIT(X,Y,ER,L,A,B,COV,CHI)
C     ==================+=====================
      IMPLICIT NONE
      INTEGER L,I
      REAL*8  G1,G2,S11,S12,S22,D,W1,W2,W3,W4,W5,W
      REAL  A,B,COV(3),CHI
      REAL  X(L),Y(L),ER(L)
*     -----------------------------
      A=0.
       B=0.
        CHI=0.
         COV(1)=0.
          COV(2)=0.
           COV(3)=0.
      IF(L.LT.2) GO TO 200
      G1=0.
       G2=0.
        S11=0.
         S12=0.
          S22=0.
      DO 1 I=1,L
        IF(X(I).EQ.0.) GOTO 1
        IF(Y(I).EQ.0.) GOTO 1
        IF(ER(I).EQ.0.) GOTO 1
        W=ER(I)
        W=1./W**2
        W1=X(I)
          W2=Y(I)
        S11=S11+W
         S12=S12+W1*W
          S22=S22+W1*W1*W
           G1=G1+W2*W
            G2=G2+W1*W2*W
   1  CONTINUE
      D=S11*S22-S12*S12
      IF(ABS(D).LT.1.E-8) GOTO 200
      W1=(G1*S22-G2*S12)/D
      B=W1
      W2=(G2*S11-G1*S12)/D
      A=W2
      W3=S22/D
      COV(3)=W3
      W3=-S12/D
      COV(2)=W3
      W3=S11/D
      COV(1)=W3
      W5=0.
      DO 2 I=1,L
        IF(X(I).EQ.0.) GOTO 2
        IF(Y(I).EQ.0.) GOTO 2
        IF(ER(I).EQ.0.) GOTO 2
        W=ER(I)
        W3=X(I)
          W4=Y(I)
        W5=W5+((W4-W1-W2*W3)/W)**2
   2  CONTINUE
      CHI=W5
      B=B+A*X(1)

***      PRINT 1002,CHI,A,B,COV
*** 1002 FORMAT(1X,'CHI,A,B,COV:',6E12.4)

*
 200  CONTINUE
      RETURN
      END
