*
*  B.Fominykh  29.11.2000
*  a steering program for comminication between muon routines

*  saved/return parameters:
*  STMUDB    - status of DB constants preparation 
*            = 0 - constants are not read
*            > 0 - O.K., constants are ready
*  STMUHITS  - status of hit preparation
*            = 0 - hits are not prepared
*            > 0 - O.K., HITB is filled
*  STMURECA  - status of MURECA
*            = 0 - MURECA was not called
*            > 0 - MURECA was called
*  STMUID    - status of MuonID
*            = 0 - MuonID was not called
*            > 0 - MuonID was called

*  input:
*         MODE=0  - set STMUHITS,STMURECA,STMUID = 0
*         MODE=-1 - print the status

*         MODE=1  - save IPAR into STMUDB
*         MODE=2  - save IPAR into STMUHITS
*         MODE=3  - save IPAR into STMURECA
*         MODE=4  - save IPAR into STMUID
*
*         MODE=11 - return IPAR from STMUDB
*         MODE=12 - return IPAR from STMUHITS
*         MODE=13 - return IPAR from STMURECA
*         MODE=14 - return IPAR from STMUID
*
      SUBROUTINE MUSTEER(MODE,IPAR)
C-    =============================
*
      IMPLICIT NONE
      INTEGER MODE,IPAR,STMUDB,STMUHITS,STMURECA,STMUID
      COMMON/CMUSTEER/STMUDB,STMUHITS,STMURECA,STMUID
C----+===1=========2=========3=========4=========5=========6=========7==********

      IF(MODE.EQ.0) THEN
***        STMUDB   = 0
        STMUHITS = 0
        STMURECA = 0
        STMUID   = 0
        RETURN
      ENDIF

      IF(MODE.EQ.-1) THEN
        PRINT 1001,STMUDB,STMUHITS,STMURECA,STMUID
 1001   FORMAT(2X,' STATUS: MUDB=',I3,' MUHITS=',I3,
     +            ' MURECA=',I3,' MuonID=',I3)
        RETURN
      ENDIF

      IF(MODE.EQ.1) STMUDB   = IPAR
      IF(MODE.EQ.2) STMUHITS = IPAR
      IF(MODE.EQ.3) STMURECA = IPAR
      IF(MODE.EQ.4) STMUID   = IPAR

      IF(MODE.EQ.11) IPAR    = STMUDB
      IF(MODE.EQ.12) IPAR    = STMUHITS
      IF(MODE.EQ.13) IPAR    = STMURECA
      IF(MODE.EQ.14) IPAR    = STMUID

      RETURN
      END
