*-- Author :    Rainer Mankel   29/04/97

      subroutine pk1rtra(it,islsta,islend,chopt)

*     **** pick single reconstructed track
      implicit none
#include "pris/zgraf.fi"
#include "arte/Arte.fi"
      integer max_graf
      parameter (max_graf=200)
      integer it, ihf, ngraf, islsta, islend, isl, ipl, i_sort, n_sort,
     +        ihf_sort(max_graf), ind_sort(max_graf), segment,
     +        segment_begin(3), segment_size(3)
      real wh(3), xxx(max_graf), yyy(max_graf), sna, z_sort(max_graf)
      character*(*) chopt
      logical lplus, lzero, lplsup
      character*2 opt_c, opt_l
#include "auto/RHIT.fi"
#include "auto/RTRA.fi"
#include "auto/HITB.fi"
#include "auto/GESL.fi"
#include "auto/GEDE.fi"

#include "arte/Arte.ff"
#include "auto/RHIT.ff"
#include "auto/RTRA.ff"
#include "auto/HITB.ff"
#include "auto/GESL.ff"
#include "auto/GEDE.ff"

*     **** stereo mode option
      lplus = index(chopt,'Y').gt.0
      lzero = index(chopt,'0').gt.0
      lplsup = lplus.or.lzero

*     **** ghosts option
      if (index(chopt,'U').gt.0) then
       if (prtra_mtra(it).gt.0) go to 999
      endif

*     **** loop over fitted hits
      n_sort = 0
      do 10 ihf=1,iq(jrhit+2)
       if (irhit_rtra(ihf).ne.it) go to 10
       if (index(chopt,'L').gt.0)
     +                      print *,' pk1rtra: display ihfit=', ihf
       ipl = ihitb_gede(orhit_hitb(ihf))
       isl = ogede_gesl(ipl)
       if (isl.lt.islsta.or.isl.gt.islend) go to 10
       if (modezg.eq.1) then
        if (isl.gt.scmxzg) go to 10
        if (.not.lscopzg(isl)) go to 10
       endif

*      **** check plane
       if (lplsup) then
        sna = abs( fgede_sin(ipl))
        if (sna.gt.1.e-10.and.lzero) go to 10
        if (sna.le.1.e-10.and.lplus) go to 10
       endif

       if (n_sort.lt.max_graf) then
        n_sort = n_sort + 1
        z_sort(n_sort) = fhitb_z(orhit_hitb(ihf))
        ihf_sort(n_sort) = ihf
       else
        print *,' () pk1rtra: overflowing n_sort=', n_sort
        stop 'pk1rtra'
       endif
 10   continue
 11   continue

*     **** sort
      call sortzv(z_sort,ind_sort,n_sort,+1,0,0)

*     **** init segment pointers
      do segment=1,3
       segment_begin(segment) = 0
       segment_size(segment) = 0
      enddo
      segment = 1
      segment_begin(1) = 1

*     **** loop over hits in sorted order
      do i_sort=1,n_sort
       ihf = ihf_sort(ind_sort(i_sort))

       ngraf = i_sort

       isl = ogede_gesl(ihitb_gede(orhit_hitb(ihf)))
       if (segment.eq.1.and.igesl_mfl(isl).eq.1) then
        segment_size(1) = segment_size(1) + 1  ! connect seg 1&2
        segment = 2
        segment_begin(segment) = ngraf
       elseif (segment.eq.2.and.igesl_mfl(isl).eq.0) then
        segment = 3
        segment_begin(segment) = ngraf - 1
        segment_size(3) = 1 ! connect 2 & 3
       endif
       segment_size(segment) = segment_size(segment) + 1

       if (index(chopt,'L').gt.0)
     +         print *,' pk1rtra: it, ihf, z, segment=',
     +         it, ihf, fhitb_z(orhit_hitb(ihf)), segment


*      **** 3D point
       wh(1) = frhit_x(ihf)
       wh(2) = frhit_y(ihf)
       wh(3) = fhitb_z(orhit_hitb(ihf))

*      **** projection
       call dipro(wh,xxx(ngraf),yyy(ngraf))

      enddo

*     **** draw the graph
      if (ngraf.ge.2) then
*      **** draw segment in front of magnet
       if (segment_size(1).ge.2) call pkgraph(segment_size(1),
     +               xxx(segment_begin(1)),yyy(segment_begin(1)),opt_l)
*      **** draw segment inside magnet
       if (segment_size(2).ge.2) call pkgraph(segment_size(2),
     +               xxx(segment_begin(2)),yyy(segment_begin(2)),opt_c)
 111   format(a20/100(/e12.4,e12.4))
*      **** draw segment beyond magnet
       if (segment_size(3).ge.2) call pkgraph(segment_size(3),
     +               xxx(segment_begin(3)),yyy(segment_begin(3)),opt_c)

*      **** successful pick is indicated by pkgraph through id=-1
       if (idpickzg.eq.-1) idpickzg = it

      endif

 999  end






