/* This defines writing to string as to ostream. 
   E.g.: 
     string tmp;
     tmp << "i=" << 10 << ", x=" << 3.14 << '\n';
 */

// Author V.Balagura (balagura@mail.desy.de)   (10.04.98).

#ifndef _string_primitives_hh
#define _string_primitives_hh 1

#include <string>
#include <strstream.h>

template<class T>
inline string& operator<<(string& s, const T& x) {
  strstream tmp;
  tmp << x;
  int c;
  while ( (c=tmp.get()) != EOF ) s += c;
  return s;
}

#if (__GNUC__ > 2) || (__GNUC__ == 2 && __GNUC_MINOR__ > 7)
inline string& operator<<(string& s, char* x) {
  s += x;
  return s;
}
#endif

#endif
