*-- Author :   A. Spiridonov   06/04/02
*-- changed:    
*   data res2_add/2.5e-7/                               23.04.01 A. Spiridonov
*   check nclus.lt.maxclus                              29.04.01 A. Spiridonov
*   if(z_set(s2) - z_clus) .lt. dzmin) go to 20         05.04.01 A. Spiridonov
*

#define CONTY_LOCK
*#define DEBUG_TFCLUSY 
#define NEW_Y_MAXHIT 
#define  TX_NSIG_MSGC
#define PROXY_TFCONTY

      subroutine tfclusy(dw,tabl,direction,nseedw,seedw)

*     **** construct and propagate vertical seeds
*          (produce cluster from sets)
*          tailored from tfcontyn.F

      implicit none

#include "rang/zf.fi"
**include "rang/zdomain.fi"
#include "rang/ztripl.fi"
#include "rang/zfmode.fi"
#include "rang/zfpar.fi"
#include "rang/zplx.fi"
#include "arte/Arte.fi"
#include "auto/GEO.fi"
#include "auto/HITB.fi"
#include "auto/RSEG.fi"

      integer dw,method,ihit,pl
      real x,rgxseg,y,y_marg,x_acs,y_acs
      
      parameter (y_marg=2.)
      
      real dxmax,dzmin,txmax,dtxmax,dxclus,dtxclus,zref,dz1,tx1,dz2,
     +     tx2,sum_z,dx,dtx,tx_nsig,dtxres
      integer dom,win,ilay,iih,idh,hitb,cmp,isig,ind1,ind2,ind3,s1,
     +     s2,s3,t1,t2,tlast,ii,jj,kk,set0,trip0,clus0,
     +     ref,trip,clus,t,trip_found,clus_found,n_z,
     +     direction
      
      real rgzlay
      integer rgwidom,tabl,rgtabssw
      integer maxlay,maxhit
#ifndef NEW_Y_MAXHIT
      parameter (maxlay=6,maxhit=100)
#else 
      parameter (maxlay=6,maxhit=300) 
#endif
      integer vlay(maxlay),vhit(maxhit)
      integer nlay,nhit
      integer seed,lay

      integer vlay_old(60),nlay_old,ilay_old

      integer maxref
      parameter (maxref=1000)
      integer nref,vecref(maxref)
      integer maxhc
      parameter (maxhc=300)
      integer nhc,hit_hc(maxhc),indhc(maxhc),
     +     nhit_current,hc
      integer message_id_1, message_id_2 , message_id_3,
     +     message_id_4
      logical init
      
      data message_id_1 /1/,message_id_2 /2/,message_id_3 /3/,
     +     message_id_4 /4/
      data init /.false./

#ifdef DEBUG_TFCLUSY
      integer tumchit
      integer mc_hit(100)
#endif
      integer maxseed
      integer nseed,nseedw,seedw(*)
      integer set,itrip,lasthit
      integer n_unique,ind_hs_1(maxhit),ind_hs(maxhit)

      logical rgepipe
      real ymin_epipe,ymax_epipe      ! -94+3 , -66-3
      parameter (ymin_epipe = -91.)
      parameter (ymax_epipe = -69.)
      
      integer maxht,nht_clus
      parameter (maxht=200) 
      integer set_clus(maxht), ht_clus(maxht) 
      real dxres, nsig_clus, qq_clus, x_clus, res2_clus,w_clus,z_clus 
      data nsig_clus/2./,qq_clus/0./ 
      real res2_add
      data res2_add/2.5e-7/

      integer iift

#include "arte/Arte.ff"
#include "auto/GEO.ff"
#include "auto/HITB.ff"
#include "auto/RSEG.ff"
      
**      print *,' tfcontyn : START =+=+=+=++++++=====+++++'
      
      dxmax = 200.              ! maximum x difference for doublets
      dzmin = 0.1               ! minimum z difference for doublets
      txmax = 1.                ! maximum slope for doublets
      dtxmax = 0.20             ! maximum slope difference for triplets
      tx_nsig = 2.              !          ||   in sigmas
      dxclus = .60              ! maximum x  difference for cluster
      
**      dtxclus = 0.10            ! maximum tx difference for cluster
      dtxclus = 0.010            ! maximum tx difference for cluster
      
      nset = nsetx              ! clear y area
      ntrip = ntripx            !
      nclus = nclusx            !
      
******set0= nsetx

      nlay_old = 0
      dom = rgwidom(dw)

      if(nseedw.le.0) then
         
         call rgtabssws(dw,tabl,2,seedw,nseedw) ! get array of seeding set
         
#ifdef  DEBUG_TFCLUSY
         print *,' tfcontyn: seedw(1),nseedw ',seedw(1),nseedw
***   print *,' tfcontyn: seed=',seed
#endif
      endif
            
      if (nseedw.le.0) then
         print *,' tfcontyn: seed not found'
         go to 999
      endif

**      print *,'tfcontyn.F: nseedw,seedw ',nseedw
**     +     ,(seedw(nseed), nseed=1,nseedw)

      
      set0= nset
      do 1000 nseed=1,nseedw    ! loop on seed set

         seed = seedw(nseed)   
         call rgsdlay(seed,maxlay,vlay,nlay)

#ifdef  DEBUG_TFCLUSY
         print *,' tfcontyn: rgsdlay returns nlay=',nlay
     +        ,' vlay ',(vlay(ihit),ihit=1,nlay)
#endif
         if (nlay.lt.3) then
            print *,' tfcontyn: nlay only',nlay
            go to 999
         endif
         
         if(nseed.eq.1) then
            sum_z = 0.          ! calculate reference z
            n_z = 0
            do 60 ilay=1,nlay
#ifdef  DEBUG_TFCLUSY
               print *,' tfcontyn:      ilay=',ilay,
     +              ' lay=',vlay(ilay),' z=',rgzlay(vlay(ilay))
**               call rgdldmp(vlay(ilay))
#endif
               sum_z = sum_z + rgzlay(vlay(ilay))
               n_z = n_z + 1
 60         continue
            zref = sum_z / n_z
         end if
         
*     **** collect stereo hits
         do 90 ilay=1,nlay
            lay = vlay(ilay)
            if (lay.eq.0) go to 91

*     ***** check if lay was used 
            if(nlay_old.gt.0) then
               do ilay_old=1,nlay_old
                  if(vlay_old(ilay_old).eq.lay) go to 90
               enddo
            endif
            nlay_old = nlay_old + 1
            vlay_old(nlay_old) = lay

            nhit = 0
#ifdef PROXY_TFCONTY
            call rghlpr(lay,maxhit,vhit,nhit)
#else 
            call rghl(lay,maxhit,vhit,nhit)
#endif
            
#ifdef DEBUG_TFCLUSY
            
*            call rgdldmp(lay)
            
            if(nhit.lt.1) then
               print '("tfcontyn: ilay ",i4," NO hits")',ilay
            else 
               print '("tfcontyn:  imc ",12i5)'
     +              ,(tumchit (vhit(ihit)),ihit=1,min0(12,nhit))         
               print '("tfcontyn: hits ",12i5)'
     +              ,(vhit(ihit),ihit=1,min0(12,nhit))
               print '("tfcontyn:  lay ",12i5)'
     +              ,(igede_lay(ihitb_gede(vhit(ihit)))
     +              ,ihit=1,min0(12,nhit))
               print '("tfcontyn:  sec ",12i5)'
     +              ,(igede_sec(ihitb_gede(vhit(ihit)))
     +              ,ihit=1,min0(12,nhit))
            endif
#endif
            
            x = rgxseg(rgzlay(lay),rgwidom(dw)) ! approximate track x position
            
            do 40 ihit=1,nhit
               hitb = vhit(ihit)

**               if(ihit.eq.1) then
**                  print *,'tfcontyn.F: approximate track z,x,zh,xh '
**     +                 ,rgzlay(lay),x_conty + tx_conty  
**     +                 *(fhitb_z(vhit(ihit)) - z_conty)
**     +                 ,fhitb_z(vhit(ihit))
**     +                 ,rgxseg(fhitb_z(vhit(ihit)),rgwidom(dw))
**     +
**               endif

#ifdef TFCONTYN_DUPLICATE_CHECK_NOT_NEEDED               
*     check if hit is in hitset                  
               do ind1=set0+1,nset
**                  if(hitb.eq.hit_set(indset(ind1))) then
                  if(hitb.eq.hit_set(ind1)) then
*%%%
                     print *,' tfcontyn : ============= skip hitb ',hitb
                     go to 40
                  end if
               end do
#endif

#ifdef DEBUG_TFCLUSY
*     if(tumchit(hitb).ne.32) go to 40   ! ++++++++++++
#endif
            
#ifdef CONTY_LOCK
            if (phitb_rseg(hitb).gt.0) go to 40 ! used hit
#ifdef CONTY_LOCK_OLD
            if (segstor_zfpar) then
               if (phitb_rseg(hitb).gt.0) go to 40 ! used hit
            else
               if (phitb_rtra(hitb).gt.0) go to 40 ! used hit
            endif
#endif
#endif
            pl = ihitb_gede(hitb)
            cmp = igede_cmp(pl)
            
            if (nset.le.(maxset-2)) then
               if (cmp.eq.1.or.cmp.eq.3) then ! strip
                  
                  x_acs = rgxseg(fhitb_z(hitb),rgwidom(dw))
                  
*     *                  y_acs = (x * fgede_rot(1,pl) - fhitb_x(hitb))
                  y_acs = (x_acs * fgede_rot(1,pl) - fhitb_x(hitb))
     +                 / fgede_rot(2,pl)
*                  y = x * fgede_rot(2,pl) + y_acs * fgede_rot(5,pl)
                  y = x_acs * fgede_rot(2,pl) + y_acs * fgede_rot(5,pl)
#ifdef DEBUG_TFCLUSY
                  print *,' () tfcontyn : ihit=',ihit,
     +                 ' zh ',fhitb_z(hitb),' x ',x,
     +                 ' y_acs ', y_acs,
     +                 ' y ',y,' ymin,max '
     +                 ,(fgede_symn(pl)-y_marg),
     +                 (fgede_symx(pl)+y_marg)
     +                 ,' xhit ',rgxseg(fhitb_z(hitb),rgwidom(dw))
                  
#endif                  
                  if (y.lt.(fgede_symn(pl)-y_marg).or.
     +                 y.gt.(fgede_symx(pl)+y_marg)) go to 40

                  nset = nset + 1
                  x_set(nset) = (rgxseg(fhitb_z(hitb),rgwidom(dw))
     +                 * fgede_rot(1,pl) - fhitb_x(hitb))
     +                 / fgede_rot(2,pl)
                  z_set(nset) = fhitb_z(hitb)
*             ****   convert to Tx
                  x_set(nset) = x_set(nset) / z_set(nset)
                  res2_set(nset) = fhitb_r(hitb)/fgede_rot(2,pl)
     +                 /z_set(nset)
                  res2_set(nset) = res2_set(nset) * res2_set(nset)
     +                 + res2_add
                  w_set(nset) = 1. / res2_set(nset)
                  clus_set(nset) = 0
                  nx_set(nset) = 0

                  hit_set(nset) = hitb
                  sig_set(nset) = 0
                  dl_set(nset) = lay
                  indset(nset) = nset
                 
#ifdef DEBUG_TFCLUSY
                  print *,' () tfcontyn : indset=',indset(nset),
     +                 ' hit=',hit_set(nset),
     +                 ' sig=',sig_set(nset),
     +                 ' z=',z_set(nset),
     +                 ' x=',x_set(nset)
#endif
                  
               elseif (cmp.eq.2) then ! wirech

**                  x = x_conty + tx_conty * (fhitb_z(hitb) - z_conty)
                  x_acs = rgxseg(fhitb_z(hitb),rgwidom(dw)) 

                  do 70 isig=-1,1,2
                     

**                     y_acs = (x * cstot_plx(pl) - fhitb_x(hitb)
                     y_acs = (x_acs * cstot_plx(pl) - fhitb_x(hitb)
     +                    - isig * abs(fhitb_q(hitb)))
     +                    / sntot_plx(pl)
**                     y = x * fgede_rot(2,pl) + y_acs * fgede_rot(5,pl)
                     y = x_acs*fgede_rot(2,pl) + y_acs*fgede_rot(5,pl)

#ifdef FULL
                     if (y.lt.(fgede_symn(pl)-y_marg).or.
     +                    y.gt.(fgede_symx(pl)+y_marg)) then
                        if (isig*fhitb_q(hitb).gt.0.) then
                           print *,' tfcontyn: good stereo hit ',
     +                          hitb,' sig=',isig,
     +                          ' x=',x,' y_acs=',y_acs,
     +                          ' y=',y,
     +                          ' killed by margin in pl=',pl
                        else
                           print *,' tfcontyn: bad  stereo hit ',
     +                          hitb,' sig=',isig,
     +                          ' x=',x,' y_acs=',y_acs,
     +                          ' y=',y,
     +                          ' killed by margin in pl=',pl
                        endif
                     endif
#endif
                     if (y.lt.(fgede_symn(pl)-y_marg).or.
     +                    y.gt.(fgede_symx(pl)+y_marg)) go to 70

                     if(rgepipe(pl)) then ! gede with cuts
**                        print *,' tfcontyn.F : EPIPE !!!!! '
                        if(y.lt.ymax_epipe.and.y.gt.ymin_epipe) then
**                           print '("tfcontyn.F : ===== gede,ih,y,h "
**     +                          ,2i5,x,f8.3,x,a4)'
**     +                          ,pl,hitb,y,hgede_hwc(3,pl)
                           go to 40
                        endif
                     endif
                     
                     nset = nset + 1                     
                     x_set(nset) = (rgxseg(fhitb_z(hitb),dom)
     +                    * cstot_plx(pl) - fhitb_x(hitb)
     +                    - isig * abs(fhitb_q(hitb)))
     +                    / sntot_plx(pl)
                     z_set(nset) = fhitb_z(hitb)
*             ****   convert to Tx
                     x_set(nset) = x_set(nset)/z_set(nset)
                     res2_set(nset) = fhitb_r(hitb)/z_set(nset)
                     res2_set(nset) = fhitb_r(hitb)/fgede_rot(2,pl)
     +                    /z_set(nset)
                     res2_set(nset) = res2_set(nset) * res2_set(nset)
                     w_set(nset) = 1. / res2_set(nset)
                     clus_set(nset) = 0
                     nx_set(nset) = 0

                     hit_set(nset) = hitb
                     sig_set(nset) = isig
                     dl_set(nset) = lay
                     indset(nset) = nset
 70               continue
               else
                  print *,' () tfcontyn: invalid cmp=', cmp
                  print *,' dw,lay,pl,hitb=',
     +                 dw,lay,pl,hitb
               endif
            else
               call mepric(message_id_1,1,
     +              'tfcontyn: overflowing nset, hits skipped')
               go to 91
            endif
 40      continue               ! hits in layer
 41      continue
 90   continue                  ! layers
 91   continue
      
 1000 continue                  ! end of loop on seed set
      
*     **** sort the hit set (increasing x)
*      call sortzv(x_set,indset(set0+1),nset-set0,+1,0,1)
*     **** sort the hit set (increasing z)
      call sortzv(z_set,indset(set0+1),nset-set0,+1,0,1)

#ifdef DEBUG_TFCLUSY
      
**      print '(" tfcontyn: ======= set0+1,nset ",2i5)',(set0+1),nset
      if(set0+1.le.nset) then
         print '("tfcontyn:set  i",12i6 )'
     +        ,(indset(ind1),ind1=set0+1,nset)
         print '("tfcontyn:set  h",12i6 )'
**     +        ,(hit_set(indset(ind1)),ind1=set0+1,nset)
**     +        ,(sig_set(indset(ind1))*hit_set(indset(ind1))
     +        ,(hit_set(indset(ind1))
     +        ,ind1=set0+1,nset)
         print '("tfcontyn:set mc",12i6 )'
     +        ,(tumchit(hit_set(indset(ind1))),ind1=set0+1,nset)
**         print '("tfcontyn:set  z",12f9.3 )'
**     +        ,(z_set(indset(ind1)),ind1=set0+1,nset)
         print '("tfcontyn:set  x",12f9.3 )'
     +        ,(x_set(indset(ind1))*1000.,ind1=set0+1,nset)
         print '("tfcontyn:set  r",12f9.3 )'
     +        ,(sqrt(res2_set(indset(ind1))*1.e6)
     +        ,ind1=set0+1,nset)
      end if
#endif
      
*     *      print *,' tfcontyn: number of sets found =',nset-set0
      
*     **** search set clusters
      
      clus0 = nclus

         do 10 ind1=set0+1,nset-2       ! loop over base hit
            s1 = indset(ind1)
            if(clus_set(s1).gt.0) go to 10
            nht_clus = 1        !  try new cluster
            res2_clus = res2_set(s1)
            w_clus = w_set(s1)
            x_clus = x_set(s1)
            z_clus = z_set(s1)
            set_clus(nht_clus) = s1
            ht_clus(nht_clus) = hit_set(s1)
#ifdef DEBUG_TFCLUSY            
            print '("cntn: i1,h,nc,x_c,r_c  A",3i5,2(x,f9.3))'
     +           ,ind1-set0,hit_set(s1)*sig_set(s1),nht_clus
     +           ,x_clus*1000.,sqrt(res2_clus)*1000.
#endif
*                                    loop over second hit
            ind2 = ind1+1
 21         continue
            if(ind2.le.nset) then
**            do 20 ind2=ind1+1,nset ! loop over second hit
               s2 = indset(ind2)
               if(clus_set(s2).gt.0) go to 20
               do ii=1,nht_clus
                  if(hit_set(s2).eq.ht_clus(ii)) go to 20  
               enddo
               dxres = sqrt( res2_clus + res2_set(s2) )
#ifdef DEBUG_TFCLUSY            
            print '("cntn: i2,h,nc,xh,dx,dxr  B",3i5,3(x,f9.3))'
     +              ,ind2-set0,hit_set(s2)*sig_set(s2),nht_clus
     +              ,x_set(s2) * 1000.
     +              ,(x_set(s2) - x_clus)*1000.
     +              ,dxres * nsig_clus * 1000.
#endif


            if(z_set(s2) - z_clus .lt. dzmin) go to 20
               if(abs(x_set(s2)-x_clus).gt.dxres*nsig_clus) go to 20
               if(ind2.lt.nset) then
                  s3 = indset(ind2+1)
                  if(hit_set(s2).eq.hit_set(s3)) then
                     if(clus_set(s3).le.0) then
                        if(abs(x_set(s2)-x_clus)
     +                       .ge.abs(x_set(s3)-x_clus)) then
                           s2 = s3                 ! change to s3
                           ind2 = ind2+1
**                           print '("cntn:\/\/\/\/\select ind2,s2",2i5)'
**     +                          ,ind2-set0,hit_set(s2)*sig_set(s2)
                        endif
                     endif
                  endif
               endif
*      **** absorb set in cluster
               nht_clus = nht_clus + 1
               ht_clus(nht_clus) = hit_set(s2)
               set_clus(nht_clus) = s2
               res2_clus =  1. / (w_clus + w_set(s2))
               x_clus = (x_clus * w_clus + x_set(s2) * w_set(s2))
     +              * res2_clus
               w_clus = w_clus + w_set(s2)
               z_clus = z_set(s2)

#ifdef DEBUG_TFCLUSY            
               print '("cntn: nc,xcl,rcl        OK ",i5,2(x,f9.3))'
     +              ,nht_clus
     +              ,x_clus*1000.
     +              ,sqrt(res2_clus) * 1000.
#endif
 20            ind2 = ind2 + 1
               go to 21
            endif          ! end of ind2.le.nclus                   

*      **** check if cluster OK 
            if(nht_clus.lt.3) go to 10

*      **** store cluster               
            if (nclus.lt.maxclus) then
               nclus = nclus + 1
               indclus(nclus) = nclus
               mult_clus(nclus) = nht_clus
               set1_clus(nclus) = set_clus(1)
               do ii=1,nht_clus
                  clus_set(set_clus(ii)) = nclus
                  if(ii.lt.nht_clus) then
                     nx_set(set_clus(ii)) = set_clus(ii+1)
                  endif
                  nx_set(set_clus(nht_clus)) = 0
               enddo
            else
               call mepric(message_id_3,1,
     +              'tfclusy.F: overflowing nclus, triplets skipped')
               go to 11
            endif

 10      continue               ! end of loop on first hit
 11      continue

      call sortzv(mult_clus,indclus(clus0+1),nclus-clus0,-1,1,1) 
     +                          ! sort mult_clus

#ifdef DEBUG_TFCLUSY
      print '(" tfcontyn: --- clusters ",2i6)',(nclusx+1),nclus
      do ind1=nclusx+1,nclus
         ii = indclus(ind1)
         if(mult_clus(ii).eq.1) then
            print '(" tfcontyn: clus ",i4," t1 ",i4)',ii,set1_clus(ii)
         else if(mult_clus(ii).eq.2) then
            print '(" tfcontyn: clus ",i4," t12 ",2(x,i4))'
     +           ,ii,set1_clus(ii),nx_set(set1_clus(ii))
         else if(mult_clus(ii).eq.3) then
            print '(" tfcontyn: clus ",i4," t123 ",3(x,i4))'
     +           ,ii,set1_clus(ii),nx_set(set1_clus(ii))
     +           ,nx_set(nx_set(set1_clus(ii)))
         else if(mult_clus(ii).eq.4) then
            print '(" tfcontyn: clus ",i4," t1234 ",4(x,i4))'
     +           ,ii,set1_clus(ii),nx_set(set1_clus(ii))
     +           ,nx_set(nx_set(set1_clus(ii)))
     +           ,nx_set(nx_set(nx_set(set1_clus(ii))))
         else if(mult_clus(ii).eq.5) then
            print '(" tfcontyn: clus ",i4," t12345 ",5(x,i4))'
     +           ,ii,set1_clus(ii),nx_set(set1_clus(ii))
     +           ,nx_set(nx_set(set1_clus(ii)))
     +           ,nx_set(nx_set(nx_set(set1_clus(ii))))
     +           ,nx_set(nx_set(nx_set(nx_set(set1_clus(ii)))))
         else if(mult_clus(ii).eq.6) then
            print '(" tfcontyn: clus ",i4," t123456 ",6(x,i4))'
     +           ,ii,set1_clus(ii),nx_set(set1_clus(ii))
     +           ,nx_set(nx_set(set1_clus(ii)))
     +           ,nx_set(nx_set(nx_set(set1_clus(ii))))
     +           ,nx_set(nx_set(nx_set(nx_set(set1_clus(ii)))))
     +           ,nx_set(nx_set(nx_set(nx_set(nx_set(set1_clus(ii)
     +           )))))
         else if(mult_clus(ii).eq.7) then
            print '(" tfcontyn: clus ",i4," t1234567 ",7(x,i4))'
     +           ,ii,set1_clus(ii),nx_set(set1_clus(ii))
     +           ,nx_set(nx_set(set1_clus(ii)))
     +           ,nx_set(nx_set(nx_set(set1_clus(ii))))
     +           ,nx_set(nx_set(nx_set(nx_set(set1_clus(ii)))))
     +           ,nx_set(nx_set(nx_set(nx_set(nx_set(set1_clus(ii))))))
     +           ,nx_set(nx_set(nx_set(nx_set(nx_set(nx_set
     +           (set1_clus(ii)))))))
         else  if(mult_clus(ii).gt.7) then 
            print '(" tfcontyn: clus ",i4," t1234567... ")'
         end if
      end do     
#endif

      if (diag_level.ge.5) then
         print *,' tfcontyn: vertical sets=', nset-nsetx,
     +        '  triplets=', ntrip-ntripx,
     +        '  clusters=', nclus-nclusx
      endif
      
      do  ind1=set0+1,nset                    ! transform Tx to X
         s1 = indset(ind1) 
         x_set(s1) = x_set(s1) * z_set(s1)
      enddo   

      if(nclusx+1.le.nclus) then
         do ii=nclusx+1,nclus

**            call tfpropcyn(ii,ii,direction) ! propagate 1 cluster

            call tfpropcly(ii,ii,direction) ! propagate 1 cluster
  
            do iift=begin_ft,nca_ft         
               if (alive_ft(iift)) then
                  if (quality_ft(iift).ge.qualmin_y_zfpar) then 
#ifdef DEBUG_TFCLUSY 
                     print *,'=F=F=F=F= store ift,nresg '
     +                    ,iift,nrseg()
     +                    ,' z1,z2 ',z_zf(first_ft(iift))
     +                    ,z_zf(last_ft(iift))
#endif
                     go to 999
                  endif
               endif               
            enddo


         enddo
      endif
      
 999  end
