*-- Author :    Rainer Mankel   04/12/94
*-- changed:    A.Spiridonov    19/02/98
*  x,y_margin  depends on updated cov matrix         06/08/00 A. Spiridonov
*  check of y coorfinate only                        13/08/00 A. Spiridonov
*  exclude flag NEWNAV                               04/12/00 A. Spiridonov
*  define Y_TARGET_CHECK                             12/06/01 A. Spiridonov
*

#define NEW_Y_CHECK
#define Y_TARGET_CHECK
      
      subroutine tffilmn(ih,dlnext,jpl,ift,izf,izfnew,istat)
      
*     **** absorb the next hit (3D version)
      implicit none
      
#include "rang/zseed.fi"
#include "rang/zf.fi"
#include "rang/zplx.fi"
#include "rang/zfpar.fi"
#include "rang/zfmode.fi"
#include "rang/zdomain.fi"
#include "pris/zpstat.fi"
      
      integer ih, jpl, izf, izfnew, xsig_min, xsig_max, del_xsig, xsig,
     +     jzf, ift, jft, ii, jj, kk, istat, tumchit, 
     +     dlnext, target_domain, cmp
      integer message_id_1
#ifdef CURVMESS
      integer message_id_2
#endif
      double precision dz, du, cs_thetu, xm_p, xr_p,
     +     cr_p, hch, kalman(dimp,dimm), ihk, m_u, sum, f(5,5)
      real wc(3), xxx(2), yyy(2), qptmax, x_border, y_border,
     +     x_margin, y_margin
*     parameter (qptmax=2.)  ! max q/pt (0.5 GeV)
      parameter (qptmax=0.96)   ! max q/pt (1 GeV)
      
      double precision xp_LEFT(5),cp_LEFT(5,5)
*-------------------------------------------
      character*1 tfcsig
      
      integer rgdomnb, rgdldom

#ifdef Y_TARGET_CHECK
      real y_targ,sy_targ
#endif
      
#include "rang/descend.fi"
      
#include "arte/Arte.fi"
#include "auto/GEO.fi"
#include "auto/HITB.fi"
#include "auto/MTRA.fi"
      
      save    message_id_1
#ifdef CURVMESS
      save message_id_2
#endif
      data    message_id_1 /1/
      
      integer N_h_zf
      double precision h_1,h_2,k_1,k_2,k_3,k_4,k_5
      double precision c11,c12,c13,c14,c15
      double precision c21,c22,c23,c24,c25
      double precision kh_1,kh_2,kh_3,kh_4,kh_5,x,y
      
      integer gold,jgold
      
#include "arte/Arte.ff"
#include "auto/GEO.ff"
#include "auto/HITB.ff"
#include "auto/MTRA.ff"
      
      kh_1(x,y) = k_1 * ( h_1 * x + h_2 * y )
      kh_2(x,y) = k_2 * ( h_1 * x + h_2 * y )
      kh_3(x,y) = k_3 * ( h_1 * x + h_2 * y )
      kh_4(x,y) = k_4 * ( h_1 * x + h_2 * y )
      kh_5(x,y) = k_5 * ( h_1 * x + h_2 * y )
      
      izfnew = 0
      
      if (.not.l_mag.and..not.l_svd) then
         print *,' () tffilm: 3d only!'
         go to 999
      endif
      
      if (diag_level.ge.5)
     +     print *,' tffilm: absorb ih, jpl, imc=', ih, jpl, tumchit(ih)
      
      if (igede_cmp(jpl).eq.2) then
         xsig_min = -1
         xsig_max = +1
         del_xsig = +2
      else
         xsig_min = 0
         xsig_max = 0
         del_xsig = +2
      endif
      
      dz = fhitb_z(ih) - z_zf(izf)
      
*     **** loop over L/R signs
      do 10 xsig=xsig_min,xsig_max,del_xsig
         istat = 0
         if (n_zf.ge.nzfmx) then
            istat = -10
            call mepric(message_id_1,3,
     +           'tffilm: ranger buffer at limit, track aborted')
            go to 999
         endif
         jzf = n_zf + 1
         
*     **** Kalman filter prediction
         
         target_domain = rgdldom( dlnext)
         if (.not.l_homog.and.filled_db(rgdomnb(target_domain))) then
            if(xsig.ne.1) then
               
               call tftranFn(target_domain,dz,izf,jzf,istat) ! short cut
               
               if(xsig.eq.-1) then ! store LEFT for sign
                  do ii=1,5
                     xp_LEFT(ii) = xp_zf(ii,jzf)
                     do jj=1,5
                        cp_LEFT(ii,jj) = cp_zf(ii,jj,jzf)
                     end do 
                  end do
               end if
            else if(xsig.eq.1) then ! restore for RIGHT 
               do ii=1,5
                  xp_zf(ii,jzf) = xp_LEFT(ii)
                  do jj=1,5
                     cp_zf(ii,jj,jzf) = cp_LEFT(ii,jj)
                  end do
               end do
            end if
         else
            call tftran(dz,izf,jzf,istat)
         endif
         
         if (istat.lt.0) then
            print *,' tffilm: transport was impossible, abort sign,',
     +           ' ih,ift,izf=',ih,ift,izf
            go to 10
         endif
         
#ifdef HISTFILM
         call hfill(6201,sngl(dz),0.,1.)
         call hfill(6202,z_zf(izf),fhitb_z(ih),1.)
         if (fault_zf(izf).eq.0) then
            call hfill(6203,sngl(dz),0.,1.)
         elseif (fault_zf(izf).eq.1) then
            call hfill(6204,sngl(dz),0.,1.)
         elseif (fault_zf(izf).eq.2) then
            call hfill(6205,sngl(dz),0.,1.)
         elseif (fault_zf(izf).eq.3) then
            call hfill(6206,sngl(dz),0.,1.)
         endif
#endif
*     *       call tftrans(dz,izf,jzf,f,-1,0,istat)
         
         if (diag_level.ge.5) then
            print *,' tffilm: start was xx(4), sq(cx(4))=',
     +           xx_zf(4,izf), dsqrt(cx_zf(4,4,izf))
            print *,' tffilm: pred=', xp_zf(2,jzf),
     +           ' error ', dsqrt( cp_zf(2,2,jzf) ), 'dz=', dz
            print *,' cp_zf(2,2,jzf), cp_zf(2,4,jzf), cp_zf(4,4,jzf)=',
     +           cp_zf(2,2,jzf), cp_zf(2,4,jzf), cp_zf(4,4,jzf)
         endif
         
*     **** projection
         
         if (igede_cmp(jpl).eq.2) then
            
            xm_zf(1,jzf)   = xsig * abs( fhitb_q(ih) )
            cm_zf(1,1,jzf) = fhitb_r(ih)**2
*     **** tan(track angle) in uz-plane
            m_u = xp_zf(3,jzf) * cstot_plx(jpl)
     +           - xp_zf(4,jzf) * sntot_plx(jpl)
            cs_thetu = 1. / dsqrt(1.d0 + m_u**2)
*     **** distance from projection to wire (along u)
            du = xp_zf(1,jzf) * cstot_plx(jpl)
     +           - xp_zf(2,jzf) * sntot_plx(jpl) - fhitb_x(ih)
            xm_p      = du * cs_thetu
*     **** difference to signed drift distance
            xr_p = xsig * abs( fhitb_q(ih) ) - xm_p
            
            
            if(abs(sntot_plx(jpl)).lt.1.e-3) then ! X - chambers
               
               N_h_zf = 1
               
               h_zf(1,1,jzf) =   cstot_plx(jpl) * cs_thetu
               h_zf(1,2,jzf) = 0.
               h_zf(1,3,jzf) = 0.
               h_zf(1,4,jzf) = 0.
               h_zf(1,5,jzf) = 0.
               
               hch =  h_zf(1,1,jzf)**2 * cp_zf(1,1,jzf)
               
            else                ! Y - chamber
               
               N_h_zf = 2
               
               h_zf(1,1,jzf) =   cstot_plx(jpl) * cs_thetu
               h_zf(1,2,jzf) = - sntot_plx(jpl) * cs_thetu
               h_zf(1,3,jzf) = 0.
               h_zf(1,4,jzf) = 0.
               h_zf(1,5,jzf) = 0.
               
               hch =  h_zf(1,1,jzf)**2 * cp_zf(1,1,jzf)
     +              +  h_zf(1,2,jzf)**2 * cp_zf(2,2,jzf)
     +              + 2.d0 * ( h_zf(1,1,jzf) * h_zf(1,2,jzf) 
     +              * cp_zf(1,2,jzf))
               
            end if

*     print '(/"sin,H= ",5(f9.4) )',sntot_plx(jpl),h_zf(1,1,jzf)
*     +         ,h_zf(1,2,jzf),h_zf(1,3,jzf),h_zf(1,4,jzf)
            
            cr_p = cm_zf(1,1,jzf) + hch
            
         elseif (igede_cmp(jpl).eq.3) then
            
            xm_zf(1,jzf)   = fhitb_x(ih)
            cm_zf(1,1,jzf) = fhitb_r(ih)**2
            xm_p = xp_zf(1,jzf) * fgede_rot(1,jpl)
     +           - xp_zf(2,jzf) * fgede_rot(2,jpl)
            xr_p = fhitb_x(ih) - xm_p
            
            N_h_zf = 2
            
            h_zf(1,1,jzf) =  fgede_rot(1,jpl)
            h_zf(1,2,jzf) = -fgede_rot(2,jpl)
            h_zf(1,3,jzf) = 0.
            h_zf(1,4,jzf) = 0.
            h_zf(1,5,jzf) = 0.
            hch = cp_zf(1,1,jzf) * h_zf(1,1,jzf)**2
     +           + 2.d0 * cp_zf(1,2,jzf) * h_zf(1,1,jzf) * h_zf(1,2,jzf)
     +           + cp_zf(2,2,jzf) * h_zf(1,2,jzf)**2
            cr_p = cm_zf(1,1,jzf) + hch
            
         elseif (igede_cmp(jpl).eq.1) then
            
            xm_zf(1,jzf)   = fhitb_x(ih)
            cm_zf(1,1,jzf) = fhitb_r(ih)**2
            xm_p = xp_zf(1,jzf) * cstot_plx(jpl)
     +           - xp_zf(2,jzf) * sntot_plx(jpl)
            xr_p = fhitb_x(ih) - xm_p
            
            N_h_zf = 2
            
            h_zf(1,1,jzf) =  cstot_plx(jpl)
            h_zf(1,2,jzf) = -sntot_plx(jpl)
            h_zf(1,3,jzf) = 0.
            h_zf(1,4,jzf) = 0.
            h_zf(1,5,jzf) = 0.
            hch = cp_zf(1,1,jzf) * h_zf(1,1,jzf)**2
     +           + 2.d0 * cp_zf(1,2,jzf) * h_zf(1,1,jzf) * h_zf(1,2,jzf)
     +           + cp_zf(2,2,jzf) * h_zf(1,2,jzf)**2
            cr_p = cm_zf(1,1,jzf) + hch
         else
            print *,' tffilm: non-supported type for jpl=', jpl
         endif
         
*     print '(/"cmp,Sr,sin,H ",i2,6(f7.4))'
*     +        ,igede_cmp(jpl),fhitb_r(ih),sntot_plx(jpl)
*     +        ,h_zf(1,1,jzf),h_zf(1,2,jzf),h_zf(1,3,jzf),h_zf(1,4,jzf)
         
         
         if (diag_level.ge.5) then
            print *,' tffilm: fhitb_x(ih), xm_p, xr_p, er_p=',
     +           fhitb_x(ih), xm_p, xr_p, dsqrt(cr_p)
            
            print *,' hch, fhitb_r(ih)**2, cr_p=',
     +           hch, fhitb_r(ih)**2, cr_p
         endif
         
*     **** decision
         
         if (dabs(xr_p).gt.dsqrt(chmax_mag_zfpar*cr_p)) then
                        
            if (diag_level.ge.5) then
               print *,' tffilm: hit dropped due to nsigma,',
     +              ' dabs(xr_p), dsqrt(16.d0*cr_p)=',
     +              dabs(xr_p), dsqrt(16.d0*cr_p)
            endif
            go to 10
         endif
         
*     **** filter point
         do ii=1,5
            if(N_h_zf.eq.1) then
               kalman(ii,1) = ( cp_zf(ii,1,jzf) * h_zf(1,1,jzf) ) / cr_p
            else if(N_h_zf.eq.2) then
               kalman(ii,1) = ( cp_zf(ii,1,jzf) * h_zf(1,1,jzf)
     +              + cp_zf(ii,2,jzf) * h_zf(1,2,jzf) ) / cr_p
            else
               kalman(ii,1) = ( cp_zf(ii,1,jzf) * h_zf(1,1,jzf)
     +              + cp_zf(ii,2,jzf) * h_zf(1,2,jzf)
     +              + cp_zf(ii,3,jzf) * h_zf(1,3,jzf)
     +              + cp_zf(ii,4,jzf) * h_zf(1,4,jzf)
     +              + cp_zf(ii,5,jzf) * h_zf(1,5,jzf) ) / cr_p
            end if
         enddo
         
         
*     print '(/"Sr,sin,K ",7(f8.4))'
*     +       ,fhitb_r(ih),sntot_plx(jpl)
*     +       ,kalman(1,1),kalman(2,1),kalman(3,1)
*     +       ,kalman(4,1),kalman(5,1)
         
*     **** updated x value
         do ii=1,5
            xx_zf(ii,jzf) = xp_zf(ii,jzf) + kalman(ii,1) * xr_p
         enddo
         
*     **** cut on Q/pt
         if (abs(sngl(xx_zf(5,jzf))).gt.qptmax) then
#ifdef CURVMESS
            call mepric(message_id_2,1,'tffilm: curvature limit exceeded')
#endif
            go to 10
         endif
         
*     **** updated cov matrix
         
         if(N_h_zf.eq.1) then
            
            h_1 = h_zf  (1,1,jzf)
            k_1 =  kalman(1,1) * h_1 
            k_2 =  kalman(2,1) * h_1
            k_3 =  kalman(3,1) * h_1
            k_4 =  kalman(4,1) * h_1
            k_5 =  kalman(5,1) * h_1
            
            c11 = cp_zf(1,1,jzf)
            c12 = cp_zf(1,2,jzf)
            c13 = cp_zf(1,3,jzf)
            c14 = cp_zf(1,4,jzf)
            c15 = cp_zf(1,5,jzf)
            
            cx_zf(1,1,jzf) = (1.d0 - k_1) * c11
            cx_zf(1,2,jzf) = (1.d0 - k_1) * c12
            cx_zf(1,3,jzf) = (1.d0 - k_1) * c13
            cx_zf(1,4,jzf) = (1.d0 - k_1) * c14
            cx_zf(1,5,jzf) = (1.d0 - k_1) * c15
            
            cx_zf(2,1,jzf) = cx_zf(1,2,jzf)
            cx_zf(2,2,jzf) = cp_zf(2,2,jzf) - k_2 * c12
            cx_zf(2,3,jzf) = cp_zf(2,3,jzf) - k_2 * c13
            cx_zf(2,4,jzf) = cp_zf(2,4,jzf) - k_2 * c14
            cx_zf(2,5,jzf) = cp_zf(2,5,jzf) - k_2 * c15
            
            cx_zf(3,1,jzf) = cx_zf(1,3,jzf) 
            cx_zf(3,2,jzf) = cx_zf(2,3,jzf)
            cx_zf(3,3,jzf) = cp_zf(3,3,jzf) - k_3 * c13
            cx_zf(3,4,jzf) = cp_zf(3,4,jzf) - k_3 * c14
            cx_zf(3,5,jzf) = cp_zf(3,5,jzf) - k_3 * c15
            
            cx_zf(4,1,jzf) = cx_zf(1,4,jzf) 
            cx_zf(4,2,jzf) = cx_zf(2,4,jzf)
            cx_zf(4,3,jzf) = cx_zf(3,4,jzf)
            cx_zf(4,4,jzf) = cp_zf(4,4,jzf) - k_4 * c14
            cx_zf(4,5,jzf) = cp_zf(4,5,jzf) - k_4 * c15
            
            cx_zf(5,1,jzf) = cx_zf(1,5,jzf) 
            cx_zf(5,2,jzf) = cx_zf(2,5,jzf)
            cx_zf(5,3,jzf) = cx_zf(3,5,jzf)
            cx_zf(5,4,jzf) = cx_zf(4,5,jzf)
            cx_zf(5,5,jzf) = cp_zf(5,5,jzf) - k_5 * c15
            
         else if(N_h_zf.eq.2) then
            
            h_1 = h_zf  (1,1,jzf)
            h_2 = h_zf  (1,2,jzf)
            k_1 =  kalman(1,1)  
            k_2 =  kalman(2,1) 
            k_3 =  kalman(3,1) 
            k_4 =  kalman(4,1) 
            k_5 =  kalman(5,1) 
            
            c11 = cp_zf(1,1,jzf)
            c12 = cp_zf(1,2,jzf)
            c13 = cp_zf(1,3,jzf)
            c14 = cp_zf(1,4,jzf)
            c15 = cp_zf(1,5,jzf)
            
            c21 = cp_zf(2,1,jzf)
            c22 = cp_zf(2,2,jzf)
            c23 = cp_zf(2,3,jzf)
            c24 = cp_zf(2,4,jzf)
            c25 = cp_zf(2,5,jzf)
            
            cx_zf(1,1,jzf) = c11 - kh_1 ( c11 , c21 ) 
            cx_zf(1,2,jzf) = c12 - kh_1 ( c12 , c22 )
            cx_zf(1,3,jzf) = c13 - kh_1 ( c13 , c23 )
            cx_zf(1,4,jzf) = c14 - kh_1 ( c14 , c24 )
            cx_zf(1,5,jzf) = c15 - kh_1 ( c15 , c25 )
            
            cx_zf(2,1,jzf) = cx_zf(1,2,jzf)
            cx_zf(2,2,jzf) = cp_zf(2,2,jzf) - kh_2 ( c12 , c22 )
            cx_zf(2,3,jzf) = cp_zf(2,3,jzf) - kh_2 ( c13 , c23 )
            cx_zf(2,4,jzf) = cp_zf(2,4,jzf) - kh_2 ( c14 , c24 )
            cx_zf(2,5,jzf) = cp_zf(2,5,jzf) - kh_2 ( c15 , c25 )
            
            cx_zf(3,1,jzf) = cx_zf(1,3,jzf) 
            cx_zf(3,2,jzf) = cx_zf(2,3,jzf)
            cx_zf(3,3,jzf) = cp_zf(3,3,jzf) - kh_3 ( c13 , c23 )
            cx_zf(3,4,jzf) = cp_zf(3,4,jzf) - kh_3 ( c14 , c24 )
            cx_zf(3,5,jzf) = cp_zf(3,5,jzf) - kh_3 ( c15 , c25 )
            
            cx_zf(4,1,jzf) = cx_zf(1,4,jzf) 
            cx_zf(4,2,jzf) = cx_zf(2,4,jzf)
            cx_zf(4,3,jzf) = cx_zf(3,4,jzf)
            cx_zf(4,4,jzf) = cp_zf(4,4,jzf) - kh_4 ( c14 , c24 )
            cx_zf(4,5,jzf) = cp_zf(4,5,jzf) - kh_4 ( c15 , c25 )
            
            cx_zf(5,1,jzf) = cx_zf(1,5,jzf) 
            cx_zf(5,2,jzf) = cx_zf(2,5,jzf)
            cx_zf(5,3,jzf) = cx_zf(3,5,jzf)
            cx_zf(5,4,jzf) = cx_zf(4,5,jzf)
            cx_zf(5,5,jzf) = cp_zf(5,5,jzf) - kh_5 ( c15 , c25 )
            
         else
            
            do ii=1,5
               do jj=1,5
                  cx_zf(ii,jj,jzf) = 0.
               enddo
            enddo
            
            do ii=1,5
               do jj=ii,5
                  sum = 0.
                  do kk=1,5
                     if (ii.eq.kk) then
                        sum = sum +
     +                       (1.d0 - kalman(ii,1) * h_zf(1,kk,jzf)) 
     +                       * cp_zf(kk,jj,jzf)
                     else
                        sum = sum - kalman(ii,1) * h_zf(1,kk,jzf) 
     +                       * cp_zf(kk,jj,jzf)
                     endif
                  enddo
                  cx_zf(ii,jj,jzf) = sum
                  if (ii.ne.jj) cx_zf(jj,ii,jzf) = sum
               enddo
            enddo
         end if
         
         
*     print *,'jzf izf N_h cx44',jzf,N_h_zf,cx_zf(4,4,jzf)

         if (cx_zf(4,4,jzf).lt.0.d0) then
            print *,' () tffilm: cr_p, jzf=', cr_p, jzf
            cr_p = 0.d0         ! try fix, track should not be continued
            
            print '(/"in izf z",i3,f9.3)',izf,z_zf(izf)
            print '("pin:",5(e11.4))',(xp_zf(ii,izf),ii=1,5)
            print '("cp 1:",5(e11.4))',(cp_zf(1,ii,jzf),ii=1,5)
            print '("cp 2:",5(e11.4))',(cp_zf(2,ii,jzf),ii=1,5)
            print '("cp 3:",5(e11.4))',(cp_zf(3,ii,jzf),ii=1,5)
            print '("cp 4:",5(e11.4))',(cp_zf(4,ii,jzf),ii=1,5)
            print '("cp 5:",5(e11.4))',(cp_zf(5,ii,jzf),ii=1,5)
            
            print '(/"out jzfz",i3,f9.3,f9.3)',jzf,fhitb_z(ih),z_zf(jzf)
            print'(/"h,ige",f9.3,f9.3,i3)',h_1,h_2,igede_cmp(jpl)
            print'(/"hit,cm,hch",f9.3,f9.3,f9.3)'
     +           ,fhitb_r(ih),cm_zf(1,1,jzf),hch
            
            print '(/"k1. ",5(1x,f8.3))',k_1,k_2,k_3,k_4,k_5
            
            print '("pou:",5(e11.4))',(xp_zf(ii,jzf),ii=1,5)
            print '("cx 1:",5(e11.4))',(cx_zf(1,ii,jzf),ii=1,5)
            print '("cx 2:",5(e11.4))',(cx_zf(2,ii,jzf),ii=1,5)
            print '("cx 3:",5(e11.4))',(cx_zf(3,ii,jzf),ii=1,5)
            print '("cx 4:",5(e11.4))',(cx_zf(4,ii,jzf),ii=1,5)
            print '("cx 5:",5(e11.4))',(cx_zf(5,ii,jzf),ii=1,5)
            
         endif

#ifdef Y_TARGET_CHECK
*        ****   check of track continuation in target
         
         if(fhitb_z(ih).lt.450.) then
            y_targ = xx_zf(2,jzf) - fhitb_z(ih) * xx_zf(4,jzf)
            sy_targ = cx_zf(4,4,jzf) 
            sy_targ = sqrt(sy_targ) * fhitb_z(ih)
            sy_targ = y_targ / sy_targ
            if(abs(sy_targ).gt.4.) go to 10
         endif
#endif
                  
*     **** updated residual
         
         if(N_h_zf.eq.1) then
            ihk = 1. - h_zf(1,1,jzf) * kalman(1,1)
         else if(N_h_zf.eq.2) then
            ihk = 1. - h_zf(1,1,jzf) * kalman(1,1)
     +           - h_zf(1,2,jzf) * kalman(2,1)
         else  
            
            ihk = 1. - h_zf(1,1,jzf) * kalman(1,1)
     +           - h_zf(1,2,jzf) * kalman(2,1)
     +           - h_zf(1,3,jzf) * kalman(3,1)
     +           - h_zf(1,4,jzf) * kalman(4,1)
     +           - h_zf(1,5,jzf) * kalman(5,1)
         end if
         
         xr_zf(1,jzf) = xr_p * ihk
         cr_zf(1,1,jzf) = cm_zf(1,1,jzf) * ihk
         
*     **** updated chi2 contribution
         ch_zf(jzf) = xr_zf(1,jzf)**2 / cr_zf(1,1,jzf)
         
         if (diag_level.ge.5) then
            print *,'>ihk, xr_zf(1,jzf), cr_zf(1,1,jzf), ch2=',
     +           ihk, xr_zf(1,jzf), cr_zf(1,1,jzf), ch_zf(jzf)
         endif
         
*     **** cut on chi**2 contribution
         
         if (ch_zf(jzf).gt.chmax_mag_zfpar) then
            go to 10
         endif
         
#ifdef OLDCHECK
*     **** check if hit is really inside plane
*     *       x_margin = 2.
*     *       y_margin = 2.
         x_margin = dsqrt(chmax_mag_zfpar*cx_zf(1,1,jzf))
         y_margin = dsqrt(chmax_mag_zfpar*cx_zf(2,2,jzf))
         if(x_margin.gt.2.) x_margin = 2.
         if(y_margin.gt.2.) y_margin = 2.
         y_border = xx_zf(1,jzf) * fgede_rot(2,jpl)
     +        + xx_zf(2,jzf) * fgede_rot(1,jpl)
         if (y_border.lt.(fgede_symn(jpl)-y_margin)) go to 10
         if (y_border.gt.(fgede_symx(jpl)+y_margin)) go to 10
         x_border = xx_zf(1,jzf) * fgede_rot(1,jpl)
     +        - xx_zf(2,jzf) * fgede_rot(2,jpl)
         if (igede_shp(jpl).eq.10) x_border = x_border 
     +        - y_border * fgede_sin(jpl) / fgede_cos(jpl)
         if (x_border.lt.(fgede_sxmn(jpl)-x_margin)) go to 10
         if (x_border.gt.(fgede_sxmx(jpl)+x_margin)) go to 10
#endif
         
         
#ifdef NEW_Y_CHECK
*     **** check if hit is really inside plane
         y_margin = dsqrt(chmax_mag_zfpar*cx_zf(2,2,jzf))
         if(y_margin.gt.2.) y_margin = 2.
         y_border = xx_zf(1,jzf) * fgede_rot(2,jpl)
     +        + xx_zf(2,jzf) * fgede_rot(5,jpl)
         if (y_border.lt.(fgede_symn(jpl)-y_margin)) go to 10
         if (y_border.gt.(fgede_symx(jpl)+y_margin)) go to 10
#endif
         
*     **** accept hit
         hit_zf(jzf)   = ih
         nhit_zf(jzf) = nhit_zf(izf) + 1
         plane_zf(jzf) = ihitb_gede(ih)
         cmp = igede_cmp(plane_zf(jzf))
         if (cmp.le.maxcmp_zfpar) then
            whit_zf(jzf) = whit_zf(izf) + whit_cmp_zfpar(cmp)
         else
            whit_zf(jzf) = whit_zf(izf) + 1.
         endif
         domlay_zf(jzf) = dlnext
         z_zf(jzf) = fhitb_z(ih)
         cht_zf(jzf) = cht_zf(izf) + ch_zf(jzf)
         sign_zf(jzf) = xsig
         prev_zf(jzf) = izf
         fault_zf(jzf) = 0
         pfault_zf(jzf) = fault_zf(izf)
         dim_zf(jzf) = 1
         shadow_zf(jzf) = 0
         n_zf = n_zf + 1
         
         izfnew = jzf

*     **** fill candidate info
         if (nca_ft.ge.ncamx) then
            print *,' () tffilm: candidate overflow, nca_ft=', nca_ft
            go to 999
         endif
         nca_ft = nca_ft + 1
         jft = nca_ft
         first_ft(jft) = first_ft(ift)
         if (diag_level.ge.5) print *,' clone candidate, jft=', jft
         nhit_ft(jft)     = nhit_zf(jzf)
         last_ft(jft)     = jzf
         prev_ft(jft)     = prev_ft(ift)
         gen_ft(jft)      = gen_ft(ift) + 1
         nfault_ft(jft)   = nfault_ft(ift)
         quality_ft(jft)  = quality_ft(ift)
     +        + 1.              ! bonus for new hit
     +        - wchi_mag_zfpar * ch_zf(jzf) ! malus for chi2
         
*     with this statement efficiency become smaller
*     if(igede_cmp(jpl).eq.1.or.igede_cmp(jpl).eq.3)
*     + quality_ft(jft)  = quality_ft(jft) + 0.5 ! bonus for MGS or silicon    
         
         alive_ft(jft)    = .true.
         mature_ft(jft)   = .false.
         stat_ft(jft) = stat_ft(ift)
         
         descend(jft) = ift_descend
         ift_preced(jft) = ift
         
**      print '("new,ift,z,w,ch",2(i4),3(f8.3))'
**     +        ,jft,ift,z_zf(jzf),whit_zf(jzf),ch_zf(jzf)
                  
 10   continue
      
      istat = 0
      
 999  end
