*-- Author :    Rainer Mankel   01/04/96
*-- changed:    A.Spiridonov    20/03/98
*   check of slt_mode_zfpar when initialize           03/09/00  A. Spiridonov
*   exclude flag #NEWNAV                              04/11/00  A. Spiridonov
*   delete obsolete code                              04/12/00  A. Spiridonov
*   quality_ft(ift).le.qualmin_y_zfpar for magnet propagation
*   call tfclusy() instead of tfcontyn()              08/04/01  A. Spiridonov
*   use of option fast_mode_zfpar
*   if ((rlevel_zfpar.eq.2.or.rlevel_zfpar.eq.5).and. 12/06/01  A. Spiridonov
*


*#define TFMATRIPN_DEBUG

      subroutine tfmatripn(istat)

*     **** mother routine for seed studies
      implicit none
#include "rang/zfmode.fi"
#include "rang/zfpar.fi"
#include "rang/zf.fi"
#include "rang/ztripl.fi"
#include "rang/zcut.fi"
#include "pris/zpstat.fi"
#include "arte/ArteFlag.fi"
#include "arte/Arte.fi"
#include "auto/RSEG.fi"

#include "rang/descend.fi"
#include "rang/FLAGWhit.hh"

      integer maxseed
      parameter (maxseed=50)
      integer vseed(maxseed),vseedw(maxseed),winw
      integer nseed,nseedw
      integer jseed,jtabl,rgnavig,rgswin,win

      integer ntot,ngood,mc,ift,izf,nhits,clus,iclus,
     +      dl,dw,nca_x,dom,direction,pc,run_level,nca_y,n_good,
     +      begin_store,jft,ft_good,istat,nca_prep

      integer if_prep     

      real ef
      logical init, lstore

      integer maxtabl
      parameter (maxtabl=5)
      integer vtabl(maxtabl),dirtabl(maxtabl)
      integer ntabl
      integer itabl
      integer rgdlwin

      save init
      data init /.false./

#ifdef TFMATRIPN_DEBUG
      integer tumchit
      integer nrseg1
#endif



#include "arte/Arte.ff"
#include "auto/RSEG.ff"


******************************************************************
*
*     Organization of storage:
*
*           1                  |
*           .                  | x candidates
*           .                  |
*         nca_x                |
*           .                   |
*           .                   | y candidates, 3d candidates
*         nca_y                 |
*           .                    |
*           .                    | magnet seeds
*         nca_prep               |
*           .                     |
*           .                     | magnet candidates
*           .                     |
*
******************************************************************

      call rginit()
      if (.not.l_rinit) call tfrinit() ! restricted init

      l_term = .false.
      lremzc = .false.

*     **** should we clear the track bank ??

*     **** do the work
      if (.not.init) then
         call rgdom()           ! set up domain structure
         init = .true.
      endif

      call rghlevnt()

      call rgstabl(maxtabl,vtabl,dirtabl,ntabl)

      do itabl=1,ntabl


#ifdef TFMATRIPN_DEBUG
         print *,"matripn: ||||||||||||||||||||| itabl ", itabl
#endif

         call tftripxn(vtabl(itabl),dirtabl(itabl))
         direction = dirtabl(itabl)

         do 10 iclus=1,nclusx
            clus = indclus(iclus)

**            print *,'--------------------------------------------'
**            print *,' propagate cluster ', clus
**            print *,'--------------------------------------------'

            call rgmondls(dl_set(trip1_clus(clus)),0)

            call tfclr()
            begin_ft = 1

            call tfpropcxn(clus,direction) ! propagate

            call tfbest()
            nca_x = nca_ft
            l_mag = .false.

            n_good = 0
            ft_good = 0
            do jft=1,nca_x
               if (alive_ft(jft)) then
                  if (quality_ft(jft).gt.qualmin_x_zfpar) then
                     n_good = n_good + 1
                     ft_good = jft

                     call rgmondls(domlay_zf(first_ft(jft)),1)
                  endif
               endif
            enddo

#ifdef TFMATRIPN_DEBUG
**            if(ngood.gt.0) then
**               print *,' after horizontal tracking '
**               print *,' ....n_good =',n_good,' ft_g= ',ft_good
**     +              ,' mc1,2 ',tumchit(hit_zf(first_ft(ft_good))) 
**     +              ,tumchit(hit_zf(last_ft(ft_good))) 
**     +              ,' z1,z2 ',z_zf(first_ft(ft_good)) 
**     +              ,z_zf(last_ft(ft_good)) 
**            endif
#endif

            if (rlevel_zfpar.le.1) go to 9

*           **** vertical continuation
            begin_ft = nca_x + 1
            n_good = 0
            do 20 ift=1,nca_x
               if (alive_ft(ift)) then
                  if (quality_ft(ift).lt.qualmin_x_zfpar) then
                     alive_ft(ift) = .false.
                     go to 20
                  endif
                  if (diag_level.ge.3) then
                     call tflft(ift,' ')
                     call tfparmft(ift)
                     if (diag_level.ge.5)
     +                    print *,' before tfsasegx,ift=', ift
                     if (l_diag) call tfwait()
                  endif

                  call tfsasegxn(ift) ! save x-projection

                  dl = dl_set(s_trip(1,trip1_clus(clus))) ! get dom lyer
                  dw = rgdlwin(dl) ! get domain window

#ifdef TFMATRIPN_DEBUG
                  print *,'-h-h-h-h-h- ift,mc,z1,2'
     +                 ,ift,tumchit(hit_zf(first_ft(ift)))
     +                 ,tumchit(hit_zf(last_ft(ift)))
     +                 ,z_zf(first_ft(ift)),z_zf(last_ft(ift))
     +                 ,' x1,2 ',xx_zf(1,first_ft(ift))
     +                 ,xx_zf(1,last_ft(ift))
     +                 ,' tx1,2 ',xx_zf(3,first_ft(ift))
     +                 ,xx_zf(3,last_ft(ift))

                  print *,'matripn: contyn -<>-<>-<>-<>- ift',ift
#endif

                  nseedw = 0
**                  call tfcontyn          
**     +                 (dw,vtabl(itabl),direction,nseedw,vseedw) 
*%%%
                  call tfclusy          
     +                 (dw,vtabl(itabl),direction,nseedw,vseedw) 

                  ngood = 0
                  do jft=nca_x+1,nca_ft
                     if (alive_ft(jft)) then
                        if (quality_ft(jft).gt.qualmin_y_zfpar) then
                           n_good = n_good + 1
                        endif
                     endif
                  enddo

                  if (n_good.ge.1) go to 20

#ifndef ALTVERT

*                 **** try alternate vertical seeding set
                  do 50 jtabl=1,ntabl
                     if (jtabl.eq.itabl) go to 50
#ifdef TFMATRIPN_DEBUG
                     print *,' tfmatripn: -X-X-X-X-X alter. seed set',
     +                       ' jtabl,itabl,ntabl ',jtabl,itabl,ntabl
#endif

                     call rgtabss(vtabl(jtabl),2,maxseed,vseed,nseed)
                     nseedw = 0
                     do jseed=1,nseed
                        win = rgswin(vseed(jseed))

                        if (rgnavig(win).eq.1) then
                           winw = win
                           nseedw = nseedw + 1
                           vseedw(nseedw) = vseed(jseed)
**                           print *,'tfmatripn.F: nseedw,vseedw(nseedw)'
**     +                          ,nseedw,vseedw(nseedw)

                        endif
                     enddo
                     
                     if(nseedw.le.0) go to 50
                                          
**                     call tfcontyn (winw,vtabl(jtabl),dirtabl(jtabl)
**     +                    ,nseedw,vseedw)

*%%%
                     call tfclusy (winw,vtabl(jtabl),dirtabl(jtabl)
     +                    ,nseedw,vseedw)

                     do izf=nca_x+1,nca_ft         
                        if (alive_ft(izf)) then
                           if (quality_ft(izf).ge.qualmin_y_zfpar) then 
#ifdef TFMATRIPN_DEBUG 
                              print *,'=S=S=S=S= store ift,nresgp '
     +                             ,izf,nrseg()
     +                             ,' z1,z2 ',z_zf(first_ft(izf))
     +                             ,z_zf(last_ft(izf))
     +                             ,prev_ft(izf)
#endif
                              go to 20
                           endif
                        endif
                     enddo  

 50               continue

                  if(fast_mode_zfpar) call tfkill(ift) ! kill x-projection ift
#endif

**                  ngood = 0
**                  do jft=nca_x+1,nca_ft
**                     if (alive_ft(jft)) then
**                        if (quality_ft(jft).lt.qualmin_y_zfpar) then
**                           n_good = n_good + 1
**                        endif
**                     endif
**                  enddo
**                  print *,' ............n_good =',n_good
               endif

 20         continue  ! x candidates

            begin_ft = nca_x + 1
            call tfbest()       ! optimize vertical

            nca_y = nca_ft

**            print *,' vertical completion done, n_good=',n_good
*%%%                                             to be uncommented
**            call tfwait()
**            if (n_good.eq.0) go to 10

*           **** 3D processing
            n_good = 0
            do 30 ift=nca_x+1,nca_y
               if (alive_ft(ift)) then
                  if (quality_ft(ift).lt.qualmin_y_zfpar) then
                     alive_ft(ift) = .false.
                     go to 30
                  else                     
                     n_good = n_good + 1
                  endif

                  if (diag_level.ge.3) then
                     print *,' tfmatrip: vertical completion',
     +                    ' successful ',
     +                    ' ift=', ift
                     call tflft(ift,' ')
                     call tfparmft(ift)
                     if (l_diag) call tfwait()
                  endif
#ifdef OPTI
*                 **** check overlap with existing tracks
                  lstore = .true.
**                  call tfopti(ift,lstore)
                  if (lstore) then
                     call tfsmfin(ift)
                     if (diag_level.ge.3) then
                        print *,' tfmatrip: after smoothing...'
                        call tflft(ift,' ')
                        call tfparmft(ift)
                     endif
                     call tfstor(ift)
                     if (l_diag) call tfwait()
                  endif
#else
                  call tflfit(ift)   
#endif

               endif
 30         continue            ! 3D process loop

**            print *,' 3D processing done, n_good=', n_good
*%%%                                             to be uncommented
**            if (n_good.le.0) go to 10

            if (rlevel_zfpar.le.2.or.rlevel_zfpar.eq.5) go to 9

*           **** magnet continuation

            if_prep = 0
            do ift=nca_x+1,nca_y
               if (alive_ft(ift)) then
                  mature_ft(ift) = .false.
                  istat = 0
                  call tfmprep(ift,istat) ! prepare for magnet tracking
                  if(istat.eq.0) if_prep = if_prep + 1

**                  call tflft(ift,' ')
**                  print *,' tfmatrip: before magnet, nca_ft=',nca_ft
**                  call tfwait()            

               endif
            enddo

            if(if_prep.eq.0) go to 10

*%%%
**            print *,'tfmatripn.F: if_prep ',if_prep

            nca_prep = nca_ft   ! store new endpointer

            l_2dx = .false.
            l_2dy = .false.
            l_mag = .true.
            begin_ft = nca_prep + 1
            istat = 0

            call tfpropmn(nca_y+1,-1,istat)
            if (istat.ge.0) then
            elseif (istat.le.-100) then
               go to 999        ! no further propagation
            elseif (istat.le.-1) then
               go to 10         ! terminate branch
            endif

            if (diag_level.ge.2) then
               call tfl()
               print *,' after tfpropm,before tfbest'
               call tfwait()
            endif
            begin_ft = nca_prep + 1
            call tfbest()
            if (diag_level.ge.3) then
               call tfl()
               print *,' after tfbest'
               call tfwait()
            endif

*           **** store loop
 9          continue
            if (rlevel_zfpar.eq.1) then
               begin_store = 1
**            elseif (rlevel_zfpar.ge.2) then
            elseif (rlevel_zfpar.eq.2.or.rlevel_zfpar.eq.5) then
               begin_store = nca_x + 1
            elseif (rlevel_zfpar.eq.3.or.rlevel_zfpar.eq.4) then
               begin_store = nca_y + 1
            else
               begin_store = nca_prep + 1
            endif

**            print *,'matrip begin_store,nca_x,nca_y,nca_ft=',
**     +           begin_store,nca_x,nca_y,nca_ft

            do 40 ift=begin_store,nca_ft         
               if (alive_ft(ift)) then

#ifdef TFMATRIPN_DEBUG
                  nrseg1 = nrseg()
#endif

                  if ((rlevel_zfpar.eq.2.or.rlevel_zfpar.le.5).and.
     +                 quality_ft(ift).lt.qualmin_y_zfpar) go to 40 
**                  if ((rlevel_zfpar.ge.2.and.rlevel_zfpar.le.5).and.
**     +                 quality_ft(ift).lt.qualmin_y_zfpar) go to 40 
                                  
                  call tfstor(ift)

#ifdef TFMATRIPN_DEBUG
**                  call tfmagft(ift)
                  if(nrseg().gt.nrseg1 ) then 
                     print *,'.--  store nrsef ',nrseg() 
                  endif
#endif

#ifdef TFMATRIPN_DEBUG_DETAIL
                  if(nrseg().gt.nrseg1 ) then
                     print *,'.-.-.-.-.-  store ift,nseg,nh,w,q '
     +                    ,ift,nrseg(),nhit_zf(last_ft(ift))
     +                    ,whit_zf(last_ft(ift)),quality_ft(ift)
**     +                    ,(prev_ft(ift))
     +                    ,' OK '
                  else
                     print *,'.-.-.-.-.-  store ift,nseg,nh,w,q '
     +                    ,ift,nrseg(),nhit_zf(last_ft(ift))
     +                    ,whit_zf(last_ft(ift)),quality_ft(ift)
     +                    ,' -- '
                  endif
#endif

#ifdef TFMATRIPN_DEBUG
*%%%
                  print *,'=O=O=O=O=O=O= store ift,nresg ',ift,nrseg()
     +                 ,' mc1,2 ',tumchit(hit_zf(first_ft(ift))) 
     +                 ,tumchit(hit_zf(last_ft(ift))) 
     +                 ,' z1,z2 ',z_zf(first_ft(ift))
     +                 ,z_zf(last_ft(ift))
     +                 ,' prev ',prev_ft(ift)
#endif
                  if (l_diag) call tfwait()
               endif
 40         continue

 10      continue               ! x clusters

      enddo                     ! enddo on tables 

 999  end
