*-- Author :    A.Spiridonov    10/07/98
*   changed : call of rghlcrd() ( unlock hits in TC)  12.11.00 A. Spiridonov
*   remove flag NEWNAV                                14.03.01 A. Spiridonov
*   remove check of diff_x in loop on hits
*
*#define TCPRON_DEBUG

      subroutine tftcpron(ift1,direction,istat)
*
*     3D track-follow in TC chambers of all alive seeds in /zf/  
*
      implicit none

#include "rang/zf.fi"
#include "rang/zfmode.fi"
#include "rang/zfpar.fi"
#include "rang/zfpar_tc.fi"
#ifndef NEWNAV
#include "rang/zdomain.fi"
#else 
#include "rang/zdb.fi"
#endif
#include "rang/zplx.fi"
#include "arte/Arte.fi"
      integer nmax
      parameter (nmax=30)
      integer target_vec(nmax),n_target,tumchit,domlay,dlnext
      integer ift1,ift,izf,ipl,icycle,method,ncan,ii,jj,
     +     zone,iplnext,imust,izfnew,nhl,nhlmx,ihl,dom
      real x_pred,y_pred,dx_window,dy_window,dz,diff_x,window_size
      parameter (nhlmx=100)
      integer hl(nhlmx),nca_now,to_be_grown,direction,istat
      logical continued
      
      integer dlold, precold, dompointer, rgdomnb, rgdldom, rgdlwin
      real xmin,xmax,ymin,ymax,zdom
      real rgzlay, rgzdom
      
#include "rang/descend.fi"
      
      logical electron
      
      integer mcout
      real fracout
      
#include "auto/GEO.fi"
#include "auto/HITB.fi"
#include "rang/sfdef.fi"
#include "arte/Arte.ff"
#include "auto/GEO.ff"
#include "auto/HITB.ff"
#include "rang/sf.fi"
      
      dlold = 0
      precold = 0
      
*     **** loop over growth cycles
      istat = 0
      
      do ii=ift1,ncamx
         descend(ii)=0
      end do
*     
      do 10 icycle=1,99
         
*     **** loop over present number of track candidates
         
         nca_now = nca_ft
         begin_ft = nca_ft + 1
         to_be_grown = 0
         do 20 ift=ift1,nca_now
            if (.not.alive_ft(ift)) go to 20
            if (mature_ft(ift))     go to 20
            
            if(descend(ift).ne.0) then     
               ift_descend = descend(ift)
            else
               ift_descend = ift
            end if
            
            to_be_grown = to_be_grown + 1
            
            if (diag_level.ge.5) then
               print *,' <<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<< '
               print *,' << track candidate ', ift, '             <<'
               print *,' <<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<< '
            endif
            
#ifdef TCPRON_DEBUG
            print *,'tftcpron.F: <<<<<<< track candidate ift ', ift
#endif

*     **** loop over planes in zone
            
            izf = last_ft(ift)
            ipl = plane_zf(izf)
            domlay = domlay_zf(izf)
            zone = fault_zf(izf) + 1
            ncan = 0
            continued = .false.
            method = 1          ! 3D    tracking
            
            if (diag_level.ge.6) then
               print *,' tftcpro: call tfdzone for domlay=', domlay,
     +              '  zone=', zone
            endif
            
            n_target = 0
            call rgzone(domlay,method-1,zone,direction,4,4,1,nmax,
     +           target_vec,n_target)
            
#ifdef TCPRON_DEBUG
            print *,' tftcpron: rgzone returns n_target=',n_target
#endif
*     
            if (diag_level.ge.5) then
               print *,' zone=', zone
               print '(6((a),i5))',
     +              'tftcpro: for ipl=',ipl,' dl=',domlay,
     +              ' meth=',method,
     +              ' zone=',zone,
     +              ' nmax=',nmax,' we get n_target=', n_target
            endif
*     
            do dom=1,maxdom_dm  ! reset prediction buffer
               filled_db(dom) = .false.
            enddo
*     
            do 30 ii=1,n_target
               dlnext = target_vec(ii)
               if (diag_level.ge.5) print *,' tftcpro: next target='
     +              , dlnext
#ifdef TCPRON_DEBUG
               print *,' tftcpron: ii,dlnext=',ii,dlnext
#endif
*     **** check if plane is within scope
*     **** check if window is intersected
               
               dz = rgzlay(dlnext) -  z_zf(izf)
               dompointer = rgdldom( dlnext)
               dom = rgdomnb( dompointer )
               zdom = rgzdom( dompointer )

#ifdef TCPRON_DEBUG
*     *               print *,' tftcpro: next target in domnb=',dom,' z=',zdom
*     *               print *,' ..............window '
*     *               call rgwidmp(rgdlwin(dlnext))
*     *               call rgdldmp(dlnext)
#endif
               
****  check electron identification
               
               electron = electron_id(ift_descend)   
               electron = .false.
               if (.not.filled_db(dom)) then
                  
                  x_pred = xx_zf(1,izf)+xx_zf(3,izf)*(zdom-z_zf(izf))
                  y_pred = xx_zf(2,izf)+xx_zf(4,izf)*(zdom-z_zf(izf))
                  
#ifdef TCPRON_DEBUG
                  print '("tftcpron : izf,zdom,x,y ",i4,3(x,f8.3))'
     +                 ,izf,zdom,x_pred,y_pred
#endif
                  filled_db(dom) = .true.
               end if
*     
               dx_window = 5.
               dy_window = 20.0
               
               call rgdlwbord(dlnext,xmin,xmax,ymin,ymax)
#ifdef TCPRON_DEBUG
               print '("tftcpron: x1/x/x2,dxw ",4(x,f8.3) )'
     +              ,xmin,x_pred,xmax,dx_window
#endif
               if (x_pred.lt.(xmin-dx_window).or.
     +              x_pred.gt.(xmax+dx_window)) go to 30
#ifdef TCPRON_DEBUG
               print '("tftcpron: y1/y/y2,dyw ",4(x,f8.3) )'
     +              ,ymin,y_pred,ymax,dy_window
#endif
               if (y_pred.lt.(ymin-dy_window).or.
     +              y_pred.gt.(ymax+dy_window)) go to 30
               
#ifdef TCPRON_DEBUG
               print '("tftcpro :   test OK, dlnext",i9)',dlnext
*     *   if (.not.filled_db(dom)) call tftctrand(izf,dom,electron,istat)
#endif

*     **** can/must plane found
               
               ncan = ncan + 1
               
*     **** loop over hits
               
**               if (dlnext.ne.dlold.or.ift_preced(ift).ne.precold) then
               if (dlnext.ne.dlold) then
                  dlold = dlnext
                  precold = ift_preced(ift)
                  nhl = 0                  
*     *                  call rghlcr(dlnext,3,dble(z_zf(izf)),
                  call rghlcrd(dlnext,3,dble(z_zf(izf)),
     +                 xx_zf(1,izf),xx_zf(2,izf),
     +                 xx_zf(3,izf),xx_zf(4,izf),
     +                 nhlmx,hl,nhl)

#ifdef TCPRON_DEBUG
                  print *,' tftcpro: nhl,hl '
     +                 ,nhl,(hl(jj),jj=1,nhl)
#endif
               endif
               
               if (diag_level.ge.6) print *,' tftcpro: hitlist nhl= ',
     +              nhl
di/sty
               do 40 ihl=1,nhl
                  
                  if (diag_level.ge.6) then
                     print *,' tftcpro: hitlist ihl=', ihl, 
     +                    ' hit=', hl(ihl),
     +                    ' imc=', tumchit(hl(ihl))
                  endif
                  
                  iplnext = ihitb_gede(hl(ihl))
                  
                  izfnew = 0
                  istat = 0                     
                  call tftcfil(hl(ihl),dlnext,iplnext,ift,izf,izfnew
     +                 ,istat)
                  if (istat.le.-100) go to 999
                  if (istat.le.-1) go to 40
                  if (izfnew.gt.0) continued = .true.
#ifdef TCPRON_DEBUG
*     *                     print *,' --> izfnew = ',izfnew
*     *                     if (izfnew.gt.0) print *,
*     *     +                    ' number of hits=',nhit_zf(izfnew)
#endif
                  
 40            continue         ! hits in hitlist
*     
 30         continue            ! planes in zone
*     
*     **** allow fault on old candidate
            if (fault_zf(izf).lt.maxflt_tc_zfpar) then
               fault_zf(izf) = fault_zf(izf) + 1
               nfault_ft(ift) = nfault_ft(ift) + 1
            else
*     **** kill or freeze old candidate
               if (whit_zf(izf).lt.whitmin_tc_zfpar) then
*     *               print *,' tftcpro: whitmin cut removed'
*     *               if (whit_zf(izf).lt.0) then
                  alive_ft(ift) = .false.
               else
                  mature_ft(ift) = .true.
                  stat_ft(ift) = 6
               endif
            endif
            if (diag_level.ge.5) call tfl()
*     
 20      continue
*     
*     print * ,'                                      call tfeed'
         
         call tftcweed
*     
         if (diag_level.ge.4) then
            print *,' **********************************************'
            print *,' *                                            *'
            print *,' *                                            *'
            print *,' *           E  N  D     O  F                 *'
            print *,' *                                            *'
            print *,' *           G  R  O  W  T  H                 *'
            print *,' *                                            *'
            print *,' *            C  Y  C  L  E                   *'
            print *,' *                                            *'
            print *,' *                                            *'
            print *,' **********************************************'
            call tfl()
            if (l_diag) call tfwait()
         endif

         if (to_be_grown.le.0) go to 11
*
 10   continue
*     
      print *,' () tftcpro: loop ends ii=99'
      
 11   if (diag_level.ge.4) then
         call tfl()
         print *,' **** end growing of seed **** '
      endif
      
      if (l_diag) call tfwait()
      
 999  end
