*-- Author :    A. Spiridonov   17/07/98
*-- changed :
*   cp_zf(2,2,jzf) = cp_zf(2,2,jzf) + sx * 10.        18.03.01  A.Spiridonov
*   use 4 parammeters in state vector                  03/05/01 A.Spiridonov
*

*#define TCTRANZ_FULL 
#define NO_ALIGNMENT

      subroutine tftctranz(i_hit,izf,jzf,istat)

*     Transport parameters from izf in position of hit i_hit 
*     to produce Kalman filter prediction for hit 
*               ( tailored from tftranf ) 
*
*     fast version for transport matrix

      implicit none
#include "arte/Arte.fi"
      integer i_hit
      integer izf, jzf, istat, ii, jj, kk, ll,
     +        mm,iii,jjj,ndimmag,ipl,imc,mimp,nnmimp,target_domain
      parameter (ndimmag=5)
      double precision dz, z_target, z_domain, rrstart
      real pnoise, dnoise
      double precision sum, dzd

#include "rang/zf.fi"
#include "rang/zfpar.fi"
#include "rang/zfmode.fi"
#include "rang/zdomain.fi"
#include "rang/zcut.fi"
#include "rang/zma.fi"
#include "pris/hgmagnhelp.fi"

      double precision f (ndimmag,ndimmag), f1(ndimmag,ndimmag),
     +       f2(ndimmag,ndimmag)
      double precision x_border(ndimmag)

#include "auto/HITB.fi"
#include "auto/GEDE.fi"
#include "auto/GESL.fi"
#include "auto/MIMP.fi"

      double precision d_z,Tx,Ty
      integer if_last,if_start,if_update


      double precision f13,f24,x,y,z

      double precision FL_1

      double precision c11 , c12 , c13 , c14 
      double precision       c22 , c23 , c24 
      double precision             c33 , c34 
      double precision                   c44 
 
      double precision g11 , g12 , g13 , g14 
      double precision g21 , g22 , g23 , g24 
      double precision g31 , g32 , g33 , g34 
      double precision g41 , g42 , g43 , g44 

      equivalence (f13,f(1,3)),(f24,f(2,4))

      real s2_x,s2_t,cov_xt,sx,st,cxt    

#ifdef NO_ALIGNMENT
      data s2_x/4./,s2_t/2.8e-4/,cov_xt/2.4e-2/
#else
      data s2_x/1./,s2_t/0.69e-4/,cov_xt/0.59e-2/
#endif

      real st_TRD,ctx_TRD,sx_TRD
      data st_TRD/.74e-4/,ctx_TRD/.34e-2/,sx_TRD/0.20/

      integer message_id_1,message_id_2

#include "arte/Arte.ff"
#include "auto/HITB.ff"
#include "auto/GEDE.ff"
#include "auto/GESL.ff"
#include "auto/MIMP.ff"

      FL_1(x,y) = x + f13*y 

*
*================================================================

*
      istat = 0
      ipl = plane_zf(izf)

      d_z = fhitb_z(i_hit) - z_zf(izf)

      f13 = d_z

      if(dabs(cx_zf(3,4,izf)/dsqrt(cx_zf(3,3,izf)*cx_zf(4,4,izf)))
     +                                            .gt.1.d0)  then
        call mepric(message_id_1,1,'tftctranz : cx_zf(3,4) wrong')
#ifdef TCTRANZ_FULL
        print '("tftctranz z1,z2 ",f9.3,f9.3)',z_zf(izf),fhitb_z(i_hit)        
        print '("cxd 1:",5(e11.4))',(cx_zf(1,ii,izf),ii=1,5)
        print '("cxd 2:",5(e11.4))',(cx_zf(2,ii,izf),ii=1,5)
        print '("cxd 3:",5(e11.4))',(cx_zf(3,ii,izf),ii=1,5)
        print '("cxd 4:",5(e11.4))',(cx_zf(4,ii,izf),ii=1,5)
        print '("cxd 5:",5(e11.4))',(cx_zf(5,ii,izf),ii=1,5)
#endif
      end if

      if_update = 1

      if(cx_zf(3,3,izf)/cx_zf(1,1,izf)
     + * d_z * d_z .lt. 0.01) if_update = 0

*     **** spep 2 : propagate parameters    
*
        Tx = xx_zf(3,izf)
        Ty = xx_zf(4,izf)
        xp_zf(1,jzf) = xx_zf(1,izf) + Tx*d_z 
        xp_zf(2,jzf) = xx_zf(2,izf) + Ty*d_z 
        xp_zf(3,jzf) = Tx 
        xp_zf(4,jzf) = Ty 
        xp_zf(5,jzf) = xx_zf(5,izf)

*
*     **** step 3: propagate cov matrix

      pnoise = 1./dabs(xp_zf(5,jzf))
      pnoise = amax1(pnoise,1.)

      if(ipl.gt.0) then                                ! ipl > 0
        if (fgede_ms(ipl).gt.0.) then
         dnoise = 1.d0 * (fault_zf(izf) + 1) * fgede_ms(ipl) / pnoise**2
        elseif (igede_cmp(ipl).eq.3) then
*      **** temporary: use old MSGC value until new value available
         dnoise = 1.d0 * (fault_zf(izf) + 1) * 0.6750e-6 / pnoise**2
        else
         print *,' () tftctranZ: no fgede_ms for ipl=', ipl
         dnoise = 0.
        endif
*
      else                                             !  ipl =< 0
        dnoise  = 0.
      end if

      if(if_update.ne.0) then                   !  udate of covariance matrix

        if(ipl.gt.0) then                                ! ipl > 0
          if (fgede_ms(ipl).gt.0.) then
            dnoise = 1.d0 * (fault_zf(izf) + 1) * fgede_ms(ipl) / pnoise**2
          elseif (igede_cmp(ipl).eq.3) then
*         **** temporary: use old MSGC value until new value available
            dnoise = 1.d0 * (fault_zf(izf) + 1) * 0.6750e-6 / pnoise**2
          else
            print *,' () tftctranZ: no fgede_ms for ipl=', ipl
            dnoise = 0.
          endif
*
          c11 = cx_zf(1,1,izf)
          c12 = cx_zf(1,2,izf)
          c13 = cx_zf(1,3,izf)
          c14 = cx_zf(1,4,izf)
          c22 = cx_zf(2,2,izf)
          c23 = cx_zf(2,3,izf)
          c24 = cx_zf(2,4,izf)
          c33 = cx_zf(3,3,izf) + dnoise 
          c34 = cx_zf(3,4,izf)
          c44 = cx_zf(4,4,izf) + dnoise

        else                                     ! dummy hit
          
          c11 = cx_zf(1,1,izf) 
          c12 = cx_zf(1,2,izf)
          c13 = cx_zf(1,3,izf) 
          c14 = cx_zf(1,4,izf)
          c22 = cx_zf(2,2,izf) 
          c23 = cx_zf(2,3,izf)
          c24 = cx_zf(2,4,izf) 
          c33 = cx_zf(3,3,izf) 
          c34 = cx_zf(3,4,izf)
          c44 = cx_zf(4,4,izf)

        end if                                   ! end of ms corrections      

        g11 = FL_1( c11 , c13 )
        g12 = FL_1( c12 , c23 )  
        g13 = FL_1( c13 , c33 )
        g14 = FL_1( c14 , c34 )
         
        g21 = FL_1( c12 , c14 )
        g22 = FL_1( c22 , c24 )
        g23 = FL_1( c23 , c34 )
        g24 = FL_1( c24 , c44 )

        g31 = c13 
        g32 = c23 
        g33 = c33 
        g34 = c34 

        g41 =      c14             
        g42 =      c24             
        g43 =      c34             
        g44 =      c44                         

        cp_zf(1,1,jzf) = FL_1( g11 , g13 )
        cp_zf(2,1,jzf) = FL_1( g21 , g23 )
        cp_zf(3,1,jzf) = FL_1( g31 , g33 )
        cp_zf(4,1,jzf) = FL_1( g41 , g43 )
 
        cp_zf(1,2,jzf) = cp_zf(2,1,jzf)
        cp_zf(2,2,jzf) = FL_1( g22 , g24 )
        cp_zf(3,2,jzf) = FL_1( g32 , g34 )
        cp_zf(4,2,jzf) = FL_1( g42 , g44 )

        cp_zf(1,3,jzf) = cp_zf(3,1,jzf)
        cp_zf(2,3,jzf) = cp_zf(3,2,jzf)
        cp_zf(3,3,jzf) = g33 
        cp_zf(4,3,jzf) = g43 

        cp_zf(1,4,jzf) = cp_zf(4,1,jzf)
        cp_zf(2,4,jzf) = cp_zf(4,2,jzf)
        cp_zf(3,4,jzf) = cp_zf(4,3,jzf)
        cp_zf(4,4,jzf) = g44             

*       ****   momentum not updated
        cp_zf(5,1,jzf) = cx_zf(5,1,izf)
        cp_zf(5,2,jzf) = cx_zf(5,2,izf)
        cp_zf(5,3,jzf) = cx_zf(5,3,izf)
        cp_zf(5,4,jzf) = cx_zf(5,4,izf)             

        cp_zf(1,5,jzf) = cp_zf(5,1,jzf)
        cp_zf(2,5,jzf) = cp_zf(5,2,jzf)
        cp_zf(3,5,jzf) = cp_zf(5,3,jzf)
        cp_zf(4,5,jzf) = cp_zf(5,4,jzf)
        cp_zf(5,5,jzf) = cx_zf(5,5,izf)             
*
        if(ipl.eq.0) then            ! dummy hit , add mult.scat. in RICH

          pnoise = dabs(xp_zf(5,jzf))

          sx  = s2_x   * pnoise * pnoise
          st  = s2_t   * pnoise * pnoise   
          cxt = cov_xt * pnoise * pnoise
#ifdef NO_ALIGNMENT
          sx = sx + 0.5
#endif

*          print '("tftctranz : sx,st,cxt=",3(x,e10.3))',sx,st,cxt
        
          cp_zf(1,1,jzf) = cp_zf(1,1,jzf) + sx
        
          cp_zf(1,3,jzf) = cp_zf(1,3,jzf) + cxt
    
          cp_zf(2,2,jzf) = cp_zf(2,2,jzf) + sx * 10.
          
          cp_zf(2,4,jzf) = cp_zf(2,4,jzf) + cxt * 10.
          
          cp_zf(3,3,jzf) = cp_zf(3,3,jzf) + st
          
          cp_zf(4,4,jzf) = cp_zf(4,4,jzf) + st * 10.
        
        end if                   ! end of  mult.scat. in RICH

*                                ! mult.scat. in TRD                   

        if(fhitb_z(i_hit).gt.1250..and.z_zf(izf).lt.1250.) then
          if(  dabs(xp_zf(1,jzf)).lt.60.
     +    .and.dabs(xp_zf(2,jzf)).lt.60.) then

          pnoise = dabs(xp_zf(5,jzf))

          sx  = sx_TRD  * pnoise * pnoise
          st  = st_TRD  * pnoise * pnoise   
          cxt = ctx_TRD * pnoise * pnoise

*          print '("tftctranz : sx,st,cxt=",3(x,e10.3))',sx,st,cxt
        
          cp_zf(1,1,jzf) = cp_zf(1,1,jzf) + sx
        
          cp_zf(1,3,jzf) = cp_zf(1,3,jzf) + cxt
    
          cp_zf(2,2,jzf) = cp_zf(2,2,jzf) + sx
          
          cp_zf(2,4,jzf) = cp_zf(2,4,jzf) + cxt
          
          cp_zf(3,3,jzf) = cp_zf(3,3,jzf) + st
          
          cp_zf(4,4,jzf) = cp_zf(4,4,jzf) + st

          end if
        end if


      ELSE                       ! covariance matrix without update

        do ii=1,5
          do jj=1,5
            cp_zf(ii,jj,jzf) = cx_zf(ii,jj,izf)
          end do
        end do
*
      END IF                    ! end of cov matrix propagation
*
****                                    if(cp_zf(4,4,jzf).lt.0.) then
      if (cp_zf(4,4,jzf).lt.0.d0
     +  .or.dabs(cp_zf(3,4,jzf)/dsqrt(cp_zf(3,3,jzf)*cp_zf(4,4,jzf)))
     +  .gt.1.d0 ) then
        call mepric(message_id_2,1
     +  ,'tftctranz : cx_zf(3,4).lt.0 , ro(tx,ty).gt.1') 
#ifdef TCTRANZ_FULL
        print '(/"tftranZ : izf,z_zf(izf),ro(tx,ty)",i4,2(x,f8.3))'
     +         ,izf,z_zf(izf)
     +         ,cx_zf(3,4,jzf)/dsqrt(cx_zf(3,3,jzf)*cx_zf(4,4,jzf))
        print '("cx_zf 1:",5(e11.4))',(cx_zf(1,ii,izf),ii=1,5)
        print '("cx_zf 2:",5(e11.4))',(cx_zf(2,ii,izf),ii=1,5)
        print '("cx_zf 3:",5(e11.4))',(cx_zf(3,ii,izf),ii=1,5)
        print '("cx_zf 4:",5(e11.4))',(cx_zf(4,ii,izf),ii=1,5)
        print '("cx_zf 5:",5(e11.4))',(cx_zf(5,ii,izf),ii=1,5)

        print '("tftranZ : jzf,fhitb_z,ro(tx,ty)",i4,2(x,f8.3))'
     +         ,jzf,fhitb_z(i_hit)        
     +         ,cp_zf(3,4,jzf)/dsqrt(cp_zf(3,3,jzf)*cp_zf(4,4,jzf))
        print '("cp_zf 1:",5(e11.4))',(cp_zf(1,ii,jzf),ii=1,5)
        print '("cp_zf 2:",5(e11.4))',(cp_zf(2,ii,jzf),ii=1,5)
        print '("cp_zf 3:",5(e11.4))',(cp_zf(3,ii,jzf),ii=1,5)
        print '("cp_zf 4:",5(e11.4))',(cp_zf(4,ii,jzf),ii=1,5)
        print '("cp_zf 5:",5(e11.4))',(cp_zf(5,ii,jzf),ii=1,5)
#endif

      end if

      if (diag_level.ge.6) then
       print *,' tftranZ: dzd, izf, jzf=',d_z,izf,jzf
       print *,' tftranZ: xx_zf(,izf)=',(xx_zf(iii,izf),iii=1,5)
       print *,' tftranZ: cx_zf(,,izf)',
     +     ((cx_zf(iii,jjj,izf),iii=1,5),jjj=1,5)
       print *,' tftranZ: xp_zf=',(xp_zf(iii,jzf),iii=1,5)
       print *,' tftranZ: cp_zf=',
     +     ((cp_zf(iii,jjj,jzf),iii=1,5),jjj=1,5)
      endif

 999  return
      end
