*-- Author :    Rainer Mankel   22/03/96
*-- changed:    A. Spiridonov   20/10/99
*   sort cluster according to mult_clus                  05/11/00 A. Spiridonov
*   select triplet matching parameters according to cmp  30/04/01 A. Spiridonov
*

#define NEW_X_MAXHIT
#define NEW_TRIPLETX
*****************************#define DTXRES_ADD
*#define TFTRIPXN_DEBUG

      subroutine tftripxn(tabl,dir)

*     **** search triplets in 0-deg layers of domain

*     **** inspired by Christophs sort scheme
      implicit none
#include "rang/zdomain.fi"
#include "rang/ztripl.fi"
#include "arte/Arte.fi"
#include "rang/zfmode.fi"
#include "rang/zfpar.fi"
#include "auto/GEO.fi"
#include "auto/HITB.fi"

      real dxmax,dzmin,txmax,dtxmax,dxclus,dtxclus,zref,dz1,tx1,dz2,
     +        tx2,sum_z,dx,dtx,tx_nsig,dtxres
      integer lay,iih,idh,hitb,cmp,isig,ind1,ind2,ind3,s1,
     +     s2,s3,t1,t2,tlast,ii,jj,kk,set0,trip0,clus0,
     +     ref,trip,clus,t,trip_found,clus_found,n_z
      integer maxref
      parameter (maxref=1000)
      integer nref,vecref(maxref)
      integer maxhc
      parameter (maxhc=300)
      integer nhc,hit_hc(maxhc),indhc(maxhc),
     +     nhit_current,hc
      integer message_id_1, message_id_2 , message_id_3,
     +     message_id_4
      logical init
      integer tabl,dir
      integer maxseed,maxlay,maxhit
#ifndef NEW_X_MAXHIT
      parameter (maxseed=50,maxlay=6,maxhit=100)
#else
      parameter (maxseed=100,maxlay=6,maxhit=200) 
#endif
      integer vseed(maxseed),vlay(maxlay),vhit(maxhit)
      integer nseed,nlay,nhit
      integer iseed,ilay,ihit
      real rgzlay
#ifdef NEW_TRIPLETX 
      real aqp_test,qp_max,z_q,x_q,tx_q 
#endif 
#ifdef DTXRES_ADD
      real dtxres_add/0.005/
#endif
      data message_id_1 /1/,message_id_2 /2/,message_id_3 /3/,
     +     message_id_4 /4/
      data init /.false./
      save message_id_1, message_id_2, message_id_3,
     +     message_id_4, init

*%%%
      real sx,sy,sxx,sxy,det,x1,x2,x3,y1,y2,y3

      real dxclus_cmp(3),dtxclus_cmp(3)
      data dxclus_cmp/0.15, 0.06, 0.15/
**      data dtxclus_cmp/0.004, 0.02, 0.004/
      data dtxclus_cmp/0.004, 0.02, 0.001/
      integer cmp_trip

*%%%
#ifdef TFTRIPXN_DEBUG
      integer tumchit
#endif

#include "arte/Arte.ff"
#include "auto/GEO.ff"
#include "auto/HITB.ff"
#ifdef NEW_TRIPLETX
      aqp_test(z_q,x_q,tx_q) = abs(( x_q - tx_q * z_q )) * 0.003474276
#endif

      dxmax = 20.               ! maximum x difference for doublets
      dzmin = 0.1               ! minimum z difference for doublets
      txmax = 1.                ! maximum slope for doublets
      dtxmax = 0.02             ! maximum slope difference for triplets
      tx_nsig = 2.              !          ||   in sigmas
      
**    **** will be selected according to cmp
      dxclus = .06              ! maximum x  difference for cluster
      dtxclus = 0.02            ! maximum tx difference for cluster
      
      nset = 0                  ! reset hit set structure
      ntrip = 0
      nclus = 0
      nsetx = 0
      ntripx = 0
      nclusx = 0

      trip0 = ntrip  

#ifdef NEW_TRIPLETX  
      qp_max = qpmax_trip_zfpar
#endif

      call rgtabss(tabl,1,maxseed,vseed,nseed)

**      print *,' tftripxn: rgtabss returns nseed=',nseed

      do iseed=1,nseed
         call rgsdlay(vseed(iseed),maxlay,vlay,nlay)
*%%%
**         print *,'tftripxn: ******* is',iseed,' vs ', vseed(iseed)
**     +   ,' vl ',vlay(1),vlay(2),vlay(3)
   
**         print *,' tftripxn: iseed,rgdslay returns nlay=',iseed,nlay
        
         if (nlay.lt.3) go to 71

         if(iseed.eq.1) then
            sum_z = 0.
            n_z = 0
            do 40 ilay=1,nlay
               sum_z = sum_z + rgzlay(vlay(ilay))
               n_z = n_z + 1
 40         continue
 41         continue
            zref = sum_z / n_z
         end if

         set0 = nset            ! startpointer for set structure

         do 90 ilay=1,nlay      ! loop over 0-deg layers
            lay = vlay(ilay)
            if (lay.eq.0) go to 91
#ifdef  TFTRIPXN_DEBUG  
*%%%
            print '(" tftripxn : ==== seed,lay,set01,nset,nclus "
     +             ,5i5,i10)'
     +             ,iseed,ilay,(set0+1),nset,nclus,lay
#endif

            call rghl(lay,maxhit,vhit,nhit)

            do 60 ihit=1,nhit   ! loop over hits in layer
               hitb = vhit(ihit)
               if (segstor_zfpar) then ! check if hit already used
                  if (phitb_rseg(hitb).gt.0) go to 60 
               else
                  if (phitb_rtra(hitb).gt.0) go to 60 
               endif
               cmp = igede_cmp(ihitb_gede(hitb))

               if (nset.le.(maxset-2)) then
                  if (cmp.eq.1.or.cmp.eq.3) then ! strip
                     nset = nset + 1
                     x_set(nset) = fhitb_x(hitb)
                     z_set(nset) = fhitb_z(hitb)
                     hit_set(nset) = hitb
                     sig_set(nset) = 0
                     dl_set(nset) = lay
                     indset(nset) = nset
                  elseif (cmp.eq.2) then ! wirech
                     do isig=-1,1,2
                        nset = nset + 1
                        x_set(nset) = fhitb_x(hitb)
     +                       + isig * abs(fhitb_q(hitb))
                        z_set(nset) = fhitb_z(hitb)
                        hit_set(nset) = hitb
                        sig_set(nset) = isig
                        dl_set(nset) = lay
                        indset(nset) = nset
                     enddo
                  else
                     print *,' () tftripxn: invalid cmp=', cmp,
     +                    ' pl=',igede_cmp(ihitb_gede(hitb)),
     +                    ' sl=',ogede_gesl(ihitb_gede(hitb)),
     +                    ' hit=',hitb
                  endif
               else
                  call mepric(message_id_1,1,
     +                 'tftripxn: overflowing nset, hits skipped')
                  go to 91
               endif
 60         continue            ! hits in layer
 61         continue
 90      continue               ! layers
 91      continue

*        **** sort the hit set (increasing x)
         call sortzv(x_set,indset(set0+1),nset-set0,+1,0,1)

#ifdef  TFTRIPXN_DEBUG 

         if(set0+1.le.nset) then
            print '(" tftripxn: set ",12i5 )'
     +           ,(hit_set(indset(ind1)),ind1=set0+1,nset)
            print '(" tftripxn: set ",12f8.3 )'
     +           ,(x_set(indset(ind1)),ind1=set0+1,nset)
            end if
#endif

*        **** sample hit triplets
**         trip0 = ntrip                                     !%%%
         do 10 ind1=set0+1,nset-2    ! loop over base hit
            s1 = indset(ind1)
            do 20 ind2=ind1+1,nset-1 ! loop over second hit
               s2 = indset(ind2)

               if(hit_set(s1).eq.hit_set(s2)) go to 20 ! s1.ne.s2
**               if(hit_set(s1).eq.hit_set(s2)) print *,'s1==s2'
                  
               if ((x_set(s2)-x_set(s1)).gt.dxmax) go to 21
               dz1 = z_set(s2) - z_set(s1)
               if (abs(dz1).lt.dzmin) go to 20
               tx1 = (x_set(s2)-x_set(s1)) / dz1
               if (abs(tx1).gt.txmax) go to 20
#ifdef NEW_TRIPLETX 
               if(aqp_test(z_set(s1),x_set(s1),tx1).gt.qp_max) 
     +                                                 go to 20  
#endif 
               do 30 ind3=ind2+1,nset ! loop over third hit
                  s3 = indset(ind3)
                  
                  if(hit_set(s2).eq.hit_set(s3)) go to 30  ! s2.ne.s3

                  if ((x_set(s3)-x_set(s1)).gt.dxmax) go to 31
                  dz2 = z_set(s3) - z_set(s1)
                  if (abs(dz2).lt.dzmin) go to 30
                  tx2 = (x_set(s3) - x_set(s1)) / dz2
                  if (abs(tx2).gt.txmax) go to 30
#ifdef NEW_TRIPLETX 
                  if(aqp_test(z_set(s2),x_set(s2),tx2).gt.qp_max) 
     +                                                   go to 30  
#endif 

#ifdef DTXRES_ADD
                  dtxres = tx_nsig * sqrt(
     +                 (1./dz2 - 1./dz1)**2 * fhitb_r(hit_set(s1))**2
     +                 + (1./dz1)**2 * (fhitb_r(hit_set(s2)))**2
     +                 + (1./dz2)**2 * (fhitb_r(hit_set(s3)))**2 
     +                 + dtxres_add * dtxres_add )
#else
                  dtxres = tx_nsig * sqrt(
     +                 (1./dz2 - 1./dz1)**2 * fhitb_r(hit_set(s1))**2
     +                 + (1./dz1)**2 * (fhitb_r(hit_set(s2)))**2
     +                 + (1./dz2)**2 * (fhitb_r(hit_set(s3)))**2 )
#endif
 
*%%%
#ifdef TFTRIPXN_DEBUG 

               if(  tumchit(hit_set(s1)).eq.tumchit(hit_set(s2))
     +         .and.tumchit(hit_set(s2)).eq.tumchit(hit_set(s3)) 
     +         .and.-abs(tx2-tx1).lt.dtxres
     +         ) then
               print '("tftripxn: mc,s,t1,t2,dt,r ",4i5,4(f8.3))'
     +         ,tumchit(hit_set(s1)) 
     +         ,hit_set(s1)*sig_set(s1),hit_set(s2)*sig_set(s2)
     +         ,hit_set(s3)*sig_set(s3),tx1,tx2 
     +         ,abs(tx2-tx1),dtxres 
               endif
#endif 

                  if (abs(tx1-tx2).lt.dtxres) then ! triplet found
#ifndef NEW_TRIPLETX_switch_off
                     if (ntrip.lt.maxtrip) then
                        ntrip = ntrip + 1
                        zref_trip(ntrip) = zref

**                        tx_trip(ntrip) = 0.5 * (tx1 + tx2)
**                        x_trip(ntrip) = x_set(s1)
**     +                       + (zref-z_set(s1)) * tx_trip(ntrip)

*%%%
**                        print '("tftripxn : z,x,tx ",3f8.3)'
**     +                  ,zref,x_trip(ntrip),tx_trip(ntrip)

                        sx = 0.
                        sy = 0.
                        sxy = 0. 
                        sxy = 0.
                        sxx = 0.
                        x1  =  (z_set(s1) - zref)
                        y1  =  (x_set(s1))
                        x2  =  (z_set(s2) - zref)
                        y2  =  (x_set(s2))
                        x3  =  (z_set(s3) - zref)
                        y3  =  (x_set(s3))
                        sx = x1 + x2 + x3
                        sy = y1 + y2 + y3
                        sxy = x1*y1 + x2*y2 +x3*y3
                        sxx = x1*x1 + x2*x2 + x3*x3
                        det = 1/(3. * sxx - sx * sx)
                        x_trip(ntrip) = (sxx*sy - sx*sxy) * det
                        tx_trip(ntrip) = (3.*sxy - sx*sy) * det

                        s_trip(1,ntrip) = s1
                        s_trip(2,ntrip) = s2
                        s_trip(3,ntrip) = s3
                        clus_trip(ntrip) = 0
                        nx_trip(ntrip) = 0
                        indtrip(ntrip) = ntrip
#else
                     if (ntrip.lt.maxtrip) then
                        ntrip = ntrip + 1
                        zref_trip(ntrip) = zref
                        tx_trip(ntrip) = 0.5 * (tx1 + tx2)
                        x_trip(ntrip) = x_set(s1)
     +                       + (zref-z_set(s1)) * tx_trip(ntrip)
                        if(aqp_test(zref,x_trip(ntrip)
     +                       ,tx_trip(ntrip)).le.qp_max) then ! qp test  
                           s_trip(1,ntrip) = s1
                           s_trip(2,ntrip) = s2
                           s_trip(3,ntrip) = s3
                           clus_trip(ntrip) = 0
                           nx_trip(ntrip) = 0
                           indtrip(ntrip) = ntrip
                        else
                           ntrip = ntrip - 1
                        end if
#endif
*%%%
#ifdef TFTRIPXN_DEBUG 
                        print '("tftripxn: stored thxt ",4i5,x,3f8.3)'
     +                  ,ntrip
     +                  ,hit_set(s_trip(1,ntrip))
     +                   *sig_set(s_trip(1,ntrip))
     +                  ,hit_set(s_trip(2,ntrip))
     +                   *sig_set(s_trip(2,ntrip))
     +                  ,hit_set(s_trip(3,ntrip))
     +                   *sig_set(s_trip(3,ntrip))
*     +                  ,aqp_test(zref_trip(ntrip)
     +                  ,x_trip(ntrip)
     +                  ,tx_trip(ntrip)
#endif
                     else
                        call mepric(message_id_2,1,
     +                     'tftripxn: overflowing ntrip, sets skipped')
                        go to 11
                     endif
                  endif
 30            continue ! third hit
 31            continue
 20         continue ! second hit
 21         continue
 10      continue ! base hit
 11      continue

         if (l_diag) then
            if (diag_level.ge.5) then
               print *,' tftripxn: ',ntrip-trip0,
     +              ' Triplets found for iseed=',iseed
            endif
         endif

      enddo     ! seeds windows
 71   continue

*        **** search triplet clusters

*         call sortzv(tx_trip,indtrip(trip0+1),ntrip-trip0,+1,0,1)
*     +                          ! sort tx

         call sortzv(x_trip,indtrip(trip0+1),ntrip-trip0,+1,0,1)
     +                          ! sort x

*%%%
#ifdef TFTRIPXN_DEBUG
         print '(" tftripxn: before nclus,trip0+1,ntrip ",3i4)'
     +          ,nclus,(trip0+1),ntrip
#endif
         clus0 = nclus
         do 50 ind1=trip0+1,ntrip    ! loop over first triplet

            t1 = indtrip(ind1)
            tlast = t1
*           **** select matching parameters according to cmp
            cmp_trip=igede_cmp(ihitb_gede(hit_set(s_trip(1,t1))))
            if (cmp_trip.le.maxcmp_zfpar) then
               dxclus = dxclus_cmp(cmp_trip)
               dtxclus = dtxclus_cmp(cmp_trip)
            else
               dxclus = dxclus_cmp(2)
               dtxclus = dtxclus_cmp(2)
            endif

*%%%
#ifdef TFTRIPXN_DEBUG
            print '("tftripxn: ind1,t1,clus(t1),x ",3i5,f8.3)'
     +             ,ind1,t1,clus_trip(t1),x_trip(t1)
#endif
            if (clus_trip(t1).gt.0) go to 50
            if (nclus.lt.maxclus) then
               nclus = nclus + 1 ! create cluster with this hit
               mult_clus(nclus) = 1
               trip1_clus(nclus) = t1
               clus_trip(t1) = nclus
               nx_trip(t1) = 0

               indclus(nclus) = nclus

*%%%
**                  print '("tftripxn : new nclus,trip1,nx ",3i5 )'
**     +                   ,nclus,trip1_clus(nclus)
**     +                   ,nx_trip(trip1_clus(nclus))


            else
               call mepric(message_id_3,1,
     +              'tftripxn: overflowing nclus, triplets skipped')
               go to 51
            endif
            do 52 ind2=ind1+1,ntrip ! loop over following triplets
               t2 = indtrip(ind2)

*%%%
**            print '("tftripxn:   ind2,t2,clus(t2) ",3i5,f8.3)'
**     +             ,ind2,t2,clus_trip(t2),x_trip(t2)

               if (x_trip(t2).gt.x_trip(t1) + dxclus ) go to 52 
               if (abs(tx_trip(t2)-tx_trip(t1)).lt.dtxclus) then
                  clus_trip(t2) = nclus ! add to same cluster
                  mult_clus(nclus) = mult_clus(nclus) + 1
                  if (tlast.gt.0) nx_trip(tlast) = t2
                  tlast = t2

*%%%
**                  print '("tftripxn : add nclus,mult,trip1,nx ",4i5 )'
**     +                   ,nclus,mult_clus(nclus),trip1_clus(nclus)
**     +                   ,nx_trip(trip1_clus(nclus))

               endif
 52         continue   
 50      continue
 51      continue

#ifdef TFTRIPXN_DEBUG
         print '(" tftripxn: after clus0,nclus ",2i4)',clus0,nclus
#endif

         if (l_diag) then
            if (diag_level.ge.5) then
               print *,' tftripxn: ',nclus-clus0,
     +              ' Clusters found '
            endif
         endif

*%%%
#ifdef TFTRIPXN_DEBUG
      print '(" tftripxn : clas0+1,nclus ",2(i5))',(clus0+1),nclus
#endif

      nsetx = nset
      ntripx = ntrip
      nclusx = nclus

      call sortzv(mult_clus,indclus(clus0+1),nclus-clus0,-1,1,1) 
     +                          ! sort mult_clus

*%%%
#ifdef TFTRIPXN_DEBUG
      do ind1=clus0+1,nclus
         ii = indclus(ind1)
         if(mult_clus(ii).eq.1) then
            print '(" tftripxn: clus ",i4," t1 ",i4)',ii,trip1_clus(ii)
         else if(mult_clus(ii).eq.2) then
            print '(" tftripxn: clus ",i4," t12 ",2(x,i4))'
     +      ,ii,trip1_clus(ii),nx_trip(trip1_clus(ii))
         else if(mult_clus(ii).eq.3) then
            print '(" tftripxn: clus ",i4," t123 ",3(x,i4))'
     +      ,ii,trip1_clus(ii),nx_trip(trip1_clus(ii))
     +      ,nx_trip(nx_trip(trip1_clus(ii)))
         else if(mult_clus(ii).eq.4) then
            print '(" tftripxn: clus ",i4," t1234 ",4(x,i4))'
     +      ,ii,trip1_clus(ii),nx_trip(trip1_clus(ii))
     +      ,nx_trip(nx_trip(trip1_clus(ii)))
     +      ,nx_trip(nx_trip(nx_trip(trip1_clus(ii))))
         else if(mult_clus(ii).eq.5) then
            print '(" tftripxn: clus ",i4," t12345 ",5(x,i4))'
     +      ,ii,trip1_clus(ii),nx_trip(trip1_clus(ii))
     +      ,nx_trip(nx_trip(trip1_clus(ii)))
     +      ,nx_trip(nx_trip(nx_trip(trip1_clus(ii))))
     +      ,nx_trip(nx_trip(nx_trip(nx_trip(trip1_clus(ii)))))
         else if(mult_clus(ii).eq.6) then
            print '(" tftripxn: clus ",i4," t123456 ",6(x,i4))'
     +      ,ii,trip1_clus(ii),nx_trip(trip1_clus(ii))
     +      ,nx_trip(nx_trip(trip1_clus(ii)))
     +      ,nx_trip(nx_trip(nx_trip(trip1_clus(ii))))
     +      ,nx_trip(nx_trip(nx_trip(nx_trip(trip1_clus(ii)))))
     +      ,nx_trip(nx_trip(nx_trip(nx_trip(nx_trip(trip1_clus(ii))))))
         end if
      end do     
#endif

      end
