#ifndef _RECO_HH_
#define _RECO_HH_

// *****************************************************************************
//
// source:    reco.hh
//
// type:      header
//
// created:   02 Jan 2001
//	
// author:    Dr. Andreas Gellrich
//            HERA-B Collaboration
//            Humboldt-University Berlin
//            Department of Physics
//            Invalidenstr. 110
//            10115 Berlin
//            Germany
//            E-mail: Andreas.Gellrich@desy.de
//
// changes:
// 02 Jan 2001 (AG) creation
// 19 Jan 2001 (PC) added some functions from new scheme.
//
// *****************************************************************************

//#include "reco/rc99Areco.hh"

// main function
void rcevnt();
extern "C" void rcZevnt_();

// init
void rcinit();
void rciVDS();
void rciECAL();
void rciMUON();

// stand-alone
int  rcStandAlone();
int  rcTARGET( int flag );
int  rcVDS( int flag );
int  rcITR( int flag );
int  rcOTR( int flag );
int  rcECAL( int flag );
int  rcRICH( int flag );
int  rcMUON( int flag );
int  rcTRD( int flag );
int  rcHPT( int flag );

// particle-id
int  rcParticleID();

// matching
int  rcMatch();
int rcDoMatchStep(int step);

// rtra creation
int rcCreateRtraBasePatt();
int rcCreateRtraLast();
int rcSelectRtraBasePatt();
int rcSetRtraHitb( ArtePointer<RTRA> rtra ) ;
int rcSetRtraSegHitb( ArtePointer<RTRA> rtra, ArtePointer<RSEG> rseg ) ;
int rcCountRtraHits( ArtePointer<RTRA> rtra ) ;
int rcCountRtraHits() ;
int rcSetRtraHitRelations();
void rcEcalStep2();      // second step of ecal

// refit
int  rcRefit();
int  rcRefitRtraBasePatt() ;
int  rcRefitRtraVdsEcal() ;
int  rcRefitRtraVdsOnly() ;

// track selection
int  rcSelectTracks();

// decay selection
int  rcSelectDecays();

// track poimnts
int  rcSetTrackPoints();
int  rcSetTrackPointsVdsEcal();

// momentum determination
int  rcMoment();

// vertexing
void rcVertex();

// timing
void rcfillEVHI();

// module selection
int  rcModSel();

// event classiffication
int  rcClassify();  // event classification
void rcFillEVTI();  // fill time table EVTI

// monte carlo matching
int rcRTRAmatchMTRA();

// termination
void rcstop();

// utilities
unsigned int rcSetError( char * module );
unsigned int rcerror( char * module );
unsigned int recoErrorFlag();

// old stuff
int  rc99Arefit();
int  rc99SelectTracks();
void rc99Avertex();

#endif
