
// *****************************************************************************
//
// source:    rcSelectDecays.C
//
// type:      source code
//
// created:   04 Dec 2000
//	
// author:    Dr. Andreas Gellrich
//            HERA-B Collaboration
//            Humboldt-University Berlin
//            Department of Physics
//            Invalidenstr. 110
//            10115 Berlin
//            Germany
//            E-mail: Andreas.Gellrich@desy.de
//
// symbol:    rcSelectDecays
//
// called by: rc99Aevnt
//
// purpose:   call functions
//
// hints:
//
// changes:
// 04 Dec 2000 (AG) introduced rcSelect_K0s_Lambda
// 11 Dec 2000 (AG) corrected typo
// 15 Dec 2000 (AG) invoke rcMarkSLTtracks() here
// 28 Jun 2000 (FS) rcSelect_K0s_Lambda is moved to rcClassVZERO.C
//
// *****************************************************************************

// standard includes
#include <iostream.h>
#include <stdlib.h>

// ARTE includes
#include "arte/arte.hh"
#include "reco/rc99Areco.hh"
#include "farm/farm.hh"

// extrenals
extern int rcSelectTracksStatus;

// prototypes
int  rcSelectJPSIEE();
int  rcSelectJPSIMM();
bool rcSelect_K0S_Lambda();
void rcMarkSLTtracks();

//
// function code
//
int
rcSelectDecays()
{
  ARTE_mark( "rcSelectDecays 0", 0 );

  // inits
  int flag = 0;

  // check status
  if( rcSelectTracksStatus == 0 ){
    ARTE_mark( "rcSelectDecays  1", 0 );
    return flag;  
  }

  //==================================================================
  // 0. mark SLT-tracks
  //==================================================================
  ARTE_mark( "rcMarkSLTtracks", 0 );
  rcMarkSLTtracks();
  
  //==================================================================
  // 1. select J/Psi -> EE candidates
  //==================================================================
  ARTE_mark( "rcSelectJPSIEE", 0 );
  flag = rcSelectJPSIEE();

  //==================================================================
  // 2. select J/Psi -> MM candidates
  //==================================================================
  ARTE_mark( "rcSelectJPSIMM", 0 );
  flag = rcSelectJPSIMM();

  //==================================================================
  // 3. K0s / Lambda
  //==================================================================
  // ARTE_mark( "rcSelect_K0S_Lambda", 0 );
  // flag = rcSelect_K0S_Lambda();
  // ARTE_mark( "rcSelectDecays  1", 0 );

  return flag;
}
