
// ********************************************************************
//
// Routine:      rcSelectTracks.C
// Author:       T.Oest
//
// Description:  select tracks from matched segments
//
// Modification:
// remove Rxxx banks before track selection        01/12/99 T.Oest
// 2000 track selection added                      10/02/00 T.Oest
// 2000 track selection replaced by new selection  26/05/00 D.Samtleben
// 11 Dec 2000 (AG) prepare for SLT tracks
// 15 Dec 2000 (AG) rcMarkSLTtracks() is called in rcSelectDecays()
// 02 Jan 2001 (AG) removed 99A
//
// ********************************************************************

// standard includes
#include <iostream.h>
#include <stdlib.h>

// ARTE includes
#include "arte/arte.hh"
#include "farm/farm.hh"
#include "reco/reco.hh"
#include "reco/rcflags.hh"

// prototypes
void rcInventRTRA();
int  rccreateRTRA();

//*****************************************************************
// function  
//*****************************************************************
int
rcSelectTracks()
{
  ARTE_mark( "rcSelectTracks 0", 0 );

  // inits
  int rc = 0;
  
  //==================================================================
  // remove tracks and vertices
  //==================================================================
  if (rcSelectTracksStatus == 1) {
    if (ArteTable<RTRA>::size() !=0) ArteTable<RTRA>::clear();
    if (ArteTable<RVER>::size() !=0) ArteTable<RVER>::clear();
    if (ArteTable<RREL>::size() !=0) ArteTable<RREL>::clear();
    if (ArteTable<RPNT>::size() !=0) ArteTable<RPNT>::clear();
  }
  
  //==================================================================
  // select VDS/ECAL tracks (+RICH)
  //==================================================================
  if (rcSelectTracksStatus == 1){
    ARTE_mark( "rcInventRTRA", 0 );
    rcInventRTRA();
  }

  //==================================================================
  // select VDS/OTR tracks
  //==================================================================
  if (rcSelectTracksStatus == 2){
    ARTE_mark( "rccreateRTRA", 0 );
    rc = rccreateRTRA();
  }

  ARTE_mark( "rcSelectTracks 1", 0 );
  return rc;
}
