// ********************************************************************
//
//  Routine:      rcfillEVHI
//  Author:       T.Oest
//
//  Description:  fill EVHI bank
//
//
//  Modification:  
//  -- clear EVHI table before filling                T. Oest 10/03/00
//
//
// ********************************************************************

#include <iostream.h>
#include <stdlib.h>
#include <stdio.h>
#include "arte/arte.hh"

#include "reco/rc99Areco.hh"
#include "reco/rcflags.hh"

//********************************************************************
// 
//********************************************************************

void rcfillEVHI() {

//===================================================================
// clear table
//===================================================================

 ArteTable<EVHI>::clear();

//===================================================================
// lopp over HITB
//===================================================================

  int  HITs[9] = {0,0,0, 0,0,0, 0,0,0};
  int RHITs[9] = {0,0,0, 0,0,0, 0,0,0};

 for( ArteTable<HITB>::iterator hitb = ArteTable<HITB>::begin();
      hitb != ArteTable<HITB>::end(); ++hitb ) {

  if ((*hitb)->gede->cmp > 0 && (*hitb)->gede->cmp <= 9) {
        ++HITs [(*hitb)->gede->cmp - 1];
     if ((*hitb)->rhit.begin() != (*hitb)->rhit.end()) 
        ++RHITs[(*hitb)->gede->cmp - 1];
  };

 };


//===================================================================
// add ECAL hits
//===================================================================

  HITs[6]  = ArteTable<HITC>::size();
  RHITs[6] = 0;

 for( ArteTable<HITC>::iterator hitc = ArteTable<HITC>::begin();
      hitc != ArteTable<HITC>::end(); ++hitc ) {

  if ((*hitc)->rccl.begin() != (*hitc)->rccl.end()) ++RHITs[6];
 };


//===================================================================
// book EVHI table
//===================================================================

  EVHI evhi;
  
  for (int i=0; i<=8 ; i++){

   evhi.hit  = HITs[i];
   evhi.rhit = RHITs[i];
  
   ArteTable<EVHI>::push_back(evhi);

  };


 return;

}

