// ********************************************************************
//
// Routine:      rckarcswitch.C
// Author:       T.Oest
//
// Description:  kuip interface to chode reconstruction chain
//
// Modification:
// 03 Jan 2000 (AG) removed 99A
//
// ********************************************************************


#include <iostream.h>
#include <stdlib.h>
#include "arte/arte.hh"
#include "reco/rc99Areco.hh"
#include "reco/rcflags.hh"
#include <string.h>
#include <ctype.h>

extern "C" void kugetc_( char*, int *, int );
           void ackuexec(char * KuipCommand);

/************************************************************************
* KARTRA
*
* called from  KUIP
***********************************************************************/

extern "C" void karcswitch_() {   

//---------------------------------------------------------------
//   read in subdetetcor status
//---------------------------------------------------------------

  int len;        
  char input[8];
  int len1 = 3;
  kugetc_(input, &len, len1);
  input[len] = 0;

  char status[8];
  status[len] = 0;

  if(len>0) for(int i=0; i<len; i++) status[i] = toupper(input[i]);

//---------------------------------------------------------------
//   read in chain 00 or 99
//---------------------------------------------------------------

  len = 0;
  len1 = 4;
  kugetc_(input, &len, len1);
  input[len] = 0;

  char chain[8];
  chain[len] = 0;

  if(len>0) for(int i=0; i<len; i++) chain[i] = toupper(input[i]);

//---------------------------------------------------------------
//   set status flag
//---------------------------------------------------------------

  if (!strncmp(status,"ON",2)) {

  if (!strncmp(chain,"2000" ,4) || !strncmp(chain,"00" ,2)){

    ackuexec("/RANGER/FPAR RLEVEL=4");

    ackuexec("/RECON/SUBD VDS ON CATS");
    ackuexec("/RECON/SUBD ITR ON ");
    ackuexec("/RECON/SUBD OTR ON ");
    ackuexec("/RECON/SUBD ECAL ON ");
    ackuexec("/RECON/SUBD TRD ON ");
    ackuexec("/RECON/SUBD HPT ON ");

    ackuexec("/RECON/MATCH MARPLE VDS OTR");

    ackuexec("/RECON/RTRA ON VDSOTR");
    ackuexec("/RECON/REFIT ON");

    ackuexec("/RECON/PID RICH ON RITER");
    ackuexec("/RECON/PID ECAL ON");
    ackuexec("/RECON/PID MUON ON");
    ackuexec("/RECON/PID TRD ON");

    cout << " /RECON/SWITCH ON 2000    corresponds to \n"
         << "           /RANGER/FPAR RLEVEL=4  \n"
         << "           /RECON/SUBD VDS ON CATS  \n"
         << "           /RECON/SUBD ITR ON  \n"
         << "           /RECON/SUBD OTR ON  \n"
         << "           /RECON/SUBD ECAL ON  \n"
         << "           /RECON/SUBD TRD ON  \n"
         << "           /RECON/SUBD HPT ON  \n"
         << "           /RECON/MATCH MARPLE VDS OTR  \n"
         << "           /RECON/RTRA ON VDSOTR  \n"
         << "           /RECON/REFIT ON   \n"
         << "           /RECON/PID RICH ON RITER  \n"
         << "           /RECON/PID ECAL ON  \n"
         << "           /RECON/PID MUON ON  \n"
         << "           /RECON/PID TRD ON  \n" 
         << endl;
  };

  if (!strncmp(chain,"1999" ,4) || !strncmp(chain,"99" ,2)){


    ackuexec("/RECON/SUBD VDS ON CATS");
    ackuexec("/RECON/SUBD ECAL ON ");
    ackuexec("/RECON/SUBD RICH ON ");

    ackuexec("/RECON/MATCH MARPLE VDS ECAL");
    ackuexec("/RECON/MATCH MARPLE VDS RICH");
    ackuexec("/RECON/MATCH MARPLE RICH ECAL");

    ackuexec("/RECON/RTRA ON VDSECAL");
    ackuexec("/RECON/REFIT ON");

    cout << " /RECON/SWITCH ON 1999    corresponds to \n"
         << "           /RECON/SUBD VDS ON CATS  \n"
         << "           /RECON/SUBD ECAL ON  \n"
         << "           /RECON/SUBD RICH ON  \n"
         << "           /RECON/MATCH MARPLE VDS ECAL \n"
         << "           /RECON/MATCH MARPLE VDS RICH \n"
         << "           /RECON/MATCH MARPLE RICH ECAL \n"
         << "           /RECON/RTRA ON VDSECAL  \n"
         << "           /RECON/REFIT ON  \n"
         << endl;
  };
  };

   if (!strncmp(status,"OFF",3)) {

    ackuexec("/RECON/SUBD VDS OFF");
    ackuexec("/RECON/SUBD ITR OFF");
    ackuexec("/RECON/SUBD OTR OFF");
    ackuexec("/RECON/SUBD ECAL OFF");
    ackuexec("/RECON/SUBD RICH OFF");
    ackuexec("/RECON/SUBD TRD OFF");
    ackuexec("/RECON/SUBD HPT OFF");

    ackuexec("/RECON/RTRA OFF");
    ackuexec("/RECON/REFIT OFF");

    ackuexec("/RECON/PID RICH OFF");
    ackuexec("/RECON/PID ECAL OFF");
    ackuexec("/RECON/PID MUON OFF");
    ackuexec("/RECON/PID TRD OFF");


   };


};
