// ********************************************************************
//
// Routine:      rckartra.C
// Author:       T.Oest
//
// Description:  kuip interface for track selection
//
// Modification:
// 03 Jan 2000 (AG) removed 99A
// 19 Jan 2001 (PC) added rcrtra2001 selection.
//
// ********************************************************************


#include <iostream.h>
#include <stdlib.h>
#include "arte/arte.hh"
#include "reco/rc99Areco.hh"
#include <string.h>
#include <ctype.h>

int rcSelectTracksStatus = 0;
int rcMainVertex         = 0;
int rcK0SVertex          = 0;

int rcRTRA2001 = 0;

extern "C" void kugetc_( char*, int *, int );
extern "C" void kugeti_( int * );

/************************************************************************
* KARTRA
*
* called from  KUIP
***********************************************************************/

extern "C" void kartra_() {   

//---------------------------------------------------------------
//   read in subdetetcor status
//---------------------------------------------------------------

  int len;        
  char input[8];
  int len1 = 3;
  kugetc_(input, &len, len1);
  input[len] = 0;

  char *status;
  status  = (char *) malloc(len+1);
  sprintf(status  ,"%s", input);

  if(len>0) for(int i=0; i<len; i++) status[i] = toupper(input[i]);

//---------------------------------------------------------------
//   read in subdetetcor status
//---------------------------------------------------------------

  len = 0;
  len1 = 7;
  kugetc_(input, &len, len1);
  input[len] = 0;

  char *method;
  method  = (char *) malloc(len+1);
  sprintf(method  ,"%s", input);

  if(len>0) for(int i=0; i<len; i++) method[i] = toupper(input[i]);

//---------------------------------------------------------------
//   set status flag
//---------------------------------------------------------------

  if (!strncmp(status,"OFF",3)) rcSelectTracksStatus = 0;
  if (!strncmp(status,"ON" ,2)) {
    if (!strncmp(method,"VDSECAL" ,7)) rcSelectTracksStatus = 1;
    if (!strncmp(method,"VDSOTR"  ,6)) rcSelectTracksStatus = 2;

  };

//---------------------------------------------------------------
//   set vertexing flag
//---------------------------------------------------------------

  if (rcSelectTracksStatus == 0){
    rcMainVertex = 0;
    rcK0SVertex = 0;
  };

  if (rcSelectTracksStatus != 0)  rcMainVertex = 1;
  if (rcSelectTracksStatus == 2)  rcK0SVertex = 1;

};



 // Select if using the new RTRA scheme:

extern "C" void rcrtra2001_() {   
  
  int selOpt=0;

  kugeti_(&selOpt);

  rcRTRA2001 = selOpt;
  if(!rcRTRA2001) cout << " Standard RTRA creation " << endl;
  else cout << " New scheme of RTRA creation " << endl;

    return;
  }
