
// ********************************************************************
//
// Routine:      rckasubd
// Author:       T.Oest
//
// Description:  kuip interface to set reco flags
//
//               reco level 0: no reconstruction
//                          1: hitb only
//                          2: reconstruction only
//                          3: hitb + reconstruction
//
// Modification:
// 09 May 2000 (AG) use faComp() to check component
// 03 Jan 2000 (AG) removed 99A
//
// ********************************************************************

#include <iostream.h>
#include <stdlib.h>
#include <stdio.h>
#include "arte/arte.hh"
#include "farm/farm.hh"
#include <string.h>
#include <ctype.h>

int recoTARGET    = 0;
int recoVDS       = 0;
int recoVDSmodule = 0;
int recoITR       = 0;
int recoOTR       = 0;
int recoECAL      = 0;
int recoMUON      = 0;
int recoRICH      = 0;
int recoRICHmodule= 0;
int recoTRD       = 0;
int recoHPT       = 0;

extern int FADEB;

extern "C" void kugetc_( char*, int *, int );

/************************************************************************
* KASUBD
*
* called from  KUIP
***********************************************************************/

extern "C" void kasubd_() {   

//---------------------------------------------------------------
//   read in subdetector
//---------------------------------------------------------------

  int len;        
  int len1 = 6;
  char input[7];
  kugetc_(input, &len, len1);
  input[len] = 0;


  char *subdetector;
  subdetector  = (char *) malloc(len+1);
  sprintf(subdetector  ,"%s", input);

  for(int i=0; i<len; i++) subdetector[i] = toupper(subdetector[i]);

//---------------------------------------------------------------
//   read in subdetetcor status
//---------------------------------------------------------------

  len1 = 3;
  kugetc_(input, &len, len1);
  input[len] = 0;

  char *status;
  status  = (char *) malloc(len+1);
  sprintf(status  ,"%s", input);

  if(len>0) for(int i=0; i<len; i++) status[i] = toupper(input[i]);

//---------------------------------------------------------------
//   read in HITB flag
//---------------------------------------------------------------

  len1 = 6;
  kugetc_(input, &len, len1);
  input[len] = 0;

  char *hitb;
  hitb   = (char *) malloc(len+1);
  sprintf(hitb  ,"%s", input);

  if(len>0) for(int i=0; i<len; i++) hitb[i] = toupper(hitb[i]);

//---------------------------------------------------------------
//   set reconstruction status
//---------------------------------------------------------------
  int istatus;


  if (!strncmp(status,"ON",2)){
    if (!strncmp(hitb,"HITB",4)){
       istatus = 1;
    } else {
       istatus = 3;
    };
  } else {
    if (!strncmp(hitb,"HITB",4)){
       istatus = 2;
    } else {
       istatus = 0;
    };
  };

  if (!strncmp(status,"ON",2)){

   if (!strncmp(subdetector,"VDS"    ,3)||!strncmp(subdetector,"SVD"    ,3)){
                                          recoVDS    = recoVDS    | istatus;
      if (strncmp(hitb,"HITB",4)){
      if (!strncmp(hitb,"CATS",4)){
       recoVDSmodule = recoVDSmodule | 2;
      } else {
       recoVDSmodule = recoVDSmodule | 1;
      };};
   };

   if (!strncmp(subdetector,"RICH"   ,4)) {
                                          recoRICH   = recoRICH   | istatus;
      if (strncmp(hitb,"HITB",4)){
      if (!strncmp(hitb,"PCSE",4)){
       recoRICHmodule = 2;
      } else {
       recoRICHmodule = 1;
      };};
   };


   if (!strncmp(subdetector,"ITR"    ,3)) recoITR    = recoITR    | istatus;
   if (!strncmp(subdetector,"OTR"    ,3)) recoOTR    = recoOTR    | istatus;
   if (!strncmp(subdetector,"ECAL"   ,4)) recoECAL   = recoECAL   | istatus;
   if (!strncmp(subdetector,"MUON"   ,4)) recoMUON   = recoMUON   | istatus;
   if (!strncmp(subdetector,"TRD"   ,3)) recoTRD = recoTRD | istatus;
   if (!strncmp(subdetector,"HPT"   ,3)) recoHPT = recoHPT | istatus;

   if (!strncmp(subdetector,"ALL" ,3)) {
      recoVDS     = recoVDS    | istatus;
      recoITR     = recoITR    | istatus;
      recoOTR     = recoOTR    | istatus;
      recoECAL    = recoECAL   | istatus;
      recoMUON    = recoMUON   | istatus;
      recoRICH    = recoRICH   | istatus;
      recoTRD     = recoTRD    | istatus;
      recoHPT     = recoHPT    | istatus;
      if (recoVDS == 0 ) {
       recoVDSmodule = 0;
      } else { recoVDSmodule = 1;
      };
      if (recoRICH == 0 ) {
       recoRICHmodule = 0;
      } else { recoRICHmodule = 1;
      };
   };
   if(strncmp(subdetector,"VDS",3)&&strncmp(subdetector,"SVD",3)&&
      strncmp(subdetector,"OTR",3)&&strncmp(subdetector,"ECAL",4)&&
      strncmp(subdetector,"MUON",4)&&strncmp(subdetector,"RICH",4)&&
      strncmp(subdetector,"TRD",3)&&strncmp(subdetector,"ITR",3)&&
      strncmp(subdetector,"HPT",3)&&strncmp(subdetector,"ALL",3)){
     cerr << "****** RECO/SUBD:   unknown subdetector!!! ************** "
<< endl;
   }

  } else {

   if (!strncmp(subdetector,"VDS"    ,3)||!strncmp(subdetector,"SVD"    ,3)) {
      if (strncmp(hitb,"HITB",4)){
      if (!strncmp(hitb,"CATS",4)){
         recoVDSmodule = recoVDSmodule & 1;
      } else { if (!strncmp(hitb,"HOLM",4)) {
               recoVDSmodule = recoVDSmodule & 2;
      } else { recoVDSmodule = 0;
      };};
       if (recoVDSmodule != 0) istatus = 3;
      };
                                          recoVDS    = recoVDS    & istatus;
   };
   if (!strncmp(subdetector,"ITR"    ,3)) recoITR    = recoITR    & istatus;
   if (!strncmp(subdetector,"OTR"    ,3)) recoOTR    = recoOTR    & istatus;
   if (!strncmp(subdetector,"ECAL"   ,4)) recoECAL   = recoECAL   & istatus;
   if (!strncmp(subdetector,"MUON"   ,4)) recoMUON   = recoMUON   & istatus;
   if (!strncmp(subdetector,"RICH"   ,4)) recoRICH   = recoRICH   & istatus;
   if (!strncmp(subdetector,"TRD"   ,3))  recoTRD = recoTRD & istatus;
   if (!strncmp(subdetector,"HPT"   ,3))  recoHPT = recoHPT & istatus;

   if (!strncmp(subdetector,"ALL" ,3)) {
      recoVDS     = recoVDS    & istatus;
      recoITR     = recoITR    & istatus;
      recoOTR     = recoOTR    & istatus;
      recoECAL    = recoECAL   & istatus;
      recoMUON    = recoMUON   & istatus;
      recoRICH    = recoRICH   & istatus;
      recoTRD     = recoTRD    & istatus;
      recoHPT     = recoHPT    & istatus;
   }
   
  }
  
  //
  // disable components if not present in run (faComp() returns 1 for offline)
  //
  recoVDS       = faComp( COMP_M_SVD  ) ? recoVDS       : 0;
  recoVDSmodule = faComp( COMP_M_SVD  ) ? recoVDSmodule : 0;
  recoITR       = faComp( COMP_M_ITR  ) ? recoITR       : 0;
  recoHPT       = faComp( COMP_M_HIPT ) ? recoHPT       : 0;
  recoOTR       = faComp( COMP_M_OTR  ) ? recoOTR       : 0;
  recoRICH      = faComp( COMP_M_RICH ) ? recoRICH      : 0;
  recoTRD       = faComp( COMP_M_TRD  ) ? recoTRD       : 0;
  recoECAL      = faComp( COMP_M_ECAL ) ? recoECAL      : 0;
  recoMUON      = faComp( COMP_M_MUON ) ? recoMUON      : 0;

  //
  // print
  //
  if( FADEB ){
    cout << "KUIP: RECO flags:"                 << endl;
    cout << "      VDS=      " << recoVDS       << endl;
    cout << "      VDSmodule=" << recoVDSmodule << endl;
    cout << "      ITR=      " << recoITR       << endl;
    cout << "      HPT=      " << recoHPT       << endl;
    cout << "      OTR=      " << recoOTR       << endl;
    cout << "      RICH=     " << recoRICH      << endl;
    cout << "      TRD=      " << recoTRD       << endl;
    cout << "      ECAL=     " << recoECAL      << endl;
    cout << "      MUON=     " << recoMUON      << endl;
  }

}
