*
* source:    rckuip.cdf
*
* type:      KUIP source code
*
* created:   25 Jul 2000
*	
* author:    Andreas Gellrich
*            HERA-B Collaboration
*            Humboldt-University Berlin
*            Physics Department
*            Invalidenstr. 110
*            10115 Berlin
*            Germany
*            E-mail: Andreas.Gellrich@desy.de
*
* purpose:   define KUIP commands for reconstruction
*
* hints:     rc99Akuip.cdf is obsolete!
*
* changes:
* 25 Jul 2000 (AG) added 4th argument to /RECON/PID
* 02 Aug 2000 (AG) polished code
* 04 Aug 2000 (AG) removed bug
* 11 Aug 2000 (AG) added argument to MODSEL
* 10 Nov 2000 (AG) added parameter to CLASS
*

>NAME RCKUIP
>Menu /Recon
>Guidance
Commands related to event reconstruction.

>Menu /Recon/Superlayers
>Command List
>Guidance
List activation status of superlayers.
>Action RCKLIST

>Command Activate
>Parameters
SL1 'Superlayer to be activated' C D=' '
+
CHOPT 'Options' C D=' '
>Guidance
Mark superlayer to be used for reconstruction.
>Action RCKACT

>Command Deactivate
>Parameters
SL1 'Superlayer to be deactivated' C D=' '
+
CHOPT 'Options' C D=' '
>Guidance
Mark superlayer to be ignored for reconstruction.
>Action RCKINACT


>Menu /Recon/Algorithm
>Command List
>Guidance
List activation status of algorithm options.
>Action RCKALGLIST
>Command Activate
>Parameters
ALG1 'Algorithm to be activated' C D=' '
+
CHOPT 'Options' C D=' '
>Guidance
Mark algorithm to be used.
>Action RCKALGACT
>Command Deactivate
>Parameters
ALG1 'Algorithm to be activated' C D=' '
+
CHOPT 'Options' C D=' '
>Guidance
Mark algorithm to be ignored.
>Action RCKALGINACT


>MENU /Recon

>Command SUBD
>Guidance
switch on/off subdetectors for stand alone reconstruction.
>Action KASUBD
>Parameter
+
SUBD 'subdetectors'         C  D=' '
STAT 'status on/off'        C  D='OFF'
HITB 'HITB  production'     C  D=' '

>Command PID
>Guidance
switch on/off subdetectors for particle ID.
>Action KAPID
>Parameter
+
SUBD 'subdetectors'      C  D=' '
STAT 'status on/off'     C  D='OFF'
MODU 'software module'   C  D=' '
MOD1 'software module 2' C  D=' '

>Command RTRA
>Guidance
switch on/off track selection
>Action KARTRA
>Parameter
+
STAT 'status on/off' C  D='OFF'
METH 'method       ' C  D='VDSOTR'

>Command MOM
>Guidance
switch on/off momentum reconstruction
>Action KAMOM
>Parameter
+
STAT 'status on/off' C  D='OFF'

>Command MATCH
>Guidance
switch on/off subdetector matching
>Action KAMATCH
>Parameter
+
SUB1 'subdetector 1'         C  D=' '
SUB2 'subdetector 2'         C  D=' '
SUB3 'subdetector 3'         C  D=' '


>Command SWITCH
>Guidance
switch reconstruction on/off and chose reco chain.
>Action KARCSWITCH
>Parameter
+
SWITCH 'reconstruction switch ' C  D='ON'
CHAIN  'reconstruction chain'   C  D='00'

>Command REFIT
>Guidance
switch refit on/off.
>Action KARCREFIT
>Parameter
+
SWITCH 'refit switch ' C  D='OFF'
OPTION 'optin        ' C  D=' '

>Command CLASS
>Guidance
switch on/off event classification
>Action KACLASS
>Parameter
+
CLASS 'class'          C  D=' '
STAT  'status on/off'  C  D='OFF'
PARA1 'parameter1'     C  D='-99999'
PARA2 'parameter2'     C  D='-99999'

>Command MODSEL
>Guidance
switch on/off reconstruction module selection
>Action KAMODSEL
>Parameter
+
NAME 'selection name' C  D=' '
STAT 'status on/off'  C  D='OFF'



>COMMAND RTRA2001
>GUIDANCE
Selects the new scheme of RTRA reconstruction.   
>ACTION RCRTRA2001
>PARAMETER
Status 'Status on=1/Off=0' I D=0
