#include "reco/recoOptions.hh"
#include "arte/arte.hh"

recoOptions RecoOpt;

recoOptions::recoOptions(){
//
}
recoOptions::~recoOptions(){
}
void recoOptions::print()
{
for( ArteTable<GEDE>::iterator iterGEDE = ArteTable<GEDE>::begin();
     iterGEDE != ArteTable<GEDE>::end();
     ++iterGEDE) {
     cout << *iterGEDE << " " << (*iterGEDE)->gesl->cmp << " " << (*iterGEDE)->gesl->name << endl;
     }
}
void recoOptions::active()
{
    for( ArteTable<GESL>::iterator iterGESL = ArteTable<GESL>::begin();
       iterGESL != ArteTable<GESL>::end();
       ++iterGESL) {
       cout << " " << (*iterGESL)->name << " " << (*iterGESL)->cmp << endl;
       }
}
void recoOptions::InitSL()
{
//    if (! IsInit)
    {
//    IsInit=1;
//    cout << "IsInit" << " " << IsInit << endl;
    for( ArteTable<GESL>::iterator iterGESL = ArteTable<GESL>::begin();
       iterGESL != ArteTable<GESL>::end();
       ++iterGESL) {
        string slname((*iterGESL)->name,4);
        cout << "Init fill " << slname << " " << endl;
        SlStatus.insert(map<string,int>::value_type(slname,1));
       }
    }
}


void recoOptions::SLList() 
{
    map< string, int >::iterator iter = SlStatus.begin();
     
    cout << "SuperLayer Status 1-active, 0-inactive" << endl;
    while(iter != SlStatus.end())
    {
      cout << "SL " << (*iter).first << " " << (*iter).second << endl;
     ++iter;
    }
}
void recoOptions::AlgList() 
{
    map< string, int >::iterator algiter = AlgStatus.begin(),
    iter_end = AlgStatus.end();
      cout << "Algorithm Status 1-active, 0-inactive" << endl;
    while(algiter != iter_end)
    {
      cout << "AL " << (*algiter).first << " " << (*algiter).second << endl;
     ++algiter;
    }
}
void recoOptions::SetInActiveSL(string slname)
{
    map< string, int >::iterator itInActive = SlStatus.find(slname);
    if (itInActive == SlStatus.end())
            {
              SlStatus.insert(map<string,int>::value_type(slname,0)); 
            }
    else
            {
              SlStatus.erase(itInActive);
              SlStatus.insert(map<string,int>::value_type(slname,0)); 
            }
}
void recoOptions::SetInActiveAlg(string algname)
{
    map< string, int >::iterator itAlgInActive = AlgStatus.find(algname);
    if (itAlgInActive == AlgStatus.end())
            {
              AlgStatus.insert(map<string,int>::value_type(algname,0)); 
            }
    else
            {
              AlgStatus.erase(itAlgInActive);
              AlgStatus.insert(map<string,int>::value_type(algname,0)); 
            }
}
void recoOptions::SetActiveSL(string name)
{
    map< string, int >::iterator itActive = SlStatus.find(name);
    if (itActive == SlStatus.end()) 
            {            
              SlStatus.insert(map<string,int>::value_type(name,1));
            }
    else    {
              SlStatus.erase(itActive);
              SlStatus.insert(map<string,int>::value_type(name,1));
            }
}
void recoOptions::SetActiveAlg(string name)
{
    map< string, int >::iterator itAlgActive = AlgStatus.find(name);
    if (itAlgActive == AlgStatus.end()) 
            {            
              AlgStatus.insert(map<string,int>::value_type(name,1));
            }
    else    {
              AlgStatus.erase(itAlgActive);
              AlgStatus.insert(map<string,int>::value_type(name,1));
            }
}
int  recoOptions::CheckActiveSL(string slname)
{
    int status = 9;

    map< string, int >::iterator itCheck = SlStatus.find(slname);
    if (itCheck != SlStatus.end())
            {
             status = (*itCheck).second;
            }
    else
            {
             cout << "SL is set to default (active)" << endl;
            }
     return status;
}
int  recoOptions::CheckActiveAlg(string alname)
{
    int status = 0;

    map< string, int >::iterator itAlgCheck = AlgStatus.find(alname);
    if (itAlgCheck != AlgStatus.end())
            {
             status = (*itAlgCheck).second;
            }
     return status;
}
