******************************************************************************
*
* source:    sltkuip.cdf
*
* type:      KUIP source code
*
* created:   24 Nov 2000
*	
* author:    Andreas Gellrich,  E-mail: Andreas.Gellrich@desy.de
*            Lars Soezueer <soezueer@mail.desy.de>
*
* purpose:   define KUIP commands for SLT
*
* hints:     
*
* changes:
* 24 Nov 2000 (AG) creation
* 16 Mar 2001 (LS) added Menu SIM with commands path, file and debuglevel
*
******************************************************************************

>NAME sltkuip
>Menu /SLT
>Guidance
Commands to steer SLT information

>Command FILL
>Guidance
switch on/off filling of table RSLA and RSLI
>Action SLTFILL
>Parameter
+
STAT 'status on/off' C  D='OFF'

>MENU SIM
>GUIDANCE
Commands for the simulation of the Second Level Trigger.

>COMMAND path
>PARAMETERS
NAME 'EDC path name' C
>GUIDANCE
Define the path to the EDC (Second Level Process Emulator) executable.
.
Must not contain the name of the executable itself.
Define that by the command SLT/SIM/file
Default is 
>ACTION slt_sim_path%C

>COMMAND file
>PARAMETERS
NAME 'EDC file name' C D='gut_emu'
>GUIDANCE
Define the file name of the EDC (Second Level Process Emulator) executable.
.
Must not contain the path to the executable.
Define that by the command SLT/SIM/path
>ACTION slt_sim_file%C

>COMMAND runnumber
>PARAMETERS
RUNNUMBER 'runnumber' I
>GUIDANCE
Set the number of the run, whose Second Level settings
(geometry, buffer map, trigger type and symbol table)
are given to the emulator.
>ACTION slt_sim_runnumber%C

>COMMAND debuglevel
>PARAMETERS
LEVEL 'EDC debug level' I D=0 R=0:3
>GUIDANCE
Set the debug level for the EDC (Second Level Process Emulator) process.
.
Possible values are:
  0 (default) No debug output, no error logger window.
  1           Error logger window, but no debug information.
  2           Error logger window, some debug information.
  3           Error logger window, lots of debug information.
>ACTION slt_sim_debuglevel%C
