!-----------------------------------------------------------------------
! Expectation Maximisation algorithm
! M. Staric, sep-2000, feb-2001
!
!-----------------------------------------------------------------------


      SUBROUTINE TEMA_ITER_HOR(KAJ,NGR,MAXNB,IX,NB,OK)

      INTEGER KAJ               ! 0=otr, 1=itr
      INTEGER NGR
      INTEGER MAXNB
      INTEGER IX(MAXNB), NB
      LOGICAL OK

#include "tema/TEMA_PAR.fi"
#include "tema/TEMA_HITS.fi"

      PARAMETER (NX=512)
      PARAMETER (NY=128)
      REAL HIST(0:NX*NY-1,0:1)
      INTEGER IHIST(0:NX*NY-1,0:1)
      EQUIVALENCE (HIST,IHIST)

      INTEGER NT
      INTEGER NTFI(MAXHIT)

      CALL TEMA_HOR_SINT(KAJ,NX,NY,MAXNB,IX,NB,NTFI,NT,OK)
      IF(.NOT.OK) RETURN
      IF(NB.EQ.0) RETURN

      NXY=NX*NY
      K0=0
      K1=1
      CALL VZERO(HIST(0,K0),NXY)
      DO I=1,NB
         K=IX(I)
         HIST(K,K0)=HIST(K,K0)+1.
      ENDDO
      DO ITER=1,NITER_HOR
         CALL VZERO(HIST(0,K1),NXY)
         J=1
         DO I=1,NT
            IF(NTFI(I).GE.0) THEN
               CALL TEMA_FILL_TOCKA(IX(J),NTFI(I),HIST(0,K0),HIST(0,K1),
     &              WMA(I),IK(I))
               J=J+NTFI(I)
            ENDIF
         ENDDO
         K0=K1
         K1=MOD(K0+1,2)
      ENDDO
      CALL VZERO(HIST(0,K1),NXY)
      DO I=1,NT
         IF(NTFI(I).GE.0) THEN
            IF(WMA(I).GT.WMA_MIN) THEN
               K=IK(I)
               IHIST(K,K1)=IHIST(K,K1)-1
            ENDIF
         ENDIF
      ENDDO

      CALL TEMA_GRUPIRAJ(IHIST(0,K1),NX,NY,NGR,OK)
      IF(.NOT.OK) RETURN
! rezultat:
      DO I=1,NT
         IF(NTFI(I).GE.0) THEN
            IF(WMA(I).GT.WMA_MIN) THEN
               K=IK(I)
               IK(I)=IHIST(K,K1)
            ELSE
               IK(I)=0
            ENDIF
         ENDIF
      ENDDO

      RETURN
      END



      SUBROUTINE TEMA_ITER_VERT(MAXNB,IX,NB,OK)

      INTEGER MAXNB
      INTEGER IX(MAXNB), NB
      LOGICAL OK

#include "tema/TEMA_PAR.fi"
#include "tema/TEMA_HITS.fi"
#include "tema/TEMA_HSEG.fi"
#include "tema/TEMA_RSEG.fi"

      PARAMETER (NX=64)
      PARAMETER (NY=1024)
      REAL HIST(0:NX*NY-1,0:1)
      INTEGER IHIST(0:NX*NY-1,0:1)
      EQUIVALENCE (HIST,IHIST)

      INTEGER NT
      INTEGER NTFI(MAXHIT)
      INTEGER IER1
      SAVE IER1

      CALL TEMA_VERT_SINT(NX,NY,MAXNB,IX,NB,NTFI,NT,OK)
      IF(.NOT.OK) RETURN
      IF(NB.EQ.0) RETURN

      NXY=NX*NN_HS
      K0=0
      K1=1
      CALL VZERO(HIST(0,K0),NXY)
      DO I=1,NB
         K=IX(I)
         HIST(K,K0)=HIST(K,K0)+1.
      ENDDO
      DO ITER=1,NITER_VER
         CALL VZERO(HIST(0,K1),NXY)
         J=1
         DO I=1,NT
            CALL TEMA_FILL_TOCKA(IX(J),NTFI(I),HIST(0,K0),HIST(0,K1),
     &           WMA(I),IK(I))
            J=J+NTFI(I)
         ENDDO
         K0=K1
         K1=MOD(K0+1,2)
      ENDDO

      CALL VZERO(HIST(0,K1),NXY)
      DO I=1,NT
         IF(WMA(I).GT.WMA_MIN) THEN
            K=IK(I)
            IHIST(K,K1)=IHIST(K,K1)-1
         ENDIF
      ENDDO

      NGR=0
      DO J=1,NN_HS
         IF(FIT_HS(J)) THEN
            II=(J-1)*NX
            NGR_OLD=NGR
            CALL TEMA_GRUPIRAJ(IHIST(II,K1),NX,1,NGR,OK)
            IF(.NOT.OK) RETURN
            DO IGR=NGR_OLD+1,MIN(NGR,MAXSEG)
               LHS_SEG(IGR)=J   ! rezultat
            ENDDO
         ENDIF
      ENDDO
      IF(NGR.GT.MAXSEG) THEN
         CALL MEPRIC(IER1,10,'TEMA: tema_iter_vert_, NGR > MAXSEG ')
      ENDIF
! rezultat:
      DO I=1,NT
         IF(WMA(I).GT.WMA_MIN) THEN
            K=IK(I)
            IK(I)=IHIST(K,K1)
         ELSE
            IK(I)=0
         ENDIF
      ENDDO

      RETURN
      END



      SUBROUTINE TEMA_HOR_SINT(KAJ,NX,NY,MAXNB,IX,NB,NTFI,NT,OK)

! horizontal sinogram index table

      INTEGER KAJ               ! 0=otr, 1=itr
      INTEGER NX, NY
      INTEGER MAXNB
      INTEGER IX(MAXNB), NB
      INTEGER NTFI(*), NT
      LOGICAL OK

#include "tema/TEMA_PAR.fi"
#include "tema/TEMA_HITS.fi"
#include "tema/TEMA_LAY.fi"

      PARAMETER (NNY=1024)
      REAL CFI(0:NNY-1), SFI(0:NNY-1)
      REAL X1(0:NNY-1), X2(0:NNY-1)
      REAL DX(0:1), DFI(0:1)
      DATA DX(0) /.87/, DFI(0) /10.E-3/ ! otr
      DATA DX(1) /.2/, DFI(1) /2.5E-3/  ! itr
      SAVE DX, DFI
      INTEGER IER1, IER2
      SAVE IER1, IER2

      OK=NY.LE.NNY
      IF(.NOT.OK) THEN
         CALL MEPRIC(IER1,100,'TEMA: tema_hor_sint_, NY > NNY (bug)')
         RETURN
      ENDIF

      DO I=0,NY-1
         FI=(I-NY/2.+.5)*DFI(KAJ)
         CFI(I)=COS(FI)
         SFI(I)=SIN(FI)
      ENDDO
      X_OFF=DX(KAJ)*NX/2.
      CALL TEMA_MEJE_RO(NX,NY,DX(KAJ),DFI(KAJ),X_OFF,X1,X2)

      NB=0
      DO I=1,NHIT(1)
         IF(KAJ.EQ.0.XOR.LAY(I).GT.NLAY_OTR) THEN
            NTFI(I)=0
            X0I=XHIT(I)
            Z0I=ZHIT(I)-Z_CENTER
            DO K=0,NY-1
               X=(X0I*CFI(K)-Z0I*SFI(K)+X_OFF)/DX(KAJ)
               IF(X.GE.X1(K).AND.X.LT.X2(K)) THEN
                  NB=NB+1
                  OK=NB.LE.MAXNB
                  IF(.NOT.OK) THEN
                     CALL MEPRIC(IER2,10,
     &                    'TEMA: tema_hor_sint_, out of memory')
                     RETURN
                  ENDIF
                  IX(NB)=IFIX(X)+K*NX
                  NTFI(I)=NTFI(I)+1
               ENDIF
            ENDDO
         ELSE
            NTFI(I)=-1
         ENDIF
      ENDDO
      NT=NHIT(1)

      RETURN
      END



      SUBROUTINE TEMA_MEJE_RO(NX,NY,DX,DFI,X_OFF,X1,X2)

      INTEGER NX, NY
      REAL DX, DFI, X_OFF
      REAL X1(0:NY-1), X2(0:NY-1)

      REAL X0(3) /-50.,25.,225./
      REAL FI0(3) /-.65,-.2,.2/
      SAVE X0, FI0

      K1=IFIX(FI0(2)/DFI+NY/2)
      XFI=(X0(2)-X0(1))/(FI0(2)-FI0(1))
      DO K=0,MIN(K1,NY-1)
         FI=(K-NY/2+.5)*DFI
         X2(K)=X0(2)+XFI*(FI-FI0(2))
         X1(NY-1-K)=-X2(K)
      ENDDO
      XFI=(X0(2)-X0(3))/(FI0(2)-FI0(3))
      DO K=K1+1,NY-1
         FI=(K-NY/2+.5)*DFI
         X2(K)=X0(2)+XFI*(FI-FI0(2))
         X1(NY-1-K)=-X2(K)
      ENDDO
      DO K=0,NY-1
         X1(K)=MAX((X1(K)+X_OFF)/DX,0)
         X2(K)=MIN((X2(K)+X_OFF)/DX,NX)
      ENDDO

      RETURN
      END



      SUBROUTINE TEMA_VERT_SINT(NX,NY,MAXNB,IX,NB,NTFI,NT,OK)

! vertical sinogram index table

      INTEGER NX, NY
      INTEGER MAXNB
      INTEGER IX(MAXNB), NB
      INTEGER NTFI(*), NT
      LOGICAL OK

#include "tema/TEMA_HITS.fi"
#include "tema/TEMA_HSEG.fi"

      REAL R1(3), DIR(3)
      REAL TY_MAX /.2/
      SAVE TY_MAX
      INTEGER IER1, IER2
      SAVE IER1, IER2

      OK=NN_HS.LE.NY
      IF(.NOT.OK) THEN
         CALL MEPRIC(IER1,100,'TEMA: tema_vert_sint_, NY > NN_HS (bug)')
         RETURN
      ENDIF

      DTY=2.*TY_MAX/NX
      NB=0
      DO I=1,NHIT(1)
         NTFI(I)=0
         DO J=1,NN_HS
            IF(.NOT.FIT_HS(J)) GOTO 1
            IF(J.NE.IK(I)) THEN
               CALL TEMA_PRO2DLINE(AA_HS(J),BB_HS(J),COV_HS(1,J),
     &              ZHIT(I),X,EX)
               DX2=(X-XHIT(I))**2/(SHIT(1,I)**2+EX)
               IF(DX2.GT.9) GOTO 1
            ENDIF
            K1=(YHIT(1,I)/ZHIT(I)+TY_MAX)/DTY
            K2=(YHIT(2,I)/ZHIT(I)+TY_MAX)/DTY+1.
            DO K=MAX(K1,0),MIN(K2,NX)-1
               NB=NB+1
               OK=NB.LE.MAXNB
               IF(.NOT.OK) THEN
                  CALL MEPRIC(IER2,10,
     &                 'TEMA: tema_vert_sint_, out of memory')
                  RETURN
               ENDIF
               IX(NB)=K+(J-1)*NX
               NTFI(I)=NTFI(I)+1
            ENDDO
 1          CONTINUE
         ENDDO
      ENDDO
      DO I=NHIT(1)+1,NHIT(2)
         NTFI(I)=0
         CALL TEMA_WIRE_VEC(I,R1,DIR)
         DO J=1,NN_HS
            IF(.NOT.FIT_HS(J)) GOTO 2
            SN=DIR(1)*VN_HS(1,J)+DIR(2)*VN_HS(2,J)+DIR(3)*VN_HS(3,J)
            IF(SN.EQ.0) GOTO 2
            PATH=0.
            DO II=1,3
               PATH=PATH+(R0_HS(II,J)-R1(II))*VN_HS(II,J)
            ENDDO
            PATH=PATH/SN
            IF(PATH.LT.0.OR.PATH.GT.1) GOTO 2
            TY=(R1(2)+PATH*DIR(2))/(R1(3)+PATH*DIR(3))
            K=(TY+TY_MAX)/DTY+1.
            IF(K.LT.1.OR.K.GT.NX) GOTO 2
            K=K-1
            NB=NB+1
            OK=NB.LE.MAXNB
            IF(.NOT.OK) THEN
               CALL MEPRIC(IER2,10,
     &              'TEMA: tema_vert_sint_, out of memory')
               RETURN
            ENDIF
            IX(NB)=K+(J-1)*NX
            NTFI(I)=NTFI(I)+1
 2          CONTINUE
         ENDDO
      ENDDO
      NT=NHIT(2)

      RETURN
      END



      SUBROUTINE TEMA_WIRE_VEC(I,R1,DR)

      INTEGER I                 ! hit index
      REAL R1(3), DR(3)         ! wire (r1=first point, dr=r2-r1)
#include "tema/TEMA_HITS.fi"

      DL=21.65*SHIT(1,I)        ! sqrt(12)/2/80e-3*sigma_cell
      Y1=YHIT(1,I)-DL
      Y2=YHIT(2,I)+DL
      R1(1)=XHIT(I)*C_ALFA(I)-Y1*S_ALFA(I)
      R1(2)=XHIT(I)*S_ALFA(I)+Y1*C_ALFA(I)
      R1(3)=ZHIT(I)
      YY=Y2-Y1
      DR(1)=-S_ALFA(I)*YY
      DR(2)=C_ALFA(I)*YY
      DR(3)=0.

      RETURN
      END



      SUBROUTINE TEMA_FILL_TOCKA(IX,N,HIST0,HIST1,WMA,KK)

      INTEGER IX(*), N
      REAL HIST0(0:*), HIST1(0:*)
      REAL WMA
      INTEGER KK

      WMA=0.
      KK=0
      S=0.
      DO K=1,N
         S=S+HIST0(IX(K))
      ENDDO
      IF(S.EQ.0) RETURN
      DO K=1,N
         W=HIST0(IX(K))/S
         IF(W.GT.WMA) THEN
            WMA=W
            KK=IX(K)
         ENDIF
         HIST1(IX(K))=HIST1(IX(K))+W
      ENDDO

      RETURN
      END



      SUBROUTINE TEMA_GRUPIRAJ(IHIST,NX,NY,NGR,OK)

      INTEGER IHIST(0:NX-1,0:NY-1)
      INTEGER NX, NY
      INTEGER NGR               ! reset it to 0, when needed
      LOGICAL OK

      PARAMETER (NSTA=1024)
      INTEGER STACK(2,NSTA)
      INTEGER ISTA
      INTEGER IER1
      SAVE IER1

      ISTA=0
      DO K=0,NY-1
         DO I=0,NX-1
            IF(IHIST(I,K).LT.0) THEN
               NGR=NGR+1
               IHIST(I,K)=NGR
               ISTA=ISTA+1
               IF(ISTA.GT.NSTA) GOTO 99
               STACK(1,ISTA)=I
               STACK(2,ISTA)=K
               DO WHILE(ISTA.GT.0)
                  I0=STACK(1,ISTA)
                  K0=STACK(2,ISTA)
                  ISTA=ISTA-1
                  DO KK=MAX(K0-1,0),MIN(K0+1,NY-1)
                     DO II=MAX(I0-1,0),MIN(I0+1,NX-1)
                        IF(IHIST(II,KK).LT.0) THEN
                           IHIST(II,KK)=NGR
                           ISTA=ISTA+1
                           IF(ISTA.GT.NSTA) GOTO 99
                           STACK(1,ISTA)=II
                           STACK(2,ISTA)=KK
                        ENDIF                        
                     ENDDO
                  ENDDO                  
               ENDDO               
            ENDIF
         ENDDO
      ENDDO
      OK=.TRUE.
      RETURN

 99   CONTINUE
      OK=.FALSE.
      CALL MEPRIC(IER1,10,'TEMA: tema_grupiraj_, stack overflow')
      RETURN
      END



      SUBROUTINE TEMA_SEGM_PROLONG(R0,SV,Z,R)

! prolongate segment --> point at z

      REAL R0(3), SV(3)         ! point (x,y,z), direction (tx,ty,1)
      REAL Z                    ! z coordinate
      REAL R(3)                 ! point at z

      R(1)=R0(1)+SV(1)*(Z-R0(3))
      R(2)=R0(2)+SV(2)*(Z-R0(3))
      R(3)=Z

      RETURN
      END



      SUBROUTINE TEMA_SEGM_SYST(SV,SMER_X,SMER_Y,SMER_Z)

      REAL SV(3)                ! segment direction (tx,ty,1)
      REAL SMER_X(3), SMER_Y(3), SMER_Z(3) ! normalised axis vectors

      D=SQRT(SV(1)**2+SV(2)**2+SV(3)**2)
      DO I=1,3
         SMER_Z(I)=SV(I)/D
      ENDDO
      D=SQRT(SMER_Z(1)**2+SMER_Z(3)**2)
      SMER_X(1)=SMER_Z(3)/D
      SMER_X(2)=0.
      SMER_X(3)=-SMER_Z(1)/D
      CALL VEKT_PROD(SMER_Z,SMER_X,SMER_Y)

      RETURN
      END



      SUBROUTINE TEMA_TO_SV(R0,RP,SX,SY,SZ,TX,TY)

      REAL R0(3)
      REAL RP(3), SX(3), SY(3), SZ(3)
      REAL TX, TY
      REAL R(3)
      REAL S_PROD

      DO I=1,3
         R(I)=R0(I)-RP(I)
      ENDDO
      X=S_PROD(R,SX)
      Y=S_PROD(R,SY)
      Z=S_PROD(R,SZ)
      TX=X/Z
      TY=Y/Z
      RETURN
      END


