// *****************************************************************************
//
// source:    L3_CovMatrix.hh
//
// type:      include file
//
// created:   06 Dec 1999
//
// authors:   Stefan Scharein, Ullrich Schwanke
//            HERA-B Collaboration
//            DESY Zeuthen
//            Platanenallee 6
//            D-15738 Zeuthen
//            Germany
//            email: scharein@ifh.de, schwanke@ifh.de
//
// changes:
//
// *****************************************************************************
#ifndef _L3_COVMATRIX_HH_
#define _L3_COVMATRIX_HH_
#include <CLHEP/Vector/ThreeVector.h>
#include <CLHEP/Matrix/Vector.h>

template<int dim> class L3_CovMatrix {
public:
  inline L3_CovMatrix();
  inline void clear();
  inline void print() const;
  inline int size() const;
  inline L3_CovMatrix&  operator=(const L3_CovMatrix& rhs);
  inline double& operator()(int,int);
  inline double get(int,int) const; 
  inline Hep3Vector operator*(const Hep3Vector &rhs) const;
  inline HepVector operator*(const HepVector &rhs) const;  
  inline L3_CovMatrix& operator*(double f);
  inline L3_CovMatrix& operator*=(double f);
  inline HepMatrix getHepMatrix() const;
private:
  double a[dim][dim];
};

#include "L3_CovMatrix.icc"
#endif
