
// ****************************************************************************
//
// source:    trdevn.C
//
// type:      source code
//
// created:   27 Oct 95
// updated:   19 Feb 99
//
// author:    Andreas Gellrich
//            HERA-B Collaboration
//            DESY Zeuthen
//            Platanenallee 6
//            D-15738 Zeuthen
//            Germany
//            email: Andreas.Gellrich@desy.de
//
// hints:     standard Arte usevnt function (see also usinit and usstop)
//
//
// *****************************************************************************


// standrad includes
#include <iostream.h>

// Arte includes
#include "arte/arte.hh"

#include "farm/farm.hh"
//
// make callable by Fortran and C
//
extern "C" {

  void trdres();
  void trd2hit(int, int, float);

//
// program code
// 
void
trdevn()
{
  // get record id of detector Dnnn
  int recid = 0;
  ARTE_get_recid_DTRD( &recid );

  // get list of FEDs for detector Dnnn
  const int max = 100;                 // maximal number of FED blocks
  ETB_fed feds[max];                   // array for FED blocks
  int n         = 0;                   // number of FED blocks
  ARTE_get_feds_DTRD( max, feds, &n ); // get FED blocks of detetcor Dnnn


  // loop over FED blocks
  for( int i=0; i<n; i++ ){
  
    trdres();

    int           l  = feds[i].hdr.length - sizeof(  SLB_SUBHDR );

    int khit = 0, lhit = 0, mhit=0, hit = 0;

    // loop over channels
    unsigned char *p = (unsigned char *) feds[i].data;
    for( int j=0; j<l; j++ ){
      unsigned char adc = *( p + j );
      //      if( ( adc != 0x00 ) && ( adc != 0xff ) ){ // sparsify)
      if( ( int(adc) > 0 ) && ( int(adc) < 255 ) ){ // sparsify)

/*	if( j < 16 ) 
	  {
	    cout << " This channel " << j << " is expected to be empty\n";
	    continue;
	  }*/

	float tdc = adc;

	// fill HITB bank from DTRD

	if(j>=112 && j<=127) {lhit++; hit = lhit;};
	if(j>=80 && j<=95) {khit++; hit = khit;};
	if(j>=96 && j<=111) {mhit++; hit = mhit;};

	if(j>=80 && j<=127) trd2hit(j, hit, tdc);

      }

   }

  }

} // void trdevn()

} // extern "C"
