#include "wax/Hit.hh"
#include "wax/RTRelation.hh"
#include <math.h>

//__________________________________________________________________
// waxHit
//
//
// Author: Wouter Hulsbergen
//__________________________________________________________________

float waxHit::fgDriftRadiusOffset=0 ;

#ifdef USE_ARTE
void
waxHit::AppendHITB(ArtePointerHITB hitb) {
  static waxRTRelation::RTResult rtresult ;
  if(fHITB.index()) {
    std::cout << "waxHit::AppendHITB(): Hit (" << fHITB.index() 
	 << ") already added !!" << std::endl ;
    return ;
  }
  fHITB=hitb ;
  HITB& hit = *hitb; 

  ArtePointer<GEDE> gede = GetGede() ;
  unsigned char mono = GetWireIndex()/32 ;
  unsigned char cell = GetWireIndex()%32 ;
  
  hit.z    = gede->zfw[mono] ;
  hit.x    = gede->xfw[mono] + cell*gede->pit ;
  hit.y    = GetTdcCount() ;
  rtresult = GetRTRelation()->GetRTResultFromT(GetDriftTime()) ;
  hit.q    = GetDriftRadiusOffset() + rtresult.fR ;
  float r_rt = rtresult.fSigmaR ; // error estimated by rtcalibration
  //float r_t0 = -fChannel->GetTZeroErr()*rtresult.fdRdT ; // error in t0
  //hit.r    = sqrt(r_rt*r_rt + r_t0*r_t0) ;
  hit.r    = r_rt ; // it doesn't really make any difference.
  hit.gede = gede ;
  hit.chid = GetCHID(GetWireIndex(),GetAsdIndex(),GetChannelIndex()) ;
}

ArtePointerHITB
waxHit::AppendHITB() {
  if(fHITB.index()) {
    std::cout << "waxHit::AppendHITB(): Hit (" << fHITB.index() 
	 << ") already added !!" << std::endl ;
    return fHITB ;
  }
  
  HITB hitb ;
  fHITB = ArteTable<HITB>::push_back(hitb);
  AppendHITB(fHITB) ;
  return fHITB ;
}

ArtePointer<DIGB> waxHit::GetDIGB() const
{
  ArtePointer<DIGB> digb(0) ;
  ArtePointer<HITB> hitb = GetHITB() ;
  if(hitb.index()>0)
    for(ArteRelationIterator<DIGB> digbIt=hitb->digb.begin() ;
	digbIt!=hitb->digb.end() ; digbIt++) 
      if(fabs((*digbIt)->q - hitb->q) < 0.001) {
	digb = digbIt ;
	break ;
      }
  return digb ;
}

#endif
